#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTNamed.h"
#include "HROOTTAttAxis.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TAXIS_DECLARATIONVIRT
#define ROOT_TAXIS_DECLARATIONVIRT(Type) \
int  Type ## _findBinTAxis ( Type ## _p p, double x ); \
int  Type ## _findFixBinTAxis ( Type ## _p p, double x ); \
double Type ## _getBinCenterTAxis ( Type ## _p p, int  bin ); \
double Type ## _GetBinCenterLog ( Type ## _p p, int  bin ); \
double Type ## _GetBinUpEdge ( Type ## _p p, int  bin ); \
void Type ## _SetTimeDisplay ( Type ## _p p, int  value ); \
void Type ## _SetTimeFormat ( Type ## _p p, const char * format ); \
void Type ## _SetTimeOffset ( Type ## _p p, double toffset, const char * option )

#undef ROOT_TAXIS_DECLARATIONNONVIRT
#define ROOT_TAXIS_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTAxis ( int  nbins, double xmin, double xmax ); \
int Type ## _tAxisGetCenterLabels ( Type ## _p p ); \
int Type ## _tAxisGetCenterTitle ( Type ## _p p )

#undef ROOT_TAXIS_DEFINITIONVIRT
#define ROOT_TAXIS_DEFINITIONVIRT(Type)\
int  Type ## _findBinTAxis ( Type ## _p p, double x )\
{\
return to_nonconst<Type,Type ## _t>(p)->FindBin(x);\
}\
int  Type ## _findFixBinTAxis ( Type ## _p p, double x )\
{\
return to_nonconst<Type,Type ## _t>(p)->FindFixBin(x);\
}\
double Type ## _getBinCenterTAxis ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetBinCenter(bin);\
}\
double Type ## _GetBinCenterLog ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetBinCenterLog(bin);\
}\
double Type ## _GetBinUpEdge ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetBinUpEdge(bin);\
}\
void Type ## _SetTimeDisplay ( Type ## _p p, int  value )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTimeDisplay(value);\
}\
void Type ## _SetTimeFormat ( Type ## _p p, const char * format )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTimeFormat(format);\
}\
void Type ## _SetTimeOffset ( Type ## _p p, double toffset, const char * option )\
{\
to_nonconst<Type,Type ## _t>(p)->SetTimeOffset(toffset, option);\
}

#undef ROOT_TAXIS_DEFINITIONNONVIRT
#define ROOT_TAXIS_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTAxis ( int  nbins, double xmin, double xmax )\
{\
Type * newp = new Type (nbins, xmin, xmax); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
int Type ## _tAxisGetCenterLabels ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetCenterLabels();\
}\
int Type ## _tAxisGetCenterTitle ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetCenterTitle();\
}

ROOT_TNAMED_DECLARATIONVIRT(TAxis);
ROOT_TATTAXIS_DECLARATIONVIRT(TAxis);
ROOT_TOBJECT_DECLARATIONVIRT(TAxis);
ROOT_DELETABLE_DECLARATIONVIRT(TAxis);


ROOT_TAXIS_DECLARATIONVIRT(TAxis);


ROOT_TAXIS_DECLARATIONNONVIRT(TAxis);


#ifdef __cplusplus
}
#endif
