#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTFormula.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTNamed.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TF1_DECLARATIONVIRT
#define ROOT_TF1_DECLARATIONVIRT(Type) \
double Type ## _Derivative ( Type ## _p p, double x, double * params, double epsilon ); \
double Type ## _Derivative2 ( Type ## _p p, double x, double * params, double epsilon ); \
double Type ## _Derivative3 ( Type ## _p p, double x, double * params, double epsilon ); \
Type ## _p Type ## _drawCopyTF1 ( Type ## _p p, const char * option ); \
TObject_p Type ## _DrawDerivative ( Type ## _p p, const char * option ); \
TObject_p Type ## _DrawIntegral ( Type ## _p p, const char * option ); \
void Type ## _DrawF1 ( Type ## _p p, const char * formula, double xmin, double xmax, const char * option ); \
void Type ## _FixParameter ( Type ## _p p, int  ipar, double value ); \
double Type ## _getMaximumTF1 ( Type ## _p p, double xmin, double xmax, double epsilon, double maxiter, int logx ); \
double Type ## _getMinimumTF1 ( Type ## _p p, double xmin, double xmax, double epsilon, double maxiter, int logx ); \
double Type ## _GetMaximumX ( Type ## _p p, double xmin, double xmax, double epsilon, double maxiter, int logx ); \
double Type ## _GetMinimumX ( Type ## _p p, double xmin, double xmax, double epsilon, double maxiter, int logx ); \
int  Type ## _GetNDF ( Type ## _p p ); \
int  Type ## _GetNpx ( Type ## _p p ); \
int  Type ## _GetNumberFreeParameters ( Type ## _p p ); \
int  Type ## _GetNumberFitPoints ( Type ## _p p ); \
double Type ## _GetParError ( Type ## _p p, int  ipar ); \
double Type ## _GetProb ( Type ## _p p ); \
int  Type ## _getQuantilesTF1 ( Type ## _p p, int  nprobSum, double * q, double * probSum ); \
double Type ## _getRandomTF1 ( Type ## _p p, double xmin, double xmax ); \
double Type ## _GetSave ( Type ## _p p, double * x ); \
double Type ## _GetX ( Type ## _p p, double y, double xmin, double xmax, double epsilon, int  maxiter ); \
double Type ## _GetXmin ( Type ## _p p ); \
double Type ## _GetXmax ( Type ## _p p ); \
double Type ## _GradientPar ( Type ## _p p, int  ipar, double * x, double eps ); \
void Type ## _InitArgs ( Type ## _p p, double * x, double * params ); \
double Type ## _IntegralTF1 ( Type ## _p p, double a, double b, double * params, double epsilon ); \
double Type ## _IntegralError ( Type ## _p p, double a, double b, double * params, double * covmat, double epsilon ); \
double Type ## _IntegralFast ( Type ## _p p, int  num, double * x, double * w, double a, double b, double * params, double epsilon ); \
int Type ## _IsInside ( Type ## _p p, double * x ); \
void Type ## _ReleaseParameter ( Type ## _p p, int  ipar ); \
void Type ## _SetChisquare ( Type ## _p p, double chi2 ); \
void Type ## _setMaximumTF1 ( Type ## _p p, double maximum ); \
void Type ## _setMinimumTF1 ( Type ## _p p, double minimum ); \
void Type ## _SetNDF ( Type ## _p p, int  ndf ); \
void Type ## _SetNumberFitPoints ( Type ## _p p, int  npfits ); \
void Type ## _SetNpx ( Type ## _p p, int  npx ); \
void Type ## _SetParError ( Type ## _p p, int  ipar, double error ); \
void Type ## _SetParErrors ( Type ## _p p, double * errors ); \
void Type ## _SetParLimits ( Type ## _p p, int  ipar, double parmin, double parmax ); \
void Type ## _SetParent ( Type ## _p p, TObject_p parent ); \
void Type ## _setRange1 ( Type ## _p p, double xmin, double xmax ); \
void Type ## _setRange2 ( Type ## _p p, double xmin, double xmax, double ymin, double ymax ); \
void Type ## _setRange3 ( Type ## _p p, double xmin, double xmax, double ymin, double ymax, double zmin, double zmax ); \
void Type ## _SetSavedPoint ( Type ## _p p, int  point, double value ); \
double Type ## _Moment ( Type ## _p p, double n, double a, double b, double * params, double epsilon ); \
double Type ## _CentralMoment ( Type ## _p p, double n, double a, double b, double * params, double epsilon ); \
double Type ## _Mean ( Type ## _p p, double a, double b, double * params, double epsilon ); \
double Type ## _Variance ( Type ## _p p, double a, double b, double * params, double epsilon )

#undef ROOT_TF1_DECLARATIONNONVIRT
#define ROOT_TF1_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTF1 ( const char * name, const char * formula, double xmin, double xmax ); \
double Type ## _tF1GetChisquare ( Type ## _p p ); \
TH1_p Type ## _tF1GetHistogram ( Type ## _p p ); \
TObject_p Type ## _tF1GetParent ( Type ## _p p ); \
TAxis_p Type ## _tF1GetXaxis ( Type ## _p p ); \
TAxis_p Type ## _tF1GetYaxis ( Type ## _p p ); \
TAxis_p Type ## _tF1GetZaxis ( Type ## _p p )

#undef ROOT_TF1_DEFINITIONVIRT
#define ROOT_TF1_DEFINITIONVIRT(Type)\
double Type ## _Derivative ( Type ## _p p, double x, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->Derivative(x, params, epsilon);\
}\
double Type ## _Derivative2 ( Type ## _p p, double x, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->Derivative2(x, params, epsilon);\
}\
double Type ## _Derivative3 ( Type ## _p p, double x, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->Derivative3(x, params, epsilon);\
}\
Type ## _p Type ## _drawCopyTF1 ( Type ## _p p, const char * option )\
{\
return to_nonconst<Type ## _t, Type>((Type *)to_nonconst<Type,Type ## _t>(p)->DrawCopy(option)) ;\
}\
TObject_p Type ## _DrawDerivative ( Type ## _p p, const char * option )\
{\
return to_nonconst<TObject_t,TObject>((TObject*)to_nonconst<Type,Type ## _t>(p)->DrawDerivative(option));\
}\
TObject_p Type ## _DrawIntegral ( Type ## _p p, const char * option )\
{\
return to_nonconst<TObject_t,TObject>((TObject*)to_nonconst<Type,Type ## _t>(p)->DrawIntegral(option));\
}\
void Type ## _DrawF1 ( Type ## _p p, const char * formula, double xmin, double xmax, const char * option )\
{\
to_nonconst<Type,Type ## _t>(p)->DrawF1(formula, xmin, xmax, option);\
}\
void Type ## _FixParameter ( Type ## _p p, int  ipar, double value )\
{\
to_nonconst<Type,Type ## _t>(p)->FixParameter(ipar, value);\
}\
double Type ## _getMaximumTF1 ( Type ## _p p, double xmin, double xmax, double epsilon, double maxiter, int logx )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMaximum(xmin, xmax, epsilon, maxiter, logx);\
}\
double Type ## _getMinimumTF1 ( Type ## _p p, double xmin, double xmax, double epsilon, double maxiter, int logx )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMinimum(xmin, xmax, epsilon, maxiter, logx);\
}\
double Type ## _GetMaximumX ( Type ## _p p, double xmin, double xmax, double epsilon, double maxiter, int logx )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMaximumX(xmin, xmax, epsilon, maxiter, logx);\
}\
double Type ## _GetMinimumX ( Type ## _p p, double xmin, double xmax, double epsilon, double maxiter, int logx )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMinimumX(xmin, xmax, epsilon, maxiter, logx);\
}\
int  Type ## _GetNDF ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetNDF();\
}\
int  Type ## _GetNpx ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetNpx();\
}\
int  Type ## _GetNumberFreeParameters ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetNumberFreeParameters();\
}\
int  Type ## _GetNumberFitPoints ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetNumberFitPoints();\
}\
double Type ## _GetParError ( Type ## _p p, int  ipar )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetParError(ipar);\
}\
double Type ## _GetProb ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetProb();\
}\
int  Type ## _getQuantilesTF1 ( Type ## _p p, int  nprobSum, double * q, double * probSum )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetQuantiles(nprobSum, q, probSum);\
}\
double Type ## _getRandomTF1 ( Type ## _p p, double xmin, double xmax )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetRandom(xmin, xmax);\
}\
double Type ## _GetSave ( Type ## _p p, double * x )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetSave(x);\
}\
double Type ## _GetX ( Type ## _p p, double y, double xmin, double xmax, double epsilon, int  maxiter )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetX(y, xmin, xmax, epsilon, maxiter);\
}\
double Type ## _GetXmin ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetXmin();\
}\
double Type ## _GetXmax ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetXmax();\
}\
double Type ## _GradientPar ( Type ## _p p, int  ipar, double * x, double eps )\
{\
return to_nonconst<Type,Type ## _t>(p)->GradientPar(ipar, x, eps);\
}\
void Type ## _InitArgs ( Type ## _p p, double * x, double * params )\
{\
to_nonconst<Type,Type ## _t>(p)->InitArgs(x, params);\
}\
double Type ## _IntegralTF1 ( Type ## _p p, double a, double b, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->Integral(a, b, params, epsilon);\
}\
double Type ## _IntegralError ( Type ## _p p, double a, double b, double * params, double * covmat, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->IntegralError(a, b, params, covmat, epsilon);\
}\
double Type ## _IntegralFast ( Type ## _p p, int  num, double * x, double * w, double a, double b, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->IntegralFast(num, x, w, a, b, params, epsilon);\
}\
int Type ## _IsInside ( Type ## _p p, double * x )\
{\
return to_nonconst<Type,Type ## _t>(p)->IsInside(x);\
}\
void Type ## _ReleaseParameter ( Type ## _p p, int  ipar )\
{\
to_nonconst<Type,Type ## _t>(p)->ReleaseParameter(ipar);\
}\
void Type ## _SetChisquare ( Type ## _p p, double chi2 )\
{\
to_nonconst<Type,Type ## _t>(p)->SetChisquare(chi2);\
}\
void Type ## _setMaximumTF1 ( Type ## _p p, double maximum )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMaximum(maximum);\
}\
void Type ## _setMinimumTF1 ( Type ## _p p, double minimum )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMinimum(minimum);\
}\
void Type ## _SetNDF ( Type ## _p p, int  ndf )\
{\
to_nonconst<Type,Type ## _t>(p)->SetNDF(ndf);\
}\
void Type ## _SetNumberFitPoints ( Type ## _p p, int  npfits )\
{\
to_nonconst<Type,Type ## _t>(p)->SetNumberFitPoints(npfits);\
}\
void Type ## _SetNpx ( Type ## _p p, int  npx )\
{\
to_nonconst<Type,Type ## _t>(p)->SetNpx(npx);\
}\
void Type ## _SetParError ( Type ## _p p, int  ipar, double error )\
{\
to_nonconst<Type,Type ## _t>(p)->SetParError(ipar, error);\
}\
void Type ## _SetParErrors ( Type ## _p p, double * errors )\
{\
to_nonconst<Type,Type ## _t>(p)->SetParErrors(errors);\
}\
void Type ## _SetParLimits ( Type ## _p p, int  ipar, double parmin, double parmax )\
{\
to_nonconst<Type,Type ## _t>(p)->SetParLimits(ipar, parmin, parmax);\
}\
void Type ## _SetParent ( Type ## _p p, TObject_p parent )\
{\
to_nonconst<Type,Type ## _t>(p)->SetParent(to_nonconst<TObject,TObject_t>(parent));\
}\
void Type ## _setRange1 ( Type ## _p p, double xmin, double xmax )\
{\
to_nonconst<Type,Type ## _t>(p)->SetRange(xmin, xmax);\
}\
void Type ## _setRange2 ( Type ## _p p, double xmin, double xmax, double ymin, double ymax )\
{\
to_nonconst<Type,Type ## _t>(p)->SetRange(xmin, xmax, ymin, ymax);\
}\
void Type ## _setRange3 ( Type ## _p p, double xmin, double xmax, double ymin, double ymax, double zmin, double zmax )\
{\
to_nonconst<Type,Type ## _t>(p)->SetRange(xmin, xmax, ymin, ymax, zmin, zmax);\
}\
void Type ## _SetSavedPoint ( Type ## _p p, int  point, double value )\
{\
to_nonconst<Type,Type ## _t>(p)->SetSavedPoint(point, value);\
}\
double Type ## _Moment ( Type ## _p p, double n, double a, double b, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->Moment(n, a, b, params, epsilon);\
}\
double Type ## _CentralMoment ( Type ## _p p, double n, double a, double b, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->CentralMoment(n, a, b, params, epsilon);\
}\
double Type ## _Mean ( Type ## _p p, double a, double b, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->Mean(a, b, params, epsilon);\
}\
double Type ## _Variance ( Type ## _p p, double a, double b, double * params, double epsilon )\
{\
return to_nonconst<Type,Type ## _t>(p)->Variance(a, b, params, epsilon);\
}

#undef ROOT_TF1_DEFINITIONNONVIRT
#define ROOT_TF1_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTF1 ( const char * name, const char * formula, double xmin, double xmax )\
{\
Type * newp = new Type (name, formula, xmin, xmax); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
double Type ## _tF1GetChisquare ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetChisquare();\
}\
TH1_p Type ## _tF1GetHistogram ( Type ## _p p )\
{\
return to_nonconst<TH1_t,TH1>((TH1*)to_nonconst<Type,Type ## _t>(p)->GetHistogram());\
}\
TObject_p Type ## _tF1GetParent ( Type ## _p p )\
{\
return to_nonconst<TObject_t,TObject>((TObject*)to_nonconst<Type,Type ## _t>(p)->GetParent());\
}\
TAxis_p Type ## _tF1GetXaxis ( Type ## _p p )\
{\
return to_nonconst<TAxis_t,TAxis>((TAxis*)to_nonconst<Type,Type ## _t>(p)->GetXaxis());\
}\
TAxis_p Type ## _tF1GetYaxis ( Type ## _p p )\
{\
return to_nonconst<TAxis_t,TAxis>((TAxis*)to_nonconst<Type,Type ## _t>(p)->GetYaxis());\
}\
TAxis_p Type ## _tF1GetZaxis ( Type ## _p p )\
{\
return to_nonconst<TAxis_t,TAxis>((TAxis*)to_nonconst<Type,Type ## _t>(p)->GetZaxis());\
}

ROOT_TFORMULA_DECLARATIONVIRT(TF1);
ROOT_TATTLINE_DECLARATIONVIRT(TF1);
ROOT_TATTFILL_DECLARATIONVIRT(TF1);
ROOT_TATTMARKER_DECLARATIONVIRT(TF1);
ROOT_TNAMED_DECLARATIONVIRT(TF1);
ROOT_TOBJECT_DECLARATIONVIRT(TF1);
ROOT_DELETABLE_DECLARATIONVIRT(TF1);


ROOT_TF1_DECLARATIONVIRT(TF1);


ROOT_TF1_DECLARATIONNONVIRT(TF1);


#ifdef __cplusplus
}
#endif
