#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TGRAPH_DECLARATIONVIRT
#define ROOT_TGRAPH_DECLARATIONVIRT(Type) \
void Type ## _Apply ( Type ## _p p, TF1_p f ); \
double Type ## _Chisquare ( Type ## _p p, TF1_p f1 ); \
void Type ## _DrawGraph ( Type ## _p p, int  n, double * x, double * y, const char * option ); \
void Type ## _drawPanelTGraph ( Type ## _p p ); \
void Type ## _Expand ( Type ## _p p, int  newsize, int  step ); \
void Type ## _FitPanelTGraph ( Type ## _p p ); \
double Type ## _getCorrelationFactorTGraph ( Type ## _p p ); \
double Type ## _getCovarianceTGraph ( Type ## _p p ); \
double Type ## _getMeanTGraph ( Type ## _p p, int  axis ); \
double Type ## _getRMSTGraph ( Type ## _p p, int  axis ); \
double Type ## _GetErrorX ( Type ## _p p, int  bin ); \
double Type ## _GetErrorY ( Type ## _p p, int  bin ); \
double Type ## _GetErrorXhigh ( Type ## _p p, int  bin ); \
double Type ## _GetErrorXlow ( Type ## _p p, int  bin ); \
double Type ## _GetErrorYhigh ( Type ## _p p, int  bin ); \
double Type ## _GetErrorYlow ( Type ## _p p, int  bin ); \
void Type ## _InitExpo ( Type ## _p p, double xmin, double xmax ); \
void Type ## _InitGaus ( Type ## _p p, double xmin, double xmax ); \
void Type ## _InitPolynom ( Type ## _p p, double xmin, double xmax ); \
int  Type ## _InsertPoint ( Type ## _p p ); \
double Type ## _integralTGraph ( Type ## _p p, int  first, int  last ); \
int Type ## _IsEditable ( Type ## _p p ); \
int  Type ## _isInsideTGraph ( Type ## _p p, double x, double y ); \
void Type ## _LeastSquareFit ( Type ## _p p, int  m, double * a, double xmin, double xmax ); \
void Type ## _PaintStats ( Type ## _p p, TF1_p fit ); \
int  Type ## _RemovePoint ( Type ## _p p, int  ipoint ); \
void Type ## _SetEditable ( Type ## _p p, int editable ); \
void Type ## _SetHistogram ( Type ## _p p, TH1F_p h ); \
void Type ## _setMaximumTGraph ( Type ## _p p, double maximum ); \
void Type ## _setMinimumTGraph ( Type ## _p p, double minimum ); \
void Type ## _Set ( Type ## _p p, int  n ); \
void Type ## _SetPoint ( Type ## _p p, int  i, double x, double y )

#undef ROOT_TGRAPH_DECLARATIONNONVIRT
#define ROOT_TGRAPH_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTGraph ( int  n, double * x, double * y ); \
int Type ## _tGraphGetEditable ( Type ## _p p ); \
TF1_p Type ## _tGraphGetFunction ( Type ## _p p, const char * name ); \
TH1F_p Type ## _tGraphGetHistogram ( Type ## _p p ); \
TList_p Type ## _tGraphGetListOfFunctions ( Type ## _p p ); \
int  Type ## _tGraphGetMaxSize ( Type ## _p p ); \
int  Type ## _tGraphGetN ( Type ## _p p ); \
double Type ## _tGraphGetMaximum ( Type ## _p p ); \
double Type ## _tGraphGetMinimum ( Type ## _p p ); \
TAxis_p Type ## _tGraphGetXaxis ( Type ## _p p ); \
TAxis_p Type ## _tGraphGetYaxis ( Type ## _p p ); \
void Type ## _tGraphPaintGraph ( Type ## _p p, int  npoints, double * x, double * y, const char * chopt ); \
void Type ## _tGraphPaintGrapHist ( Type ## _p p, int  npoints, double * x, double * y, const char * chopt )

#undef ROOT_TGRAPH_DEFINITIONVIRT
#define ROOT_TGRAPH_DEFINITIONVIRT(Type)\
void Type ## _Apply ( Type ## _p p, TF1_p f )\
{\
to_nonconst<Type,Type ## _t>(p)->Apply(to_nonconst<TF1,TF1_t>(f));\
}\
double Type ## _Chisquare ( Type ## _p p, TF1_p f1 )\
{\
return to_nonconst<Type,Type ## _t>(p)->Chisquare(to_nonconst<TF1,TF1_t>(f1));\
}\
void Type ## _DrawGraph ( Type ## _p p, int  n, double * x, double * y, const char * option )\
{\
to_nonconst<Type,Type ## _t>(p)->DrawGraph(n, x, y, option);\
}\
void Type ## _drawPanelTGraph ( Type ## _p p )\
{\
to_nonconst<Type,Type ## _t>(p)->DrawPanel();\
}\
void Type ## _Expand ( Type ## _p p, int  newsize, int  step )\
{\
to_nonconst<Type,Type ## _t>(p)->Expand(newsize, step);\
}\
void Type ## _FitPanelTGraph ( Type ## _p p )\
{\
to_nonconst<Type,Type ## _t>(p)->FitPanel();\
}\
double Type ## _getCorrelationFactorTGraph ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetCorrelationFactor();\
}\
double Type ## _getCovarianceTGraph ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetCovariance();\
}\
double Type ## _getMeanTGraph ( Type ## _p p, int  axis )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMean(axis);\
}\
double Type ## _getRMSTGraph ( Type ## _p p, int  axis )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetRMS(axis);\
}\
double Type ## _GetErrorX ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetErrorX(bin);\
}\
double Type ## _GetErrorY ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetErrorY(bin);\
}\
double Type ## _GetErrorXhigh ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetErrorXhigh(bin);\
}\
double Type ## _GetErrorXlow ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetErrorXlow(bin);\
}\
double Type ## _GetErrorYhigh ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetErrorYhigh(bin);\
}\
double Type ## _GetErrorYlow ( Type ## _p p, int  bin )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetErrorYlow(bin);\
}\
void Type ## _InitExpo ( Type ## _p p, double xmin, double xmax )\
{\
to_nonconst<Type,Type ## _t>(p)->InitExpo(xmin, xmax);\
}\
void Type ## _InitGaus ( Type ## _p p, double xmin, double xmax )\
{\
to_nonconst<Type,Type ## _t>(p)->InitGaus(xmin, xmax);\
}\
void Type ## _InitPolynom ( Type ## _p p, double xmin, double xmax )\
{\
to_nonconst<Type,Type ## _t>(p)->InitPolynom(xmin, xmax);\
}\
int  Type ## _InsertPoint ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->InsertPoint();\
}\
double Type ## _integralTGraph ( Type ## _p p, int  first, int  last )\
{\
return to_nonconst<Type,Type ## _t>(p)->Integral(first, last);\
}\
int Type ## _IsEditable ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->IsEditable();\
}\
int  Type ## _isInsideTGraph ( Type ## _p p, double x, double y )\
{\
return to_nonconst<Type,Type ## _t>(p)->IsInside(x, y);\
}\
void Type ## _LeastSquareFit ( Type ## _p p, int  m, double * a, double xmin, double xmax )\
{\
to_nonconst<Type,Type ## _t>(p)->LeastSquareFit(m, a, xmin, xmax);\
}\
void Type ## _PaintStats ( Type ## _p p, TF1_p fit )\
{\
to_nonconst<Type,Type ## _t>(p)->PaintStats(to_nonconst<TF1,TF1_t>(fit));\
}\
int  Type ## _RemovePoint ( Type ## _p p, int  ipoint )\
{\
return to_nonconst<Type,Type ## _t>(p)->RemovePoint(ipoint);\
}\
void Type ## _SetEditable ( Type ## _p p, int editable )\
{\
to_nonconst<Type,Type ## _t>(p)->SetEditable(editable);\
}\
void Type ## _SetHistogram ( Type ## _p p, TH1F_p h )\
{\
to_nonconst<Type,Type ## _t>(p)->SetHistogram(to_nonconst<TH1F,TH1F_t>(h));\
}\
void Type ## _setMaximumTGraph ( Type ## _p p, double maximum )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMaximum(maximum);\
}\
void Type ## _setMinimumTGraph ( Type ## _p p, double minimum )\
{\
to_nonconst<Type,Type ## _t>(p)->SetMinimum(minimum);\
}\
void Type ## _Set ( Type ## _p p, int  n )\
{\
to_nonconst<Type,Type ## _t>(p)->Set(n);\
}\
void Type ## _SetPoint ( Type ## _p p, int  i, double x, double y )\
{\
to_nonconst<Type,Type ## _t>(p)->SetPoint(i, x, y);\
}

#undef ROOT_TGRAPH_DEFINITIONNONVIRT
#define ROOT_TGRAPH_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTGraph ( int  n, double * x, double * y )\
{\
Type * newp = new Type (n, x, y); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
int Type ## _tGraphGetEditable ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetEditable();\
}\
TF1_p Type ## _tGraphGetFunction ( Type ## _p p, const char * name )\
{\
return to_nonconst<TF1_t,TF1>((TF1*)to_nonconst<Type,Type ## _t>(p)->GetFunction(name));\
}\
TH1F_p Type ## _tGraphGetHistogram ( Type ## _p p )\
{\
return to_nonconst<TH1F_t,TH1F>((TH1F*)to_nonconst<Type,Type ## _t>(p)->GetHistogram());\
}\
TList_p Type ## _tGraphGetListOfFunctions ( Type ## _p p )\
{\
return to_nonconst<TList_t,TList>((TList*)to_nonconst<Type,Type ## _t>(p)->GetListOfFunctions());\
}\
int  Type ## _tGraphGetMaxSize ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMaxSize();\
}\
int  Type ## _tGraphGetN ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetN();\
}\
double Type ## _tGraphGetMaximum ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMaximum();\
}\
double Type ## _tGraphGetMinimum ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetMinimum();\
}\
TAxis_p Type ## _tGraphGetXaxis ( Type ## _p p )\
{\
return to_nonconst<TAxis_t,TAxis>((TAxis*)to_nonconst<Type,Type ## _t>(p)->GetXaxis());\
}\
TAxis_p Type ## _tGraphGetYaxis ( Type ## _p p )\
{\
return to_nonconst<TAxis_t,TAxis>((TAxis*)to_nonconst<Type,Type ## _t>(p)->GetYaxis());\
}\
void Type ## _tGraphPaintGraph ( Type ## _p p, int  npoints, double * x, double * y, const char * chopt )\
{\
to_nonconst<Type,Type ## _t>(p)->PaintGraph(npoints, x, y, chopt);\
}\
void Type ## _tGraphPaintGrapHist ( Type ## _p p, int  npoints, double * x, double * y, const char * chopt )\
{\
to_nonconst<Type,Type ## _t>(p)->PaintGrapHist(npoints, x, y, chopt);\
}

ROOT_TNAMED_DECLARATIONVIRT(TGraph);
ROOT_TATTLINE_DECLARATIONVIRT(TGraph);
ROOT_TATTFILL_DECLARATIONVIRT(TGraph);
ROOT_TATTMARKER_DECLARATIONVIRT(TGraph);
ROOT_TOBJECT_DECLARATIONVIRT(TGraph);
ROOT_DELETABLE_DECLARATIONVIRT(TGraph);


ROOT_TGRAPH_DECLARATIONVIRT(TGraph);


ROOT_TGRAPH_DECLARATIONNONVIRT(TGraph);


#ifdef __cplusplus
}
#endif
