#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTH1.h"
#include "HROOTTAtt3D.h"
#include "HROOTTNamed.h"
#include "HROOTTAttLine.h"
#include "HROOTTAttFill.h"
#include "HROOTTAttMarker.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TH3_DECLARATIONVIRT
#define ROOT_TH3_DECLARATIONVIRT(Type) \
int  Type ## _fill3 ( Type ## _p p, double x, double y, double z ); \
int  Type ## _fill3w ( Type ## _p p, double x, double y, double z, double w ); \
void Type ## _FitSlicesZ ( Type ## _p p, TF1_p f1, int  binminx, int  binmaxx, int  binminy, int  binmaxy, int  cut, const char * option ); \
double Type ## _getCorrelationFactor3 ( Type ## _p p, int  axis1, int  axis2 ); \
double Type ## _getCovariance3 ( Type ## _p p, int  axis1, int  axis2 ); \
TH3_p Type ## _rebinX3 ( Type ## _p p, int  ngroup, const char * newname ); \
TH3_p Type ## _rebinY3 ( Type ## _p p, int  ngroup, const char * newname ); \
TH3_p Type ## _rebinZ3 ( Type ## _p p, int  ngroup, const char * newname ); \
TH3_p Type ## _Rebin3D ( Type ## _p p, int  nxgroup, int  nygroup, int  nzgroup, const char * newname )

#undef ROOT_TH3_DECLARATIONNONVIRT
#define ROOT_TH3_DECLARATIONNONVIRT(Type) \
TH1D_p Type ## _tH3ProjectionX ( Type ## _p p, const char * name, int  firstybin, int  lastybin, int  firstzbin, int  lastzbin, const char * option ); \
TH1D_p Type ## _tH3ProjectionY ( Type ## _p p, const char * name, int  firstxbin, int  lastxbin, int  firstzbin, int  lastzbin, const char * option ); \
TH1D_p Type ## _tH3ProjectionZ ( Type ## _p p, const char * name, int  firstxbin, int  lastxbin, int  firstybin, int  lastybin, const char * option ); \
TH1_p Type ## _tH3Project3D ( Type ## _p p, const char * option )

#undef ROOT_TH3_DEFINITIONVIRT
#define ROOT_TH3_DEFINITIONVIRT(Type)\
int  Type ## _fill3 ( Type ## _p p, double x, double y, double z )\
{\
return to_nonconst<Type,Type ## _t>(p)->Fill(x, y, z);\
}\
int  Type ## _fill3w ( Type ## _p p, double x, double y, double z, double w )\
{\
return to_nonconst<Type,Type ## _t>(p)->Fill(x, y, z, w);\
}\
void Type ## _FitSlicesZ ( Type ## _p p, TF1_p f1, int  binminx, int  binmaxx, int  binminy, int  binmaxy, int  cut, const char * option )\
{\
to_nonconst<Type,Type ## _t>(p)->FitSlicesZ(to_nonconst<TF1,TF1_t>(f1), binminx, binmaxx, binminy, binmaxy, cut, option);\
}\
double Type ## _getCorrelationFactor3 ( Type ## _p p, int  axis1, int  axis2 )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetCorrelationFactor(axis1, axis2);\
}\
double Type ## _getCovariance3 ( Type ## _p p, int  axis1, int  axis2 )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetCovariance(axis1, axis2);\
}\
TH3_p Type ## _rebinX3 ( Type ## _p p, int  ngroup, const char * newname )\
{\
return to_nonconst<TH3_t,TH3>((TH3*)to_nonconst<Type,Type ## _t>(p)->RebinX(ngroup, newname));\
}\
TH3_p Type ## _rebinY3 ( Type ## _p p, int  ngroup, const char * newname )\
{\
return to_nonconst<TH3_t,TH3>((TH3*)to_nonconst<Type,Type ## _t>(p)->RebinY(ngroup, newname));\
}\
TH3_p Type ## _rebinZ3 ( Type ## _p p, int  ngroup, const char * newname )\
{\
return to_nonconst<TH3_t,TH3>((TH3*)to_nonconst<Type,Type ## _t>(p)->RebinZ(ngroup, newname));\
}\
TH3_p Type ## _Rebin3D ( Type ## _p p, int  nxgroup, int  nygroup, int  nzgroup, const char * newname )\
{\
return to_nonconst<TH3_t,TH3>((TH3*)to_nonconst<Type,Type ## _t>(p)->Rebin3D(nxgroup, nygroup, nzgroup, newname));\
}

#undef ROOT_TH3_DEFINITIONNONVIRT
#define ROOT_TH3_DEFINITIONNONVIRT(Type)\
TH1D_p Type ## _tH3ProjectionX ( Type ## _p p, const char * name, int  firstybin, int  lastybin, int  firstzbin, int  lastzbin, const char * option )\
{\
return to_nonconst<TH1D_t,TH1D>((TH1D*)to_nonconst<Type,Type ## _t>(p)->ProjectionX(name, firstybin, lastybin, firstzbin, lastzbin, option));\
}\
TH1D_p Type ## _tH3ProjectionY ( Type ## _p p, const char * name, int  firstxbin, int  lastxbin, int  firstzbin, int  lastzbin, const char * option )\
{\
return to_nonconst<TH1D_t,TH1D>((TH1D*)to_nonconst<Type,Type ## _t>(p)->ProjectionY(name, firstxbin, lastxbin, firstzbin, lastzbin, option));\
}\
TH1D_p Type ## _tH3ProjectionZ ( Type ## _p p, const char * name, int  firstxbin, int  lastxbin, int  firstybin, int  lastybin, const char * option )\
{\
return to_nonconst<TH1D_t,TH1D>((TH1D*)to_nonconst<Type,Type ## _t>(p)->ProjectionZ(name, firstxbin, lastxbin, firstybin, lastybin, option));\
}\
TH1_p Type ## _tH3Project3D ( Type ## _p p, const char * option )\
{\
return to_nonconst<TH1_t,TH1>((TH1*)to_nonconst<Type,Type ## _t>(p)->Project3D(option));\
}

ROOT_TH1_DECLARATIONVIRT(TH3);
ROOT_TATT3D_DECLARATIONVIRT(TH3);
ROOT_TNAMED_DECLARATIONVIRT(TH3);
ROOT_TATTLINE_DECLARATIONVIRT(TH3);
ROOT_TATTFILL_DECLARATIONVIRT(TH3);
ROOT_TATTMARKER_DECLARATIONVIRT(TH3);
ROOT_TOBJECT_DECLARATIONVIRT(TH3);
ROOT_DELETABLE_DECLARATIONVIRT(TH3);


ROOT_TH3_DECLARATIONVIRT(TH3);


ROOT_TH3_DECLARATIONNONVIRT(TH3);


#ifdef __cplusplus
}
#endif
