#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTObject.h"
#include "HROOTTAttLine.h"
#include "HROOTDeletable.h"

#undef ROOT_TLINE_DECLARATIONVIRT
#define ROOT_TLINE_DECLARATIONVIRT(Type) \
TLine_p Type ## _DrawLine ( Type ## _p p, double x1, double y1, double x2, double y2 ); \
TLine_p Type ## _DrawLineNDC ( Type ## _p p, double x1, double y1, double x2, double y2 ); \
void Type ## _PaintLine ( Type ## _p p, double x1, double y1, double x2, double y2 ); \
void Type ## _PaintLineNDC ( Type ## _p p, double u1, double v1, double u2, double v2 ); \
void Type ## _SetX1 ( Type ## _p p, double x1 ); \
void Type ## _SetX2 ( Type ## _p p, double x2 ); \
void Type ## _SetY1 ( Type ## _p p, double y1 ); \
void Type ## _SetY2 ( Type ## _p p, double y2 )

#undef ROOT_TLINE_DECLARATIONNONVIRT
#define ROOT_TLINE_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTLine ( double x1, double y1, double x2, double y2 ); \
double Type ## _tLineGetX1 ( Type ## _p p ); \
double Type ## _tLineGetX2 ( Type ## _p p ); \
double Type ## _tLineGetY1 ( Type ## _p p ); \
double Type ## _tLineGetY2 ( Type ## _p p ); \
int Type ## _tLineIsHorizontal ( Type ## _p p ); \
int Type ## _tLineIsVertical ( Type ## _p p ); \
void Type ## _tLineSetHorizontal ( Type ## _p p, int set ); \
void Type ## _tLineSetVertical ( Type ## _p p, int set )

#undef ROOT_TLINE_DEFINITIONVIRT
#define ROOT_TLINE_DEFINITIONVIRT(Type)\
TLine_p Type ## _DrawLine ( Type ## _p p, double x1, double y1, double x2, double y2 )\
{\
return to_nonconst<TLine_t,TLine>((TLine*)to_nonconst<Type,Type ## _t>(p)->DrawLine(x1, y1, x2, y2));\
}\
TLine_p Type ## _DrawLineNDC ( Type ## _p p, double x1, double y1, double x2, double y2 )\
{\
return to_nonconst<TLine_t,TLine>((TLine*)to_nonconst<Type,Type ## _t>(p)->DrawLineNDC(x1, y1, x2, y2));\
}\
void Type ## _PaintLine ( Type ## _p p, double x1, double y1, double x2, double y2 )\
{\
to_nonconst<Type,Type ## _t>(p)->PaintLine(x1, y1, x2, y2);\
}\
void Type ## _PaintLineNDC ( Type ## _p p, double u1, double v1, double u2, double v2 )\
{\
to_nonconst<Type,Type ## _t>(p)->PaintLineNDC(u1, v1, u2, v2);\
}\
void Type ## _SetX1 ( Type ## _p p, double x1 )\
{\
to_nonconst<Type,Type ## _t>(p)->SetX1(x1);\
}\
void Type ## _SetX2 ( Type ## _p p, double x2 )\
{\
to_nonconst<Type,Type ## _t>(p)->SetX2(x2);\
}\
void Type ## _SetY1 ( Type ## _p p, double y1 )\
{\
to_nonconst<Type,Type ## _t>(p)->SetY1(y1);\
}\
void Type ## _SetY2 ( Type ## _p p, double y2 )\
{\
to_nonconst<Type,Type ## _t>(p)->SetY2(y2);\
}

#undef ROOT_TLINE_DEFINITIONNONVIRT
#define ROOT_TLINE_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTLine ( double x1, double y1, double x2, double y2 )\
{\
Type * newp = new Type (x1, y1, x2, y2); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
double Type ## _tLineGetX1 ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetX1();\
}\
double Type ## _tLineGetX2 ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetX2();\
}\
double Type ## _tLineGetY1 ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetY1();\
}\
double Type ## _tLineGetY2 ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->GetY2();\
}\
int Type ## _tLineIsHorizontal ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->IsHorizontal();\
}\
int Type ## _tLineIsVertical ( Type ## _p p )\
{\
return to_nonconst<Type,Type ## _t>(p)->IsVertical();\
}\
void Type ## _tLineSetHorizontal ( Type ## _p p, int set )\
{\
to_nonconst<Type,Type ## _t>(p)->SetHorizontal(set);\
}\
void Type ## _tLineSetVertical ( Type ## _p p, int set )\
{\
to_nonconst<Type,Type ## _t>(p)->SetVertical(set);\
}

ROOT_TOBJECT_DECLARATIONVIRT(TLine);
ROOT_TATTLINE_DECLARATIONVIRT(TLine);
ROOT_DELETABLE_DECLARATIONVIRT(TLine);


ROOT_TLINE_DECLARATIONVIRT(TLine);


ROOT_TLINE_DECLARATIONNONVIRT(TLine);


#ifdef __cplusplus
}
#endif
