#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTNamed.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TRANDOM_DECLARATIONVIRT
#define ROOT_TRANDOM_DECLARATIONVIRT(Type) \
double Type ## _Gaus ( Type ## _p p, double mean, double sigma ); \
double Type ## _Uniform ( Type ## _p p, double x1, double x2 )

#undef ROOT_TRANDOM_DECLARATIONNONVIRT
#define ROOT_TRANDOM_DECLARATIONNONVIRT(Type) \
Type ## _p Type ## _newTRandom ( int  seed )

#undef ROOT_TRANDOM_DEFINITIONVIRT
#define ROOT_TRANDOM_DEFINITIONVIRT(Type)\
double Type ## _Gaus ( Type ## _p p, double mean, double sigma )\
{\
return to_nonconst<Type,Type ## _t>(p)->Gaus(mean, sigma);\
}\
double Type ## _Uniform ( Type ## _p p, double x1, double x2 )\
{\
return to_nonconst<Type,Type ## _t>(p)->Uniform(x1, x2);\
}

#undef ROOT_TRANDOM_DEFINITIONNONVIRT
#define ROOT_TRANDOM_DEFINITIONNONVIRT(Type)\
Type ## _p Type ## _newTRandom ( int  seed )\
{\
Type * newp = new Type (seed); \
return to_nonconst<Type ## _t, Type >(newp);\
}

ROOT_TNAMED_DECLARATIONVIRT(TRandom);
ROOT_TOBJECT_DECLARATIONVIRT(TRandom);
ROOT_DELETABLE_DECLARATIONVIRT(TRandom);


ROOT_TRANDOM_DECLARATIONVIRT(TRandom);


ROOT_TRANDOM_DECLARATIONNONVIRT(TRandom);


#ifdef __cplusplus
}
#endif
