{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TArrayF.Implementation where


import HROOT.TypeCast

import HROOT.Class.TArrayF.RawType
import HROOT.Class.TArrayF.FFI
import HROOT.Class.TArrayF.Interface
import HROOT.Class.TArrayF.Cast

import HROOT.Class.TArray.RawType
import HROOT.Class.TArray.Cast
import HROOT.Class.TArray.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITArrayF TArrayF where
instance ITArray TArrayF where
instance IDeletable TArrayF where
  delete = xform0 c_tarrayf_delete

instance ITArrayF (Exist TArrayF) where

instance ITArray (Exist TArrayF) where

instance IDeletable (Exist TArrayF) where
  delete (ETArrayF x) = delete x





instance FPtr (Exist TArrayF) where
  type Raw (Exist TArrayF) = RawTArrayF
  get_fptr (ETArrayF obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayF (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayF) :: TArrayF)
