{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TArrow.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TArrow.RawType
import HROOT.Class.TLine.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTArrow.h"

foreign import ccall "HROOTTArrow.h TArrow_DrawLine" c_tarrow_drawline 
  :: (Ptr RawTArrow) -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTLine)
foreign import ccall "HROOTTArrow.h TArrow_DrawLineNDC" c_tarrow_drawlinendc 
  :: (Ptr RawTArrow) -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTLine)
foreign import ccall "HROOTTArrow.h TArrow_PaintLine" c_tarrow_paintline 
  :: (Ptr RawTArrow) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_PaintLineNDC" c_tarrow_paintlinendc 
  :: (Ptr RawTArrow) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetX1" c_tarrow_setx1 
  :: (Ptr RawTArrow) -> CDouble -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetX2" c_tarrow_setx2 
  :: (Ptr RawTArrow) -> CDouble -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetY1" c_tarrow_sety1 
  :: (Ptr RawTArrow) -> CDouble -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetY2" c_tarrow_sety2 
  :: (Ptr RawTArrow) -> CDouble -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetFillColor" c_tarrow_setfillcolor 
  :: (Ptr RawTArrow) -> CInt -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetFillStyle" c_tarrow_setfillstyle 
  :: (Ptr RawTArrow) -> CInt -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_Draw" c_tarrow_draw 
  :: (Ptr RawTArrow) -> CString -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_FindObject" c_tarrow_findobject 
  :: (Ptr RawTArrow) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTArrow.h TArrow_GetName" c_tarrow_getname 
  :: (Ptr RawTArrow) -> IO CString
foreign import ccall "HROOTTArrow.h TArrow_IsA" c_tarrow_isa 
  :: (Ptr RawTArrow) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTArrow.h TArrow_IsFolder" c_tarrow_isfolder 
  :: (Ptr RawTArrow) -> IO CInt
foreign import ccall "HROOTTArrow.h TArrow_IsEqual" c_tarrow_isequal 
  :: (Ptr RawTArrow) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTArrow.h TArrow_IsSortable" c_tarrow_issortable 
  :: (Ptr RawTArrow) -> IO CInt
foreign import ccall "HROOTTArrow.h TArrow_Paint" c_tarrow_paint 
  :: (Ptr RawTArrow) -> CString -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_printObj" c_tarrow_printobj 
  :: (Ptr RawTArrow) -> CString -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_RecursiveRemove" c_tarrow_recursiveremove 
  :: (Ptr RawTArrow) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SaveAs" c_tarrow_saveas 
  :: (Ptr RawTArrow) -> CString -> CString -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_UseCurrentStyle" c_tarrow_usecurrentstyle 
  :: (Ptr RawTArrow) -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_Write" c_tarrow_write 
  :: (Ptr RawTArrow) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTArrow.h TArrow_GetLineColor" c_tarrow_getlinecolor 
  :: (Ptr RawTArrow) -> IO CInt
foreign import ccall "HROOTTArrow.h TArrow_GetLineStyle" c_tarrow_getlinestyle 
  :: (Ptr RawTArrow) -> IO CInt
foreign import ccall "HROOTTArrow.h TArrow_GetLineWidth" c_tarrow_getlinewidth 
  :: (Ptr RawTArrow) -> IO CInt
foreign import ccall "HROOTTArrow.h TArrow_ResetAttLine" c_tarrow_resetattline 
  :: (Ptr RawTArrow) -> CString -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetLineAttributes" c_tarrow_setlineattributes 
  :: (Ptr RawTArrow) -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetLineColor" c_tarrow_setlinecolor 
  :: (Ptr RawTArrow) -> CInt -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetLineStyle" c_tarrow_setlinestyle 
  :: (Ptr RawTArrow) -> CInt -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_SetLineWidth" c_tarrow_setlinewidth 
  :: (Ptr RawTArrow) -> CInt -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_delete" c_tarrow_delete 
  :: (Ptr RawTArrow) -> IO ()
foreign import ccall "HROOTTArrow.h TArrow_newTArrow" c_tarrow_newtarrow 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> CString -> IO (Ptr RawTArrow)

