{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TButton.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TButton.RawType
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTButton.h"

foreign import ccall "HROOTTButton.h TButton_GetTextAlign" c_tbutton_gettextalign 
  :: (Ptr RawTButton) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_GetTextAngle" c_tbutton_gettextangle 
  :: (Ptr RawTButton) -> IO CDouble
foreign import ccall "HROOTTButton.h TButton_GetTextColor" c_tbutton_gettextcolor 
  :: (Ptr RawTButton) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_GetTextFont" c_tbutton_gettextfont 
  :: (Ptr RawTButton) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_GetTextSize" c_tbutton_gettextsize 
  :: (Ptr RawTButton) -> IO CDouble
foreign import ccall "HROOTTButton.h TButton_ResetAttText" c_tbutton_resetatttext 
  :: (Ptr RawTButton) -> CString -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetTextAttributes" c_tbutton_settextattributes 
  :: (Ptr RawTButton) -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetTextAlign" c_tbutton_settextalign 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetTextAngle" c_tbutton_settextangle 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetTextColor" c_tbutton_settextcolor 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetTextFont" c_tbutton_settextfont 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetTextSize" c_tbutton_settextsize 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetTextSizePixels" c_tbutton_settextsizepixels 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_cd" c_tbutton_cd 
  :: (Ptr RawTButton) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTButton.h TButton_GetFrame" c_tbutton_getframe 
  :: (Ptr RawTButton) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTButton.h TButton_Modified" c_tbutton_modified 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_Range" c_tbutton_range 
  :: (Ptr RawTButton) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_Draw" c_tbutton_draw 
  :: (Ptr RawTButton) -> CString -> IO ()
foreign import ccall "HROOTTButton.h TButton_FindObject" c_tbutton_findobject 
  :: (Ptr RawTButton) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTButton.h TButton_GetName" c_tbutton_getname 
  :: (Ptr RawTButton) -> IO CString
foreign import ccall "HROOTTButton.h TButton_IsA" c_tbutton_isa 
  :: (Ptr RawTButton) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTButton.h TButton_IsFolder" c_tbutton_isfolder 
  :: (Ptr RawTButton) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_IsEqual" c_tbutton_isequal 
  :: (Ptr RawTButton) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_IsSortable" c_tbutton_issortable 
  :: (Ptr RawTButton) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_Paint" c_tbutton_paint 
  :: (Ptr RawTButton) -> CString -> IO ()
foreign import ccall "HROOTTButton.h TButton_printObj" c_tbutton_printobj 
  :: (Ptr RawTButton) -> CString -> IO ()
foreign import ccall "HROOTTButton.h TButton_RecursiveRemove" c_tbutton_recursiveremove 
  :: (Ptr RawTButton) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTButton.h TButton_SaveAs" c_tbutton_saveas 
  :: (Ptr RawTButton) -> CString -> CString -> IO ()
foreign import ccall "HROOTTButton.h TButton_UseCurrentStyle" c_tbutton_usecurrentstyle 
  :: (Ptr RawTButton) -> IO ()
foreign import ccall "HROOTTButton.h TButton_Write" c_tbutton_write 
  :: (Ptr RawTButton) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTButton.h TButton_GetLineColor" c_tbutton_getlinecolor 
  :: (Ptr RawTButton) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_GetLineStyle" c_tbutton_getlinestyle 
  :: (Ptr RawTButton) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_GetLineWidth" c_tbutton_getlinewidth 
  :: (Ptr RawTButton) -> IO CInt
foreign import ccall "HROOTTButton.h TButton_ResetAttLine" c_tbutton_resetattline 
  :: (Ptr RawTButton) -> CString -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetLineAttributes" c_tbutton_setlineattributes 
  :: (Ptr RawTButton) -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetLineColor" c_tbutton_setlinecolor 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetLineStyle" c_tbutton_setlinestyle 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetLineWidth" c_tbutton_setlinewidth 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetFillColor" c_tbutton_setfillcolor 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetFillStyle" c_tbutton_setfillstyle 
  :: (Ptr RawTButton) -> CInt -> IO ()
foreign import ccall "HROOTTButton.h TButton_ResetAttPad" c_tbutton_resetattpad 
  :: (Ptr RawTButton) -> CString -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetBottomMargin" c_tbutton_setbottommargin 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetLeftMargin" c_tbutton_setleftmargin 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetRightMargin" c_tbutton_setrightmargin 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetTopMargin" c_tbutton_settopmargin 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetMargin" c_tbutton_setmargin 
  :: (Ptr RawTButton) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetAfile" c_tbutton_setafile 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetXfile" c_tbutton_setxfile 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetYfile" c_tbutton_setyfile 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetAstat" c_tbutton_setastat 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetXstat" c_tbutton_setxstat 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_SetYstat" c_tbutton_setystat 
  :: (Ptr RawTButton) -> CDouble -> IO ()
foreign import ccall "HROOTTButton.h TButton_delete" c_tbutton_delete 
  :: (Ptr RawTButton) -> IO ()

