{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TCanvas.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TCanvas.RawType
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTCanvas.h"

foreign import ccall "HROOTTCanvas.h TCanvas_cd" c_tcanvas_cd 
  :: (Ptr RawTCanvas) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTCanvas.h TCanvas_GetFrame" c_tcanvas_getframe 
  :: (Ptr RawTCanvas) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTCanvas.h TCanvas_Modified" c_tcanvas_modified 
  :: (Ptr RawTCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_Range" c_tcanvas_range 
  :: (Ptr RawTCanvas) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_Draw" c_tcanvas_draw 
  :: (Ptr RawTCanvas) -> CString -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_FindObject" c_tcanvas_findobject 
  :: (Ptr RawTCanvas) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTCanvas.h TCanvas_GetName" c_tcanvas_getname 
  :: (Ptr RawTCanvas) -> IO CString
foreign import ccall "HROOTTCanvas.h TCanvas_IsA" c_tcanvas_isa 
  :: (Ptr RawTCanvas) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTCanvas.h TCanvas_IsFolder" c_tcanvas_isfolder 
  :: (Ptr RawTCanvas) -> IO CInt
foreign import ccall "HROOTTCanvas.h TCanvas_IsEqual" c_tcanvas_isequal 
  :: (Ptr RawTCanvas) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTCanvas.h TCanvas_IsSortable" c_tcanvas_issortable 
  :: (Ptr RawTCanvas) -> IO CInt
foreign import ccall "HROOTTCanvas.h TCanvas_Paint" c_tcanvas_paint 
  :: (Ptr RawTCanvas) -> CString -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_printObj" c_tcanvas_printobj 
  :: (Ptr RawTCanvas) -> CString -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_RecursiveRemove" c_tcanvas_recursiveremove 
  :: (Ptr RawTCanvas) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SaveAs" c_tcanvas_saveas 
  :: (Ptr RawTCanvas) -> CString -> CString -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_UseCurrentStyle" c_tcanvas_usecurrentstyle 
  :: (Ptr RawTCanvas) -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_Write" c_tcanvas_write 
  :: (Ptr RawTCanvas) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTCanvas.h TCanvas_GetLineColor" c_tcanvas_getlinecolor 
  :: (Ptr RawTCanvas) -> IO CInt
foreign import ccall "HROOTTCanvas.h TCanvas_GetLineStyle" c_tcanvas_getlinestyle 
  :: (Ptr RawTCanvas) -> IO CInt
foreign import ccall "HROOTTCanvas.h TCanvas_GetLineWidth" c_tcanvas_getlinewidth 
  :: (Ptr RawTCanvas) -> IO CInt
foreign import ccall "HROOTTCanvas.h TCanvas_ResetAttLine" c_tcanvas_resetattline 
  :: (Ptr RawTCanvas) -> CString -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetLineAttributes" c_tcanvas_setlineattributes 
  :: (Ptr RawTCanvas) -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetLineColor" c_tcanvas_setlinecolor 
  :: (Ptr RawTCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetLineStyle" c_tcanvas_setlinestyle 
  :: (Ptr RawTCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetLineWidth" c_tcanvas_setlinewidth 
  :: (Ptr RawTCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetFillColor" c_tcanvas_setfillcolor 
  :: (Ptr RawTCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetFillStyle" c_tcanvas_setfillstyle 
  :: (Ptr RawTCanvas) -> CInt -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_ResetAttPad" c_tcanvas_resetattpad 
  :: (Ptr RawTCanvas) -> CString -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetBottomMargin" c_tcanvas_setbottommargin 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetLeftMargin" c_tcanvas_setleftmargin 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetRightMargin" c_tcanvas_setrightmargin 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetTopMargin" c_tcanvas_settopmargin 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetMargin" c_tcanvas_setmargin 
  :: (Ptr RawTCanvas) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetAfile" c_tcanvas_setafile 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetXfile" c_tcanvas_setxfile 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetYfile" c_tcanvas_setyfile 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetAstat" c_tcanvas_setastat 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetXstat" c_tcanvas_setxstat 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_SetYstat" c_tcanvas_setystat 
  :: (Ptr RawTCanvas) -> CDouble -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_delete" c_tcanvas_delete 
  :: (Ptr RawTCanvas) -> IO ()
foreign import ccall "HROOTTCanvas.h TCanvas_newTCanvas" c_tcanvas_newtcanvas 
  :: CString -> CString -> CInt -> CInt -> IO (Ptr RawTCanvas)

