{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TCanvas.Implementation where


import HROOT.TypeCast

import HROOT.Class.TCanvas.RawType
import HROOT.Class.TCanvas.FFI
import HROOT.Class.TCanvas.Interface
import HROOT.Class.TCanvas.Cast
import HROOT.Class.TFrame.RawType
import HROOT.Class.TFrame.Cast
import HROOT.Class.TFrame.Interface
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TPad.RawType
import HROOT.Class.TPad.Cast
import HROOT.Class.TPad.Interface
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TVirtualPad.Cast
import HROOT.Class.TVirtualPad.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttPad.RawType
import HROOT.Class.TAttPad.Cast
import HROOT.Class.TAttPad.Interface
import HROOT.Class.TQObject.RawType
import HROOT.Class.TQObject.Cast
import HROOT.Class.TQObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITCanvas TCanvas where
instance ITPad TCanvas where
instance ITVirtualPad TCanvas where
  cd = xform1 c_tcanvas_cd
  getFrame = xform0 c_tcanvas_getframe
  modified = xform1 c_tcanvas_modified
  range = xform4 c_tcanvas_range
instance ITObject TCanvas where
  draw = xform1 c_tcanvas_draw
  findObject = xform1 c_tcanvas_findobject
  getName = xform0 c_tcanvas_getname
  isA = xform0 c_tcanvas_isa
  isFolder = xform0 c_tcanvas_isfolder
  isEqual = xform1 c_tcanvas_isequal
  isSortable = xform0 c_tcanvas_issortable
  paint = xform1 c_tcanvas_paint
  printObj = xform1 c_tcanvas_printobj
  recursiveRemove = xform1 c_tcanvas_recursiveremove
  saveAs = xform2 c_tcanvas_saveas
  useCurrentStyle = xform0 c_tcanvas_usecurrentstyle
  write = xform3 c_tcanvas_write
instance ITAttLine TCanvas where
  getLineColor = xform0 c_tcanvas_getlinecolor
  getLineStyle = xform0 c_tcanvas_getlinestyle
  getLineWidth = xform0 c_tcanvas_getlinewidth
  resetAttLine = xform1 c_tcanvas_resetattline
  setLineAttributes = xform0 c_tcanvas_setlineattributes
  setLineColor = xform1 c_tcanvas_setlinecolor
  setLineStyle = xform1 c_tcanvas_setlinestyle
  setLineWidth = xform1 c_tcanvas_setlinewidth
instance ITAttFill TCanvas where
  setFillColor = xform1 c_tcanvas_setfillcolor
  setFillStyle = xform1 c_tcanvas_setfillstyle
instance ITAttPad TCanvas where
  resetAttPad = xform1 c_tcanvas_resetattpad
  setBottomMargin = xform1 c_tcanvas_setbottommargin
  setLeftMargin = xform1 c_tcanvas_setleftmargin
  setRightMargin = xform1 c_tcanvas_setrightmargin
  setTopMargin = xform1 c_tcanvas_settopmargin
  setMargin = xform4 c_tcanvas_setmargin
  setAfile = xform1 c_tcanvas_setafile
  setXfile = xform1 c_tcanvas_setxfile
  setYfile = xform1 c_tcanvas_setyfile
  setAstat = xform1 c_tcanvas_setastat
  setXstat = xform1 c_tcanvas_setxstat
  setYstat = xform1 c_tcanvas_setystat
instance ITQObject TCanvas where
instance IDeletable TCanvas where
  delete = xform0 c_tcanvas_delete

instance ITCanvas (Exist TCanvas) where

instance ITPad (Exist TCanvas) where

instance ITVirtualPad (Exist TCanvas) where
  cd (ETCanvas x) = cd x
  getFrame (ETCanvas x) = getFrame x
  modified (ETCanvas x) = modified x
  range (ETCanvas x) = range x
instance ITObject (Exist TCanvas) where
  draw (ETCanvas x) = draw x
  findObject (ETCanvas x) = findObject x
  getName (ETCanvas x) = getName x
  isA (ETCanvas x) = isA x
  isFolder (ETCanvas x) = isFolder x
  isEqual (ETCanvas x) = isEqual x
  isSortable (ETCanvas x) = isSortable x
  paint (ETCanvas x) = paint x
  printObj (ETCanvas x) = printObj x
  recursiveRemove (ETCanvas x) = recursiveRemove x
  saveAs (ETCanvas x) = saveAs x
  useCurrentStyle (ETCanvas x) = useCurrentStyle x
  write (ETCanvas x) = write x
instance ITAttLine (Exist TCanvas) where
  getLineColor (ETCanvas x) = getLineColor x
  getLineStyle (ETCanvas x) = getLineStyle x
  getLineWidth (ETCanvas x) = getLineWidth x
  resetAttLine (ETCanvas x) = resetAttLine x
  setLineAttributes (ETCanvas x) = setLineAttributes x
  setLineColor (ETCanvas x) = setLineColor x
  setLineStyle (ETCanvas x) = setLineStyle x
  setLineWidth (ETCanvas x) = setLineWidth x
instance ITAttFill (Exist TCanvas) where
  setFillColor (ETCanvas x) = setFillColor x
  setFillStyle (ETCanvas x) = setFillStyle x
instance ITAttPad (Exist TCanvas) where
  resetAttPad (ETCanvas x) = resetAttPad x
  setBottomMargin (ETCanvas x) = setBottomMargin x
  setLeftMargin (ETCanvas x) = setLeftMargin x
  setRightMargin (ETCanvas x) = setRightMargin x
  setTopMargin (ETCanvas x) = setTopMargin x
  setMargin (ETCanvas x) = setMargin x
  setAfile (ETCanvas x) = setAfile x
  setXfile (ETCanvas x) = setXfile x
  setYfile (ETCanvas x) = setYfile x
  setAstat (ETCanvas x) = setAstat x
  setXstat (ETCanvas x) = setXstat x
  setYstat (ETCanvas x) = setYstat x
instance ITQObject (Exist TCanvas) where

instance IDeletable (Exist TCanvas) where
  delete (ETCanvas x) = delete x


newTCanvas :: String -> String -> Int -> Int -> IO TCanvas
newTCanvas = xform3 c_tcanvas_newtcanvas



instance FPtr (Exist TCanvas) where
  type Raw (Exist TCanvas) = RawTCanvas
  get_fptr (ETCanvas obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETCanvas (cast_fptr_to_obj (fptr :: ForeignPtr RawTCanvas) :: TCanvas)
