{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TChain.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TChain.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTChain.h"

foreign import ccall "HROOTTChain.h TChain_SetName" c_tchain_setname 
  :: (Ptr RawTChain) -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetNameTitle" c_tchain_setnametitle 
  :: (Ptr RawTChain) -> CString -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetTitle" c_tchain_settitle 
  :: (Ptr RawTChain) -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_GetLineColor" c_tchain_getlinecolor 
  :: (Ptr RawTChain) -> IO CInt
foreign import ccall "HROOTTChain.h TChain_GetLineStyle" c_tchain_getlinestyle 
  :: (Ptr RawTChain) -> IO CInt
foreign import ccall "HROOTTChain.h TChain_GetLineWidth" c_tchain_getlinewidth 
  :: (Ptr RawTChain) -> IO CInt
foreign import ccall "HROOTTChain.h TChain_ResetAttLine" c_tchain_resetattline 
  :: (Ptr RawTChain) -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetLineAttributes" c_tchain_setlineattributes 
  :: (Ptr RawTChain) -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetLineColor" c_tchain_setlinecolor 
  :: (Ptr RawTChain) -> CInt -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetLineStyle" c_tchain_setlinestyle 
  :: (Ptr RawTChain) -> CInt -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetLineWidth" c_tchain_setlinewidth 
  :: (Ptr RawTChain) -> CInt -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetFillColor" c_tchain_setfillcolor 
  :: (Ptr RawTChain) -> CInt -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetFillStyle" c_tchain_setfillstyle 
  :: (Ptr RawTChain) -> CInt -> IO ()
foreign import ccall "HROOTTChain.h TChain_GetMarkerColor" c_tchain_getmarkercolor 
  :: (Ptr RawTChain) -> IO CInt
foreign import ccall "HROOTTChain.h TChain_GetMarkerStyle" c_tchain_getmarkerstyle 
  :: (Ptr RawTChain) -> IO CInt
foreign import ccall "HROOTTChain.h TChain_GetMarkerSize" c_tchain_getmarkersize 
  :: (Ptr RawTChain) -> IO CDouble
foreign import ccall "HROOTTChain.h TChain_ResetAttMarker" c_tchain_resetattmarker 
  :: (Ptr RawTChain) -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetMarkerAttributes" c_tchain_setmarkerattributes 
  :: (Ptr RawTChain) -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetMarkerColor" c_tchain_setmarkercolor 
  :: (Ptr RawTChain) -> CInt -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetMarkerStyle" c_tchain_setmarkerstyle 
  :: (Ptr RawTChain) -> CInt -> IO ()
foreign import ccall "HROOTTChain.h TChain_SetMarkerSize" c_tchain_setmarkersize 
  :: (Ptr RawTChain) -> CInt -> IO ()
foreign import ccall "HROOTTChain.h TChain_Draw" c_tchain_draw 
  :: (Ptr RawTChain) -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_FindObject" c_tchain_findobject 
  :: (Ptr RawTChain) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTChain.h TChain_GetName" c_tchain_getname 
  :: (Ptr RawTChain) -> IO CString
foreign import ccall "HROOTTChain.h TChain_IsA" c_tchain_isa 
  :: (Ptr RawTChain) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTChain.h TChain_IsFolder" c_tchain_isfolder 
  :: (Ptr RawTChain) -> IO CInt
foreign import ccall "HROOTTChain.h TChain_IsEqual" c_tchain_isequal 
  :: (Ptr RawTChain) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTChain.h TChain_IsSortable" c_tchain_issortable 
  :: (Ptr RawTChain) -> IO CInt
foreign import ccall "HROOTTChain.h TChain_Paint" c_tchain_paint 
  :: (Ptr RawTChain) -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_printObj" c_tchain_printobj 
  :: (Ptr RawTChain) -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_RecursiveRemove" c_tchain_recursiveremove 
  :: (Ptr RawTChain) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTChain.h TChain_SaveAs" c_tchain_saveas 
  :: (Ptr RawTChain) -> CString -> CString -> IO ()
foreign import ccall "HROOTTChain.h TChain_UseCurrentStyle" c_tchain_usecurrentstyle 
  :: (Ptr RawTChain) -> IO ()
foreign import ccall "HROOTTChain.h TChain_Write" c_tchain_write 
  :: (Ptr RawTChain) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTChain.h TChain_delete" c_tchain_delete 
  :: (Ptr RawTChain) -> IO ()
foreign import ccall "HROOTTChain.h TChain_newTChain" c_tchain_newtchain 
  :: CString -> CString -> IO (Ptr RawTChain)

