{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TCurlyLine.Implementation where


import HROOT.TypeCast

import HROOT.Class.TCurlyLine.RawType
import HROOT.Class.TCurlyLine.FFI
import HROOT.Class.TCurlyLine.Interface
import HROOT.Class.TCurlyLine.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TPolyLine.RawType
import HROOT.Class.TPolyLine.Cast
import HROOT.Class.TPolyLine.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITCurlyLine TCurlyLine where
instance ITPolyLine TCurlyLine where
instance ITObject TCurlyLine where
  draw = xform1 c_tcurlyline_draw
  findObject = xform1 c_tcurlyline_findobject
  getName = xform0 c_tcurlyline_getname
  isA = xform0 c_tcurlyline_isa
  isFolder = xform0 c_tcurlyline_isfolder
  isEqual = xform1 c_tcurlyline_isequal
  isSortable = xform0 c_tcurlyline_issortable
  paint = xform1 c_tcurlyline_paint
  printObj = xform1 c_tcurlyline_printobj
  recursiveRemove = xform1 c_tcurlyline_recursiveremove
  saveAs = xform2 c_tcurlyline_saveas
  useCurrentStyle = xform0 c_tcurlyline_usecurrentstyle
  write = xform3 c_tcurlyline_write
instance ITAttLine TCurlyLine where
  getLineColor = xform0 c_tcurlyline_getlinecolor
  getLineStyle = xform0 c_tcurlyline_getlinestyle
  getLineWidth = xform0 c_tcurlyline_getlinewidth
  resetAttLine = xform1 c_tcurlyline_resetattline
  setLineAttributes = xform0 c_tcurlyline_setlineattributes
  setLineColor = xform1 c_tcurlyline_setlinecolor
  setLineStyle = xform1 c_tcurlyline_setlinestyle
  setLineWidth = xform1 c_tcurlyline_setlinewidth
instance ITAttFill TCurlyLine where
  setFillColor = xform1 c_tcurlyline_setfillcolor
  setFillStyle = xform1 c_tcurlyline_setfillstyle
instance IDeletable TCurlyLine where
  delete = xform0 c_tcurlyline_delete

instance ITCurlyLine (Exist TCurlyLine) where

instance ITPolyLine (Exist TCurlyLine) where

instance ITObject (Exist TCurlyLine) where
  draw (ETCurlyLine x) = draw x
  findObject (ETCurlyLine x) = findObject x
  getName (ETCurlyLine x) = getName x
  isA (ETCurlyLine x) = isA x
  isFolder (ETCurlyLine x) = isFolder x
  isEqual (ETCurlyLine x) = isEqual x
  isSortable (ETCurlyLine x) = isSortable x
  paint (ETCurlyLine x) = paint x
  printObj (ETCurlyLine x) = printObj x
  recursiveRemove (ETCurlyLine x) = recursiveRemove x
  saveAs (ETCurlyLine x) = saveAs x
  useCurrentStyle (ETCurlyLine x) = useCurrentStyle x
  write (ETCurlyLine x) = write x
instance ITAttLine (Exist TCurlyLine) where
  getLineColor (ETCurlyLine x) = getLineColor x
  getLineStyle (ETCurlyLine x) = getLineStyle x
  getLineWidth (ETCurlyLine x) = getLineWidth x
  resetAttLine (ETCurlyLine x) = resetAttLine x
  setLineAttributes (ETCurlyLine x) = setLineAttributes x
  setLineColor (ETCurlyLine x) = setLineColor x
  setLineStyle (ETCurlyLine x) = setLineStyle x
  setLineWidth (ETCurlyLine x) = setLineWidth x
instance ITAttFill (Exist TCurlyLine) where
  setFillColor (ETCurlyLine x) = setFillColor x
  setFillStyle (ETCurlyLine x) = setFillStyle x
instance IDeletable (Exist TCurlyLine) where
  delete (ETCurlyLine x) = delete x


newTCurlyLine :: Double -> Double -> Double -> Double -> Double -> Double -> IO TCurlyLine
newTCurlyLine = xform5 c_tcurlyline_newtcurlyline



instance FPtr (Exist TCurlyLine) where
  type Raw (Exist TCurlyLine) = RawTCurlyLine
  get_fptr (ETCurlyLine obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETCurlyLine (cast_fptr_to_obj (fptr :: ForeignPtr RawTCurlyLine) :: TCurlyLine)
