{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TDialogCanvas.Implementation where


import HROOT.TypeCast

import HROOT.Class.TDialogCanvas.RawType
import HROOT.Class.TDialogCanvas.FFI
import HROOT.Class.TDialogCanvas.Interface
import HROOT.Class.TDialogCanvas.Cast
import HROOT.Class.TFrame.RawType
import HROOT.Class.TFrame.Cast
import HROOT.Class.TFrame.Interface
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TCanvas.RawType
import HROOT.Class.TCanvas.Cast
import HROOT.Class.TCanvas.Interface
import HROOT.Class.TAttText.RawType
import HROOT.Class.TAttText.Cast
import HROOT.Class.TAttText.Interface
import HROOT.Class.TPad.RawType
import HROOT.Class.TPad.Cast
import HROOT.Class.TPad.Interface
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TVirtualPad.Cast
import HROOT.Class.TVirtualPad.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttPad.RawType
import HROOT.Class.TAttPad.Cast
import HROOT.Class.TAttPad.Interface
import HROOT.Class.TQObject.RawType
import HROOT.Class.TQObject.Cast
import HROOT.Class.TQObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITDialogCanvas TDialogCanvas where
instance ITCanvas TDialogCanvas where
instance ITAttText TDialogCanvas where
  getTextAlign = xform0 c_tdialogcanvas_gettextalign
  getTextAngle = xform0 c_tdialogcanvas_gettextangle
  getTextColor = xform0 c_tdialogcanvas_gettextcolor
  getTextFont = xform0 c_tdialogcanvas_gettextfont
  getTextSize = xform0 c_tdialogcanvas_gettextsize
  resetAttText = xform1 c_tdialogcanvas_resetatttext
  setTextAttributes = xform0 c_tdialogcanvas_settextattributes
  setTextAlign = xform1 c_tdialogcanvas_settextalign
  setTextAngle = xform1 c_tdialogcanvas_settextangle
  setTextColor = xform1 c_tdialogcanvas_settextcolor
  setTextFont = xform1 c_tdialogcanvas_settextfont
  setTextSize = xform1 c_tdialogcanvas_settextsize
  setTextSizePixels = xform1 c_tdialogcanvas_settextsizepixels
instance ITPad TDialogCanvas where
instance ITVirtualPad TDialogCanvas where
  cd = xform1 c_tdialogcanvas_cd
  getFrame = xform0 c_tdialogcanvas_getframe
  modified = xform1 c_tdialogcanvas_modified
  range = xform4 c_tdialogcanvas_range
instance ITObject TDialogCanvas where
  draw = xform1 c_tdialogcanvas_draw
  findObject = xform1 c_tdialogcanvas_findobject
  getName = xform0 c_tdialogcanvas_getname
  isA = xform0 c_tdialogcanvas_isa
  isFolder = xform0 c_tdialogcanvas_isfolder
  isEqual = xform1 c_tdialogcanvas_isequal
  isSortable = xform0 c_tdialogcanvas_issortable
  paint = xform1 c_tdialogcanvas_paint
  printObj = xform1 c_tdialogcanvas_printobj
  recursiveRemove = xform1 c_tdialogcanvas_recursiveremove
  saveAs = xform2 c_tdialogcanvas_saveas
  useCurrentStyle = xform0 c_tdialogcanvas_usecurrentstyle
  write = xform3 c_tdialogcanvas_write
instance ITAttLine TDialogCanvas where
  getLineColor = xform0 c_tdialogcanvas_getlinecolor
  getLineStyle = xform0 c_tdialogcanvas_getlinestyle
  getLineWidth = xform0 c_tdialogcanvas_getlinewidth
  resetAttLine = xform1 c_tdialogcanvas_resetattline
  setLineAttributes = xform0 c_tdialogcanvas_setlineattributes
  setLineColor = xform1 c_tdialogcanvas_setlinecolor
  setLineStyle = xform1 c_tdialogcanvas_setlinestyle
  setLineWidth = xform1 c_tdialogcanvas_setlinewidth
instance ITAttFill TDialogCanvas where
  setFillColor = xform1 c_tdialogcanvas_setfillcolor
  setFillStyle = xform1 c_tdialogcanvas_setfillstyle
instance ITAttPad TDialogCanvas where
  resetAttPad = xform1 c_tdialogcanvas_resetattpad
  setBottomMargin = xform1 c_tdialogcanvas_setbottommargin
  setLeftMargin = xform1 c_tdialogcanvas_setleftmargin
  setRightMargin = xform1 c_tdialogcanvas_setrightmargin
  setTopMargin = xform1 c_tdialogcanvas_settopmargin
  setMargin = xform4 c_tdialogcanvas_setmargin
  setAfile = xform1 c_tdialogcanvas_setafile
  setXfile = xform1 c_tdialogcanvas_setxfile
  setYfile = xform1 c_tdialogcanvas_setyfile
  setAstat = xform1 c_tdialogcanvas_setastat
  setXstat = xform1 c_tdialogcanvas_setxstat
  setYstat = xform1 c_tdialogcanvas_setystat
instance ITQObject TDialogCanvas where
instance IDeletable TDialogCanvas where
  delete = xform0 c_tdialogcanvas_delete

instance ITDialogCanvas (Exist TDialogCanvas) where

instance ITCanvas (Exist TDialogCanvas) where

instance ITAttText (Exist TDialogCanvas) where
  getTextAlign (ETDialogCanvas x) = getTextAlign x
  getTextAngle (ETDialogCanvas x) = getTextAngle x
  getTextColor (ETDialogCanvas x) = getTextColor x
  getTextFont (ETDialogCanvas x) = getTextFont x
  getTextSize (ETDialogCanvas x) = getTextSize x
  resetAttText (ETDialogCanvas x) = resetAttText x
  setTextAttributes (ETDialogCanvas x) = setTextAttributes x
  setTextAlign (ETDialogCanvas x) = setTextAlign x
  setTextAngle (ETDialogCanvas x) = setTextAngle x
  setTextColor (ETDialogCanvas x) = setTextColor x
  setTextFont (ETDialogCanvas x) = setTextFont x
  setTextSize (ETDialogCanvas x) = setTextSize x
  setTextSizePixels (ETDialogCanvas x) = setTextSizePixels x
instance ITPad (Exist TDialogCanvas) where

instance ITVirtualPad (Exist TDialogCanvas) where
  cd (ETDialogCanvas x) = cd x
  getFrame (ETDialogCanvas x) = getFrame x
  modified (ETDialogCanvas x) = modified x
  range (ETDialogCanvas x) = range x
instance ITObject (Exist TDialogCanvas) where
  draw (ETDialogCanvas x) = draw x
  findObject (ETDialogCanvas x) = findObject x
  getName (ETDialogCanvas x) = getName x
  isA (ETDialogCanvas x) = isA x
  isFolder (ETDialogCanvas x) = isFolder x
  isEqual (ETDialogCanvas x) = isEqual x
  isSortable (ETDialogCanvas x) = isSortable x
  paint (ETDialogCanvas x) = paint x
  printObj (ETDialogCanvas x) = printObj x
  recursiveRemove (ETDialogCanvas x) = recursiveRemove x
  saveAs (ETDialogCanvas x) = saveAs x
  useCurrentStyle (ETDialogCanvas x) = useCurrentStyle x
  write (ETDialogCanvas x) = write x
instance ITAttLine (Exist TDialogCanvas) where
  getLineColor (ETDialogCanvas x) = getLineColor x
  getLineStyle (ETDialogCanvas x) = getLineStyle x
  getLineWidth (ETDialogCanvas x) = getLineWidth x
  resetAttLine (ETDialogCanvas x) = resetAttLine x
  setLineAttributes (ETDialogCanvas x) = setLineAttributes x
  setLineColor (ETDialogCanvas x) = setLineColor x
  setLineStyle (ETDialogCanvas x) = setLineStyle x
  setLineWidth (ETDialogCanvas x) = setLineWidth x
instance ITAttFill (Exist TDialogCanvas) where
  setFillColor (ETDialogCanvas x) = setFillColor x
  setFillStyle (ETDialogCanvas x) = setFillStyle x
instance ITAttPad (Exist TDialogCanvas) where
  resetAttPad (ETDialogCanvas x) = resetAttPad x
  setBottomMargin (ETDialogCanvas x) = setBottomMargin x
  setLeftMargin (ETDialogCanvas x) = setLeftMargin x
  setRightMargin (ETDialogCanvas x) = setRightMargin x
  setTopMargin (ETDialogCanvas x) = setTopMargin x
  setMargin (ETDialogCanvas x) = setMargin x
  setAfile (ETDialogCanvas x) = setAfile x
  setXfile (ETDialogCanvas x) = setXfile x
  setYfile (ETDialogCanvas x) = setYfile x
  setAstat (ETDialogCanvas x) = setAstat x
  setXstat (ETDialogCanvas x) = setXstat x
  setYstat (ETDialogCanvas x) = setYstat x
instance ITQObject (Exist TDialogCanvas) where

instance IDeletable (Exist TDialogCanvas) where
  delete (ETDialogCanvas x) = delete x





instance FPtr (Exist TDialogCanvas) where
  type Raw (Exist TDialogCanvas) = RawTDialogCanvas
  get_fptr (ETDialogCanvas obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETDialogCanvas (cast_fptr_to_obj (fptr :: ForeignPtr RawTDialogCanvas) :: TDialogCanvas)
