{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TDirectoryFile.Implementation where


import HROOT.TypeCast

import HROOT.Class.TDirectoryFile.RawType
import HROOT.Class.TDirectoryFile.FFI
import HROOT.Class.TDirectoryFile.Interface
import HROOT.Class.TDirectoryFile.Cast
import HROOT.Class.TKey.RawType
import HROOT.Class.TKey.Cast
import HROOT.Class.TKey.Interface
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TList.RawType
import HROOT.Class.TList.Cast
import HROOT.Class.TList.Interface
import HROOT.Class.TDirectory.RawType
import HROOT.Class.TDirectory.Cast
import HROOT.Class.TDirectory.Interface
import HROOT.Class.TNamed.RawType
import HROOT.Class.TNamed.Cast
import HROOT.Class.TNamed.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITDirectoryFile TDirectoryFile where
  getListOfKeys = xform0 c_tdirectoryfile_getlistofkeys
instance ITDirectory TDirectoryFile where
  append = xform2 c_tdirectoryfile_append
  addD = xform2 c_tdirectoryfile_addd
  appendKey = xform1 c_tdirectoryfile_appendkey
  close = xform1 c_tdirectoryfile_close
  get = xform1 c_tdirectoryfile_get
instance ITNamed TDirectoryFile where
  setName = xform1 c_tdirectoryfile_setname
  setNameTitle = xform2 c_tdirectoryfile_setnametitle
  setTitle = xform1 c_tdirectoryfile_settitle
instance ITObject TDirectoryFile where
  draw = xform1 c_tdirectoryfile_draw
  findObject = xform1 c_tdirectoryfile_findobject
  getName = xform0 c_tdirectoryfile_getname
  isA = xform0 c_tdirectoryfile_isa
  isFolder = xform0 c_tdirectoryfile_isfolder
  isEqual = xform1 c_tdirectoryfile_isequal
  isSortable = xform0 c_tdirectoryfile_issortable
  paint = xform1 c_tdirectoryfile_paint
  printObj = xform1 c_tdirectoryfile_printobj
  recursiveRemove = xform1 c_tdirectoryfile_recursiveremove
  saveAs = xform2 c_tdirectoryfile_saveas
  useCurrentStyle = xform0 c_tdirectoryfile_usecurrentstyle
  write = xform3 c_tdirectoryfile_write
instance IDeletable TDirectoryFile where
  delete = xform0 c_tdirectoryfile_delete

instance ITDirectoryFile (Exist TDirectoryFile) where
  getListOfKeys (ETDirectoryFile x) = getListOfKeys x
instance ITDirectory (Exist TDirectoryFile) where
  append (ETDirectoryFile x) = append x
  addD (ETDirectoryFile x) = addD x
  appendKey (ETDirectoryFile x) = appendKey x
  close (ETDirectoryFile x) = close x
  get (ETDirectoryFile x) = get x
instance ITNamed (Exist TDirectoryFile) where
  setName (ETDirectoryFile x) = setName x
  setNameTitle (ETDirectoryFile x) = setNameTitle x
  setTitle (ETDirectoryFile x) = setTitle x
instance ITObject (Exist TDirectoryFile) where
  draw (ETDirectoryFile x) = draw x
  findObject (ETDirectoryFile x) = findObject x
  getName (ETDirectoryFile x) = getName x
  isA (ETDirectoryFile x) = isA x
  isFolder (ETDirectoryFile x) = isFolder x
  isEqual (ETDirectoryFile x) = isEqual x
  isSortable (ETDirectoryFile x) = isSortable x
  paint (ETDirectoryFile x) = paint x
  printObj (ETDirectoryFile x) = printObj x
  recursiveRemove (ETDirectoryFile x) = recursiveRemove x
  saveAs (ETDirectoryFile x) = saveAs x
  useCurrentStyle (ETDirectoryFile x) = useCurrentStyle x
  write (ETDirectoryFile x) = write x
instance IDeletable (Exist TDirectoryFile) where
  delete (ETDirectoryFile x) = delete x





instance FPtr (Exist TDirectoryFile) where
  type Raw (Exist TDirectoryFile) = RawTDirectoryFile
  get_fptr (ETDirectoryFile obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETDirectoryFile (cast_fptr_to_obj (fptr :: ForeignPtr RawTDirectoryFile) :: TDirectoryFile)
