{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TDirectoryFile.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TDirectoryFile.RawType
import HROOT.Class.TList.RawType
import HROOT.Class.TDirectory.Interface


class (ITDirectory a) => ITDirectoryFile a where

    getListOfKeys :: a -> IO TList 

instance Existable TDirectoryFile where
  data Exist TDirectoryFile = forall a. (FPtr a, ITDirectoryFile a) => ETDirectoryFile a

upcastTDirectoryFile :: (FPtr a, ITDirectoryFile a) => a -> TDirectoryFile
upcastTDirectoryFile h = let fh = get_fptr h
                             fh2 :: ForeignPtr RawTDirectoryFile = castForeignPtr fh
                         in cast_fptr_to_obj fh2
