{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TEllipse.Implementation where


import HROOT.TypeCast

import HROOT.Class.TEllipse.RawType
import HROOT.Class.TEllipse.FFI
import HROOT.Class.TEllipse.Interface
import HROOT.Class.TEllipse.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITEllipse TEllipse where
instance ITObject TEllipse where
  draw = xform1 c_tellipse_draw
  findObject = xform1 c_tellipse_findobject
  getName = xform0 c_tellipse_getname
  isA = xform0 c_tellipse_isa
  isFolder = xform0 c_tellipse_isfolder
  isEqual = xform1 c_tellipse_isequal
  isSortable = xform0 c_tellipse_issortable
  paint = xform1 c_tellipse_paint
  printObj = xform1 c_tellipse_printobj
  recursiveRemove = xform1 c_tellipse_recursiveremove
  saveAs = xform2 c_tellipse_saveas
  useCurrentStyle = xform0 c_tellipse_usecurrentstyle
  write = xform3 c_tellipse_write
instance ITAttLine TEllipse where
  getLineColor = xform0 c_tellipse_getlinecolor
  getLineStyle = xform0 c_tellipse_getlinestyle
  getLineWidth = xform0 c_tellipse_getlinewidth
  resetAttLine = xform1 c_tellipse_resetattline
  setLineAttributes = xform0 c_tellipse_setlineattributes
  setLineColor = xform1 c_tellipse_setlinecolor
  setLineStyle = xform1 c_tellipse_setlinestyle
  setLineWidth = xform1 c_tellipse_setlinewidth
instance ITAttFill TEllipse where
  setFillColor = xform1 c_tellipse_setfillcolor
  setFillStyle = xform1 c_tellipse_setfillstyle
instance IDeletable TEllipse where
  delete = xform0 c_tellipse_delete

instance ITEllipse (Exist TEllipse) where

instance ITObject (Exist TEllipse) where
  draw (ETEllipse x) = draw x
  findObject (ETEllipse x) = findObject x
  getName (ETEllipse x) = getName x
  isA (ETEllipse x) = isA x
  isFolder (ETEllipse x) = isFolder x
  isEqual (ETEllipse x) = isEqual x
  isSortable (ETEllipse x) = isSortable x
  paint (ETEllipse x) = paint x
  printObj (ETEllipse x) = printObj x
  recursiveRemove (ETEllipse x) = recursiveRemove x
  saveAs (ETEllipse x) = saveAs x
  useCurrentStyle (ETEllipse x) = useCurrentStyle x
  write (ETEllipse x) = write x
instance ITAttLine (Exist TEllipse) where
  getLineColor (ETEllipse x) = getLineColor x
  getLineStyle (ETEllipse x) = getLineStyle x
  getLineWidth (ETEllipse x) = getLineWidth x
  resetAttLine (ETEllipse x) = resetAttLine x
  setLineAttributes (ETEllipse x) = setLineAttributes x
  setLineColor (ETEllipse x) = setLineColor x
  setLineStyle (ETEllipse x) = setLineStyle x
  setLineWidth (ETEllipse x) = setLineWidth x
instance ITAttFill (Exist TEllipse) where
  setFillColor (ETEllipse x) = setFillColor x
  setFillStyle (ETEllipse x) = setFillStyle x
instance IDeletable (Exist TEllipse) where
  delete (ETEllipse x) = delete x


newTEllipse :: Double -> Double -> Double -> Double -> Double -> Double -> Double -> IO TEllipse
newTEllipse = xform6 c_tellipse_newtellipse



instance FPtr (Exist TEllipse) where
  type Raw (Exist TEllipse) = RawTEllipse
  get_fptr (ETEllipse obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETEllipse (cast_fptr_to_obj (fptr :: ForeignPtr RawTEllipse) :: TEllipse)
