{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TEvePad.Implementation where


import HROOT.TypeCast

import HROOT.Class.TEvePad.RawType
import HROOT.Class.TEvePad.FFI
import HROOT.Class.TEvePad.Interface
import HROOT.Class.TEvePad.Cast
import HROOT.Class.TFrame.RawType
import HROOT.Class.TFrame.Cast
import HROOT.Class.TFrame.Interface
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TPad.RawType
import HROOT.Class.TPad.Cast
import HROOT.Class.TPad.Interface
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TVirtualPad.Cast
import HROOT.Class.TVirtualPad.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttPad.RawType
import HROOT.Class.TAttPad.Cast
import HROOT.Class.TAttPad.Interface
import HROOT.Class.TQObject.RawType
import HROOT.Class.TQObject.Cast
import HROOT.Class.TQObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITEvePad TEvePad where
instance ITPad TEvePad where
instance ITVirtualPad TEvePad where
  cd = xform1 c_tevepad_cd
  getFrame = xform0 c_tevepad_getframe
  modified = xform1 c_tevepad_modified
  range = xform4 c_tevepad_range
instance ITObject TEvePad where
  draw = xform1 c_tevepad_draw
  findObject = xform1 c_tevepad_findobject
  getName = xform0 c_tevepad_getname
  isA = xform0 c_tevepad_isa
  isFolder = xform0 c_tevepad_isfolder
  isEqual = xform1 c_tevepad_isequal
  isSortable = xform0 c_tevepad_issortable
  paint = xform1 c_tevepad_paint
  printObj = xform1 c_tevepad_printobj
  recursiveRemove = xform1 c_tevepad_recursiveremove
  saveAs = xform2 c_tevepad_saveas
  useCurrentStyle = xform0 c_tevepad_usecurrentstyle
  write = xform3 c_tevepad_write
instance ITAttLine TEvePad where
  getLineColor = xform0 c_tevepad_getlinecolor
  getLineStyle = xform0 c_tevepad_getlinestyle
  getLineWidth = xform0 c_tevepad_getlinewidth
  resetAttLine = xform1 c_tevepad_resetattline
  setLineAttributes = xform0 c_tevepad_setlineattributes
  setLineColor = xform1 c_tevepad_setlinecolor
  setLineStyle = xform1 c_tevepad_setlinestyle
  setLineWidth = xform1 c_tevepad_setlinewidth
instance ITAttFill TEvePad where
  setFillColor = xform1 c_tevepad_setfillcolor
  setFillStyle = xform1 c_tevepad_setfillstyle
instance ITAttPad TEvePad where
  resetAttPad = xform1 c_tevepad_resetattpad
  setBottomMargin = xform1 c_tevepad_setbottommargin
  setLeftMargin = xform1 c_tevepad_setleftmargin
  setRightMargin = xform1 c_tevepad_setrightmargin
  setTopMargin = xform1 c_tevepad_settopmargin
  setMargin = xform4 c_tevepad_setmargin
  setAfile = xform1 c_tevepad_setafile
  setXfile = xform1 c_tevepad_setxfile
  setYfile = xform1 c_tevepad_setyfile
  setAstat = xform1 c_tevepad_setastat
  setXstat = xform1 c_tevepad_setxstat
  setYstat = xform1 c_tevepad_setystat
instance ITQObject TEvePad where
instance IDeletable TEvePad where
  delete = xform0 c_tevepad_delete

instance ITEvePad (Exist TEvePad) where

instance ITPad (Exist TEvePad) where

instance ITVirtualPad (Exist TEvePad) where
  cd (ETEvePad x) = cd x
  getFrame (ETEvePad x) = getFrame x
  modified (ETEvePad x) = modified x
  range (ETEvePad x) = range x
instance ITObject (Exist TEvePad) where
  draw (ETEvePad x) = draw x
  findObject (ETEvePad x) = findObject x
  getName (ETEvePad x) = getName x
  isA (ETEvePad x) = isA x
  isFolder (ETEvePad x) = isFolder x
  isEqual (ETEvePad x) = isEqual x
  isSortable (ETEvePad x) = isSortable x
  paint (ETEvePad x) = paint x
  printObj (ETEvePad x) = printObj x
  recursiveRemove (ETEvePad x) = recursiveRemove x
  saveAs (ETEvePad x) = saveAs x
  useCurrentStyle (ETEvePad x) = useCurrentStyle x
  write (ETEvePad x) = write x
instance ITAttLine (Exist TEvePad) where
  getLineColor (ETEvePad x) = getLineColor x
  getLineStyle (ETEvePad x) = getLineStyle x
  getLineWidth (ETEvePad x) = getLineWidth x
  resetAttLine (ETEvePad x) = resetAttLine x
  setLineAttributes (ETEvePad x) = setLineAttributes x
  setLineColor (ETEvePad x) = setLineColor x
  setLineStyle (ETEvePad x) = setLineStyle x
  setLineWidth (ETEvePad x) = setLineWidth x
instance ITAttFill (Exist TEvePad) where
  setFillColor (ETEvePad x) = setFillColor x
  setFillStyle (ETEvePad x) = setFillStyle x
instance ITAttPad (Exist TEvePad) where
  resetAttPad (ETEvePad x) = resetAttPad x
  setBottomMargin (ETEvePad x) = setBottomMargin x
  setLeftMargin (ETEvePad x) = setLeftMargin x
  setRightMargin (ETEvePad x) = setRightMargin x
  setTopMargin (ETEvePad x) = setTopMargin x
  setMargin (ETEvePad x) = setMargin x
  setAfile (ETEvePad x) = setAfile x
  setXfile (ETEvePad x) = setXfile x
  setYfile (ETEvePad x) = setYfile x
  setAstat (ETEvePad x) = setAstat x
  setXstat (ETEvePad x) = setXstat x
  setYstat (ETEvePad x) = setYstat x
instance ITQObject (Exist TEvePad) where

instance IDeletable (Exist TEvePad) where
  delete (ETEvePad x) = delete x





instance FPtr (Exist TEvePad) where
  type Raw (Exist TEvePad) = RawTEvePad
  get_fptr (ETEvePad obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETEvePad (cast_fptr_to_obj (fptr :: ForeignPtr RawTEvePad) :: TEvePad)
