{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TGaxis.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TGaxis.RawType
import HROOT.Class.TLine.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTGaxis.h"

foreign import ccall "HROOTTGaxis.h TGaxis_DrawLine" c_tgaxis_drawline 
  :: (Ptr RawTGaxis) -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTLine)
foreign import ccall "HROOTTGaxis.h TGaxis_DrawLineNDC" c_tgaxis_drawlinendc 
  :: (Ptr RawTGaxis) -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTLine)
foreign import ccall "HROOTTGaxis.h TGaxis_PaintLine" c_tgaxis_paintline 
  :: (Ptr RawTGaxis) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_PaintLineNDC" c_tgaxis_paintlinendc 
  :: (Ptr RawTGaxis) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetX1" c_tgaxis_setx1 
  :: (Ptr RawTGaxis) -> CDouble -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetX2" c_tgaxis_setx2 
  :: (Ptr RawTGaxis) -> CDouble -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetY1" c_tgaxis_sety1 
  :: (Ptr RawTGaxis) -> CDouble -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetY2" c_tgaxis_sety2 
  :: (Ptr RawTGaxis) -> CDouble -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_GetTextAlign" c_tgaxis_gettextalign 
  :: (Ptr RawTGaxis) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_GetTextAngle" c_tgaxis_gettextangle 
  :: (Ptr RawTGaxis) -> IO CDouble
foreign import ccall "HROOTTGaxis.h TGaxis_GetTextColor" c_tgaxis_gettextcolor 
  :: (Ptr RawTGaxis) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_GetTextFont" c_tgaxis_gettextfont 
  :: (Ptr RawTGaxis) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_GetTextSize" c_tgaxis_gettextsize 
  :: (Ptr RawTGaxis) -> IO CDouble
foreign import ccall "HROOTTGaxis.h TGaxis_ResetAttText" c_tgaxis_resetatttext 
  :: (Ptr RawTGaxis) -> CString -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetTextAttributes" c_tgaxis_settextattributes 
  :: (Ptr RawTGaxis) -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetTextAlign" c_tgaxis_settextalign 
  :: (Ptr RawTGaxis) -> CInt -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetTextAngle" c_tgaxis_settextangle 
  :: (Ptr RawTGaxis) -> CDouble -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetTextColor" c_tgaxis_settextcolor 
  :: (Ptr RawTGaxis) -> CInt -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetTextFont" c_tgaxis_settextfont 
  :: (Ptr RawTGaxis) -> CInt -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetTextSize" c_tgaxis_settextsize 
  :: (Ptr RawTGaxis) -> CDouble -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetTextSizePixels" c_tgaxis_settextsizepixels 
  :: (Ptr RawTGaxis) -> CInt -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_Draw" c_tgaxis_draw 
  :: (Ptr RawTGaxis) -> CString -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_FindObject" c_tgaxis_findobject 
  :: (Ptr RawTGaxis) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTGaxis.h TGaxis_GetName" c_tgaxis_getname 
  :: (Ptr RawTGaxis) -> IO CString
foreign import ccall "HROOTTGaxis.h TGaxis_IsA" c_tgaxis_isa 
  :: (Ptr RawTGaxis) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTGaxis.h TGaxis_IsFolder" c_tgaxis_isfolder 
  :: (Ptr RawTGaxis) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_IsEqual" c_tgaxis_isequal 
  :: (Ptr RawTGaxis) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_IsSortable" c_tgaxis_issortable 
  :: (Ptr RawTGaxis) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_Paint" c_tgaxis_paint 
  :: (Ptr RawTGaxis) -> CString -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_printObj" c_tgaxis_printobj 
  :: (Ptr RawTGaxis) -> CString -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_RecursiveRemove" c_tgaxis_recursiveremove 
  :: (Ptr RawTGaxis) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SaveAs" c_tgaxis_saveas 
  :: (Ptr RawTGaxis) -> CString -> CString -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_UseCurrentStyle" c_tgaxis_usecurrentstyle 
  :: (Ptr RawTGaxis) -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_Write" c_tgaxis_write 
  :: (Ptr RawTGaxis) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_GetLineColor" c_tgaxis_getlinecolor 
  :: (Ptr RawTGaxis) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_GetLineStyle" c_tgaxis_getlinestyle 
  :: (Ptr RawTGaxis) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_GetLineWidth" c_tgaxis_getlinewidth 
  :: (Ptr RawTGaxis) -> IO CInt
foreign import ccall "HROOTTGaxis.h TGaxis_ResetAttLine" c_tgaxis_resetattline 
  :: (Ptr RawTGaxis) -> CString -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetLineAttributes" c_tgaxis_setlineattributes 
  :: (Ptr RawTGaxis) -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetLineColor" c_tgaxis_setlinecolor 
  :: (Ptr RawTGaxis) -> CInt -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetLineStyle" c_tgaxis_setlinestyle 
  :: (Ptr RawTGaxis) -> CInt -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_SetLineWidth" c_tgaxis_setlinewidth 
  :: (Ptr RawTGaxis) -> CInt -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_delete" c_tgaxis_delete 
  :: (Ptr RawTGaxis) -> IO ()
foreign import ccall "HROOTTGaxis.h TGaxis_newTGaxis" c_tgaxis_newtgaxis 
  :: CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> CInt -> CString -> CDouble -> IO (Ptr RawTGaxis)

