{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TGraphPolar.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TGraphPolar.RawType
import HROOT.Class.TF1.RawType
import HROOT.Class.TH1F.RawType
import HROOT.Class.TList.RawType
import HROOT.Class.TAxis.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTGraphPolar.h"

foreign import ccall "HROOTTGraphPolar.h TGraphPolar_Apply" c_tgraphpolar_apply 
  :: (Ptr RawTGraphPolar) -> (Ptr RawTF1) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_Chisquare" c_tgraphpolar_chisquare 
  :: (Ptr RawTGraphPolar) -> (Ptr RawTF1) -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_DrawGraph" c_tgraphpolar_drawgraph 
  :: (Ptr RawTGraphPolar) -> CInt -> (Ptr CDouble) -> (Ptr CDouble) -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_drawPanelTGraph" c_tgraphpolar_drawpaneltgraph 
  :: (Ptr RawTGraphPolar) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_Expand" c_tgraphpolar_expand 
  :: (Ptr RawTGraphPolar) -> CInt -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_FitPanelTGraph" c_tgraphpolar_fitpaneltgraph 
  :: (Ptr RawTGraphPolar) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_getCorrelationFactorTGraph" c_tgraphpolar_getcorrelationfactortgraph 
  :: (Ptr RawTGraphPolar) -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_getCovarianceTGraph" c_tgraphpolar_getcovariancetgraph 
  :: (Ptr RawTGraphPolar) -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_getMeanTGraph" c_tgraphpolar_getmeantgraph 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_getRMSTGraph" c_tgraphpolar_getrmstgraph 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetErrorX" c_tgraphpolar_geterrorx 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetErrorY" c_tgraphpolar_geterrory 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetErrorXhigh" c_tgraphpolar_geterrorxhigh 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetErrorXlow" c_tgraphpolar_geterrorxlow 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetErrorYhigh" c_tgraphpolar_geterroryhigh 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetErrorYlow" c_tgraphpolar_geterrorylow 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_InitExpo" c_tgraphpolar_initexpo 
  :: (Ptr RawTGraphPolar) -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_InitGaus" c_tgraphpolar_initgaus 
  :: (Ptr RawTGraphPolar) -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_InitPolynom" c_tgraphpolar_initpolynom 
  :: (Ptr RawTGraphPolar) -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_InsertPoint" c_tgraphpolar_insertpoint 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_integralTGraph" c_tgraphpolar_integraltgraph 
  :: (Ptr RawTGraphPolar) -> CInt -> CInt -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_IsEditable" c_tgraphpolar_iseditable 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_isInsideTGraph" c_tgraphpolar_isinsidetgraph 
  :: (Ptr RawTGraphPolar) -> CDouble -> CDouble -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_LeastSquareFit" c_tgraphpolar_leastsquarefit 
  :: (Ptr RawTGraphPolar) -> CInt -> (Ptr CDouble) -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_PaintStats" c_tgraphpolar_paintstats 
  :: (Ptr RawTGraphPolar) -> (Ptr RawTF1) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_RemovePoint" c_tgraphpolar_removepoint 
  :: (Ptr RawTGraphPolar) -> CInt -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetEditable" c_tgraphpolar_seteditable 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetHistogram" c_tgraphpolar_sethistogram 
  :: (Ptr RawTGraphPolar) -> (Ptr RawTH1F) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_setMaximumTGraph" c_tgraphpolar_setmaximumtgraph 
  :: (Ptr RawTGraphPolar) -> CDouble -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_setMinimumTGraph" c_tgraphpolar_setminimumtgraph 
  :: (Ptr RawTGraphPolar) -> CDouble -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_Set" c_tgraphpolar_set 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetPoint" c_tgraphpolar_setpoint 
  :: (Ptr RawTGraphPolar) -> CInt -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetName" c_tgraphpolar_setname 
  :: (Ptr RawTGraphPolar) -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetNameTitle" c_tgraphpolar_setnametitle 
  :: (Ptr RawTGraphPolar) -> CString -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetTitle" c_tgraphpolar_settitle 
  :: (Ptr RawTGraphPolar) -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetLineColor" c_tgraphpolar_getlinecolor 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetLineStyle" c_tgraphpolar_getlinestyle 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetLineWidth" c_tgraphpolar_getlinewidth 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_ResetAttLine" c_tgraphpolar_resetattline 
  :: (Ptr RawTGraphPolar) -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetLineAttributes" c_tgraphpolar_setlineattributes 
  :: (Ptr RawTGraphPolar) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetLineColor" c_tgraphpolar_setlinecolor 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetLineStyle" c_tgraphpolar_setlinestyle 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetLineWidth" c_tgraphpolar_setlinewidth 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetFillColor" c_tgraphpolar_setfillcolor 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetFillStyle" c_tgraphpolar_setfillstyle 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetMarkerColor" c_tgraphpolar_getmarkercolor 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetMarkerStyle" c_tgraphpolar_getmarkerstyle 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetMarkerSize" c_tgraphpolar_getmarkersize 
  :: (Ptr RawTGraphPolar) -> IO CDouble
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_ResetAttMarker" c_tgraphpolar_resetattmarker 
  :: (Ptr RawTGraphPolar) -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetMarkerAttributes" c_tgraphpolar_setmarkerattributes 
  :: (Ptr RawTGraphPolar) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetMarkerColor" c_tgraphpolar_setmarkercolor 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetMarkerStyle" c_tgraphpolar_setmarkerstyle 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SetMarkerSize" c_tgraphpolar_setmarkersize 
  :: (Ptr RawTGraphPolar) -> CInt -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_Draw" c_tgraphpolar_draw 
  :: (Ptr RawTGraphPolar) -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_FindObject" c_tgraphpolar_findobject 
  :: (Ptr RawTGraphPolar) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_GetName" c_tgraphpolar_getname 
  :: (Ptr RawTGraphPolar) -> IO CString
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_IsA" c_tgraphpolar_isa 
  :: (Ptr RawTGraphPolar) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_IsFolder" c_tgraphpolar_isfolder 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_IsEqual" c_tgraphpolar_isequal 
  :: (Ptr RawTGraphPolar) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_IsSortable" c_tgraphpolar_issortable 
  :: (Ptr RawTGraphPolar) -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_Paint" c_tgraphpolar_paint 
  :: (Ptr RawTGraphPolar) -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_printObj" c_tgraphpolar_printobj 
  :: (Ptr RawTGraphPolar) -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_RecursiveRemove" c_tgraphpolar_recursiveremove 
  :: (Ptr RawTGraphPolar) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_SaveAs" c_tgraphpolar_saveas 
  :: (Ptr RawTGraphPolar) -> CString -> CString -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_UseCurrentStyle" c_tgraphpolar_usecurrentstyle 
  :: (Ptr RawTGraphPolar) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_Write" c_tgraphpolar_write 
  :: (Ptr RawTGraphPolar) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_delete" c_tgraphpolar_delete 
  :: (Ptr RawTGraphPolar) -> IO ()
foreign import ccall "HROOTTGraphPolar.h TGraphPolar_newTGraphPolar" c_tgraphpolar_newtgraphpolar 
  :: CInt -> (Ptr CDouble) -> (Ptr CDouble) -> (Ptr CDouble) -> (Ptr CDouble) -> IO (Ptr RawTGraphPolar)

