{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.THStack.Implementation where


import HROOT.TypeCast

import HROOT.Class.THStack.RawType
import HROOT.Class.THStack.FFI
import HROOT.Class.THStack.Interface
import HROOT.Class.THStack.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TNamed.RawType
import HROOT.Class.TNamed.Cast
import HROOT.Class.TNamed.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITHStack THStack where
instance ITNamed THStack where
  setName = xform1 c_thstack_setname
  setNameTitle = xform2 c_thstack_setnametitle
  setTitle = xform1 c_thstack_settitle
instance ITObject THStack where
  draw = xform1 c_thstack_draw
  findObject = xform1 c_thstack_findobject
  getName = xform0 c_thstack_getname
  isA = xform0 c_thstack_isa
  isFolder = xform0 c_thstack_isfolder
  isEqual = xform1 c_thstack_isequal
  isSortable = xform0 c_thstack_issortable
  paint = xform1 c_thstack_paint
  printObj = xform1 c_thstack_printobj
  recursiveRemove = xform1 c_thstack_recursiveremove
  saveAs = xform2 c_thstack_saveas
  useCurrentStyle = xform0 c_thstack_usecurrentstyle
  write = xform3 c_thstack_write
instance IDeletable THStack where
  delete = xform0 c_thstack_delete

instance ITHStack (Exist THStack) where

instance ITNamed (Exist THStack) where
  setName (ETHStack x) = setName x
  setNameTitle (ETHStack x) = setNameTitle x
  setTitle (ETHStack x) = setTitle x
instance ITObject (Exist THStack) where
  draw (ETHStack x) = draw x
  findObject (ETHStack x) = findObject x
  getName (ETHStack x) = getName x
  isA (ETHStack x) = isA x
  isFolder (ETHStack x) = isFolder x
  isEqual (ETHStack x) = isEqual x
  isSortable (ETHStack x) = isSortable x
  paint (ETHStack x) = paint x
  printObj (ETHStack x) = printObj x
  recursiveRemove (ETHStack x) = recursiveRemove x
  saveAs (ETHStack x) = saveAs x
  useCurrentStyle (ETHStack x) = useCurrentStyle x
  write (ETHStack x) = write x
instance IDeletable (Exist THStack) where
  delete (ETHStack x) = delete x


newTHStack :: String -> String -> IO THStack
newTHStack = xform1 c_thstack_newthstack



instance FPtr (Exist THStack) where
  type Raw (Exist THStack) = RawTHStack
  get_fptr (ETHStack obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETHStack (cast_fptr_to_obj (fptr :: ForeignPtr RawTHStack) :: THStack)
