{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TInspectCanvas.Implementation where


import HROOT.TypeCast

import HROOT.Class.TInspectCanvas.RawType
import HROOT.Class.TInspectCanvas.FFI
import HROOT.Class.TInspectCanvas.Interface
import HROOT.Class.TInspectCanvas.Cast
import HROOT.Class.TFrame.RawType
import HROOT.Class.TFrame.Cast
import HROOT.Class.TFrame.Interface
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TCanvas.RawType
import HROOT.Class.TCanvas.Cast
import HROOT.Class.TCanvas.Interface
import HROOT.Class.TAttText.RawType
import HROOT.Class.TAttText.Cast
import HROOT.Class.TAttText.Interface
import HROOT.Class.TPad.RawType
import HROOT.Class.TPad.Cast
import HROOT.Class.TPad.Interface
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TVirtualPad.Cast
import HROOT.Class.TVirtualPad.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttPad.RawType
import HROOT.Class.TAttPad.Cast
import HROOT.Class.TAttPad.Interface
import HROOT.Class.TQObject.RawType
import HROOT.Class.TQObject.Cast
import HROOT.Class.TQObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITInspectCanvas TInspectCanvas where
instance ITCanvas TInspectCanvas where
instance ITAttText TInspectCanvas where
  getTextAlign = xform0 c_tinspectcanvas_gettextalign
  getTextAngle = xform0 c_tinspectcanvas_gettextangle
  getTextColor = xform0 c_tinspectcanvas_gettextcolor
  getTextFont = xform0 c_tinspectcanvas_gettextfont
  getTextSize = xform0 c_tinspectcanvas_gettextsize
  resetAttText = xform1 c_tinspectcanvas_resetatttext
  setTextAttributes = xform0 c_tinspectcanvas_settextattributes
  setTextAlign = xform1 c_tinspectcanvas_settextalign
  setTextAngle = xform1 c_tinspectcanvas_settextangle
  setTextColor = xform1 c_tinspectcanvas_settextcolor
  setTextFont = xform1 c_tinspectcanvas_settextfont
  setTextSize = xform1 c_tinspectcanvas_settextsize
  setTextSizePixels = xform1 c_tinspectcanvas_settextsizepixels
instance ITPad TInspectCanvas where
instance ITVirtualPad TInspectCanvas where
  cd = xform1 c_tinspectcanvas_cd
  getFrame = xform0 c_tinspectcanvas_getframe
  modified = xform1 c_tinspectcanvas_modified
  range = xform4 c_tinspectcanvas_range
instance ITObject TInspectCanvas where
  draw = xform1 c_tinspectcanvas_draw
  findObject = xform1 c_tinspectcanvas_findobject
  getName = xform0 c_tinspectcanvas_getname
  isA = xform0 c_tinspectcanvas_isa
  isFolder = xform0 c_tinspectcanvas_isfolder
  isEqual = xform1 c_tinspectcanvas_isequal
  isSortable = xform0 c_tinspectcanvas_issortable
  paint = xform1 c_tinspectcanvas_paint
  printObj = xform1 c_tinspectcanvas_printobj
  recursiveRemove = xform1 c_tinspectcanvas_recursiveremove
  saveAs = xform2 c_tinspectcanvas_saveas
  useCurrentStyle = xform0 c_tinspectcanvas_usecurrentstyle
  write = xform3 c_tinspectcanvas_write
instance ITAttLine TInspectCanvas where
  getLineColor = xform0 c_tinspectcanvas_getlinecolor
  getLineStyle = xform0 c_tinspectcanvas_getlinestyle
  getLineWidth = xform0 c_tinspectcanvas_getlinewidth
  resetAttLine = xform1 c_tinspectcanvas_resetattline
  setLineAttributes = xform0 c_tinspectcanvas_setlineattributes
  setLineColor = xform1 c_tinspectcanvas_setlinecolor
  setLineStyle = xform1 c_tinspectcanvas_setlinestyle
  setLineWidth = xform1 c_tinspectcanvas_setlinewidth
instance ITAttFill TInspectCanvas where
  setFillColor = xform1 c_tinspectcanvas_setfillcolor
  setFillStyle = xform1 c_tinspectcanvas_setfillstyle
instance ITAttPad TInspectCanvas where
  resetAttPad = xform1 c_tinspectcanvas_resetattpad
  setBottomMargin = xform1 c_tinspectcanvas_setbottommargin
  setLeftMargin = xform1 c_tinspectcanvas_setleftmargin
  setRightMargin = xform1 c_tinspectcanvas_setrightmargin
  setTopMargin = xform1 c_tinspectcanvas_settopmargin
  setMargin = xform4 c_tinspectcanvas_setmargin
  setAfile = xform1 c_tinspectcanvas_setafile
  setXfile = xform1 c_tinspectcanvas_setxfile
  setYfile = xform1 c_tinspectcanvas_setyfile
  setAstat = xform1 c_tinspectcanvas_setastat
  setXstat = xform1 c_tinspectcanvas_setxstat
  setYstat = xform1 c_tinspectcanvas_setystat
instance ITQObject TInspectCanvas where
instance IDeletable TInspectCanvas where
  delete = xform0 c_tinspectcanvas_delete

instance ITInspectCanvas (Exist TInspectCanvas) where

instance ITCanvas (Exist TInspectCanvas) where

instance ITAttText (Exist TInspectCanvas) where
  getTextAlign (ETInspectCanvas x) = getTextAlign x
  getTextAngle (ETInspectCanvas x) = getTextAngle x
  getTextColor (ETInspectCanvas x) = getTextColor x
  getTextFont (ETInspectCanvas x) = getTextFont x
  getTextSize (ETInspectCanvas x) = getTextSize x
  resetAttText (ETInspectCanvas x) = resetAttText x
  setTextAttributes (ETInspectCanvas x) = setTextAttributes x
  setTextAlign (ETInspectCanvas x) = setTextAlign x
  setTextAngle (ETInspectCanvas x) = setTextAngle x
  setTextColor (ETInspectCanvas x) = setTextColor x
  setTextFont (ETInspectCanvas x) = setTextFont x
  setTextSize (ETInspectCanvas x) = setTextSize x
  setTextSizePixels (ETInspectCanvas x) = setTextSizePixels x
instance ITPad (Exist TInspectCanvas) where

instance ITVirtualPad (Exist TInspectCanvas) where
  cd (ETInspectCanvas x) = cd x
  getFrame (ETInspectCanvas x) = getFrame x
  modified (ETInspectCanvas x) = modified x
  range (ETInspectCanvas x) = range x
instance ITObject (Exist TInspectCanvas) where
  draw (ETInspectCanvas x) = draw x
  findObject (ETInspectCanvas x) = findObject x
  getName (ETInspectCanvas x) = getName x
  isA (ETInspectCanvas x) = isA x
  isFolder (ETInspectCanvas x) = isFolder x
  isEqual (ETInspectCanvas x) = isEqual x
  isSortable (ETInspectCanvas x) = isSortable x
  paint (ETInspectCanvas x) = paint x
  printObj (ETInspectCanvas x) = printObj x
  recursiveRemove (ETInspectCanvas x) = recursiveRemove x
  saveAs (ETInspectCanvas x) = saveAs x
  useCurrentStyle (ETInspectCanvas x) = useCurrentStyle x
  write (ETInspectCanvas x) = write x
instance ITAttLine (Exist TInspectCanvas) where
  getLineColor (ETInspectCanvas x) = getLineColor x
  getLineStyle (ETInspectCanvas x) = getLineStyle x
  getLineWidth (ETInspectCanvas x) = getLineWidth x
  resetAttLine (ETInspectCanvas x) = resetAttLine x
  setLineAttributes (ETInspectCanvas x) = setLineAttributes x
  setLineColor (ETInspectCanvas x) = setLineColor x
  setLineStyle (ETInspectCanvas x) = setLineStyle x
  setLineWidth (ETInspectCanvas x) = setLineWidth x
instance ITAttFill (Exist TInspectCanvas) where
  setFillColor (ETInspectCanvas x) = setFillColor x
  setFillStyle (ETInspectCanvas x) = setFillStyle x
instance ITAttPad (Exist TInspectCanvas) where
  resetAttPad (ETInspectCanvas x) = resetAttPad x
  setBottomMargin (ETInspectCanvas x) = setBottomMargin x
  setLeftMargin (ETInspectCanvas x) = setLeftMargin x
  setRightMargin (ETInspectCanvas x) = setRightMargin x
  setTopMargin (ETInspectCanvas x) = setTopMargin x
  setMargin (ETInspectCanvas x) = setMargin x
  setAfile (ETInspectCanvas x) = setAfile x
  setXfile (ETInspectCanvas x) = setXfile x
  setYfile (ETInspectCanvas x) = setYfile x
  setAstat (ETInspectCanvas x) = setAstat x
  setXstat (ETInspectCanvas x) = setXstat x
  setYstat (ETInspectCanvas x) = setYstat x
instance ITQObject (Exist TInspectCanvas) where

instance IDeletable (Exist TInspectCanvas) where
  delete (ETInspectCanvas x) = delete x





instance FPtr (Exist TInspectCanvas) where
  type Raw (Exist TInspectCanvas) = RawTInspectCanvas
  get_fptr (ETInspectCanvas obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETInspectCanvas (cast_fptr_to_obj (fptr :: ForeignPtr RawTInspectCanvas) :: TInspectCanvas)
