{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TLatex.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TLatex.RawType
import HROOT.Class.TText.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTLatex.h"

foreign import ccall "HROOTTLatex.h TLatex_DrawText" c_tlatex_drawtext 
  :: (Ptr RawTLatex) -> CDouble -> CDouble -> CString -> IO (Ptr RawTText)
foreign import ccall "HROOTTLatex.h TLatex_DrawTextNDC" c_tlatex_drawtextndc 
  :: (Ptr RawTLatex) -> CDouble -> CDouble -> CString -> IO (Ptr RawTText)
foreign import ccall "HROOTTLatex.h TLatex_GetControlBox" c_tlatex_getcontrolbox 
  :: (Ptr RawTLatex) -> CInt -> CInt -> CInt -> (Ptr CInt) -> (Ptr CInt) -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetText" c_tlatex_settext 
  :: (Ptr RawTLatex) -> CDouble -> CDouble -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_GetLineColor" c_tlatex_getlinecolor 
  :: (Ptr RawTLatex) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_GetLineStyle" c_tlatex_getlinestyle 
  :: (Ptr RawTLatex) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_GetLineWidth" c_tlatex_getlinewidth 
  :: (Ptr RawTLatex) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_ResetAttLine" c_tlatex_resetattline 
  :: (Ptr RawTLatex) -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetLineAttributes" c_tlatex_setlineattributes 
  :: (Ptr RawTLatex) -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetLineColor" c_tlatex_setlinecolor 
  :: (Ptr RawTLatex) -> CInt -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetLineStyle" c_tlatex_setlinestyle 
  :: (Ptr RawTLatex) -> CInt -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetLineWidth" c_tlatex_setlinewidth 
  :: (Ptr RawTLatex) -> CInt -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetName" c_tlatex_setname 
  :: (Ptr RawTLatex) -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetNameTitle" c_tlatex_setnametitle 
  :: (Ptr RawTLatex) -> CString -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetTitle" c_tlatex_settitle 
  :: (Ptr RawTLatex) -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_GetTextAlign" c_tlatex_gettextalign 
  :: (Ptr RawTLatex) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_GetTextAngle" c_tlatex_gettextangle 
  :: (Ptr RawTLatex) -> IO CDouble
foreign import ccall "HROOTTLatex.h TLatex_GetTextColor" c_tlatex_gettextcolor 
  :: (Ptr RawTLatex) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_GetTextFont" c_tlatex_gettextfont 
  :: (Ptr RawTLatex) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_GetTextSize" c_tlatex_gettextsize 
  :: (Ptr RawTLatex) -> IO CDouble
foreign import ccall "HROOTTLatex.h TLatex_ResetAttText" c_tlatex_resetatttext 
  :: (Ptr RawTLatex) -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetTextAttributes" c_tlatex_settextattributes 
  :: (Ptr RawTLatex) -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetTextAlign" c_tlatex_settextalign 
  :: (Ptr RawTLatex) -> CInt -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetTextAngle" c_tlatex_settextangle 
  :: (Ptr RawTLatex) -> CDouble -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetTextColor" c_tlatex_settextcolor 
  :: (Ptr RawTLatex) -> CInt -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetTextFont" c_tlatex_settextfont 
  :: (Ptr RawTLatex) -> CInt -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetTextSize" c_tlatex_settextsize 
  :: (Ptr RawTLatex) -> CDouble -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SetTextSizePixels" c_tlatex_settextsizepixels 
  :: (Ptr RawTLatex) -> CInt -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_Draw" c_tlatex_draw 
  :: (Ptr RawTLatex) -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_FindObject" c_tlatex_findobject 
  :: (Ptr RawTLatex) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTLatex.h TLatex_GetName" c_tlatex_getname 
  :: (Ptr RawTLatex) -> IO CString
foreign import ccall "HROOTTLatex.h TLatex_IsA" c_tlatex_isa 
  :: (Ptr RawTLatex) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTLatex.h TLatex_IsFolder" c_tlatex_isfolder 
  :: (Ptr RawTLatex) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_IsEqual" c_tlatex_isequal 
  :: (Ptr RawTLatex) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_IsSortable" c_tlatex_issortable 
  :: (Ptr RawTLatex) -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_Paint" c_tlatex_paint 
  :: (Ptr RawTLatex) -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_printObj" c_tlatex_printobj 
  :: (Ptr RawTLatex) -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_RecursiveRemove" c_tlatex_recursiveremove 
  :: (Ptr RawTLatex) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_SaveAs" c_tlatex_saveas 
  :: (Ptr RawTLatex) -> CString -> CString -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_UseCurrentStyle" c_tlatex_usecurrentstyle 
  :: (Ptr RawTLatex) -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_Write" c_tlatex_write 
  :: (Ptr RawTLatex) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTLatex.h TLatex_delete" c_tlatex_delete 
  :: (Ptr RawTLatex) -> IO ()
foreign import ccall "HROOTTLatex.h TLatex_newTLatex" c_tlatex_newtlatex 
  :: CDouble -> CDouble -> CString -> IO (Ptr RawTLatex)
foreign import ccall "HROOTTLatex.h TLatex_tLatexDrawLatex" c_tlatex_tlatexdrawlatex 
  :: (Ptr RawTLatex) -> CDouble -> CDouble -> CString -> IO (Ptr RawTLatex)

