{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TLatex.Implementation where


import HROOT.TypeCast

import HROOT.Class.TLatex.RawType
import HROOT.Class.TLatex.FFI
import HROOT.Class.TLatex.Interface
import HROOT.Class.TLatex.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TText.RawType
import HROOT.Class.TText.Cast
import HROOT.Class.TText.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TNamed.RawType
import HROOT.Class.TNamed.Cast
import HROOT.Class.TNamed.Interface
import HROOT.Class.TAttText.RawType
import HROOT.Class.TAttText.Cast
import HROOT.Class.TAttText.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITLatex TLatex where
instance ITText TLatex where
  drawText = xform3 c_tlatex_drawtext
  drawTextNDC = xform3 c_tlatex_drawtextndc
  getControlBox = xform5 c_tlatex_getcontrolbox
  setText = xform3 c_tlatex_settext
instance ITAttLine TLatex where
  getLineColor = xform0 c_tlatex_getlinecolor
  getLineStyle = xform0 c_tlatex_getlinestyle
  getLineWidth = xform0 c_tlatex_getlinewidth
  resetAttLine = xform1 c_tlatex_resetattline
  setLineAttributes = xform0 c_tlatex_setlineattributes
  setLineColor = xform1 c_tlatex_setlinecolor
  setLineStyle = xform1 c_tlatex_setlinestyle
  setLineWidth = xform1 c_tlatex_setlinewidth
instance ITNamed TLatex where
  setName = xform1 c_tlatex_setname
  setNameTitle = xform2 c_tlatex_setnametitle
  setTitle = xform1 c_tlatex_settitle
instance ITAttText TLatex where
  getTextAlign = xform0 c_tlatex_gettextalign
  getTextAngle = xform0 c_tlatex_gettextangle
  getTextColor = xform0 c_tlatex_gettextcolor
  getTextFont = xform0 c_tlatex_gettextfont
  getTextSize = xform0 c_tlatex_gettextsize
  resetAttText = xform1 c_tlatex_resetatttext
  setTextAttributes = xform0 c_tlatex_settextattributes
  setTextAlign = xform1 c_tlatex_settextalign
  setTextAngle = xform1 c_tlatex_settextangle
  setTextColor = xform1 c_tlatex_settextcolor
  setTextFont = xform1 c_tlatex_settextfont
  setTextSize = xform1 c_tlatex_settextsize
  setTextSizePixels = xform1 c_tlatex_settextsizepixels
instance ITObject TLatex where
  draw = xform1 c_tlatex_draw
  findObject = xform1 c_tlatex_findobject
  getName = xform0 c_tlatex_getname
  isA = xform0 c_tlatex_isa
  isFolder = xform0 c_tlatex_isfolder
  isEqual = xform1 c_tlatex_isequal
  isSortable = xform0 c_tlatex_issortable
  paint = xform1 c_tlatex_paint
  printObj = xform1 c_tlatex_printobj
  recursiveRemove = xform1 c_tlatex_recursiveremove
  saveAs = xform2 c_tlatex_saveas
  useCurrentStyle = xform0 c_tlatex_usecurrentstyle
  write = xform3 c_tlatex_write
instance IDeletable TLatex where
  delete = xform0 c_tlatex_delete

instance ITLatex (Exist TLatex) where

instance ITText (Exist TLatex) where
  drawText (ETLatex x) = drawText x
  drawTextNDC (ETLatex x) = drawTextNDC x
  getControlBox (ETLatex x) = getControlBox x
  setText (ETLatex x) = setText x
instance ITAttLine (Exist TLatex) where
  getLineColor (ETLatex x) = getLineColor x
  getLineStyle (ETLatex x) = getLineStyle x
  getLineWidth (ETLatex x) = getLineWidth x
  resetAttLine (ETLatex x) = resetAttLine x
  setLineAttributes (ETLatex x) = setLineAttributes x
  setLineColor (ETLatex x) = setLineColor x
  setLineStyle (ETLatex x) = setLineStyle x
  setLineWidth (ETLatex x) = setLineWidth x
instance ITNamed (Exist TLatex) where
  setName (ETLatex x) = setName x
  setNameTitle (ETLatex x) = setNameTitle x
  setTitle (ETLatex x) = setTitle x
instance ITAttText (Exist TLatex) where
  getTextAlign (ETLatex x) = getTextAlign x
  getTextAngle (ETLatex x) = getTextAngle x
  getTextColor (ETLatex x) = getTextColor x
  getTextFont (ETLatex x) = getTextFont x
  getTextSize (ETLatex x) = getTextSize x
  resetAttText (ETLatex x) = resetAttText x
  setTextAttributes (ETLatex x) = setTextAttributes x
  setTextAlign (ETLatex x) = setTextAlign x
  setTextAngle (ETLatex x) = setTextAngle x
  setTextColor (ETLatex x) = setTextColor x
  setTextFont (ETLatex x) = setTextFont x
  setTextSize (ETLatex x) = setTextSize x
  setTextSizePixels (ETLatex x) = setTextSizePixels x
instance ITObject (Exist TLatex) where
  draw (ETLatex x) = draw x
  findObject (ETLatex x) = findObject x
  getName (ETLatex x) = getName x
  isA (ETLatex x) = isA x
  isFolder (ETLatex x) = isFolder x
  isEqual (ETLatex x) = isEqual x
  isSortable (ETLatex x) = isSortable x
  paint (ETLatex x) = paint x
  printObj (ETLatex x) = printObj x
  recursiveRemove (ETLatex x) = recursiveRemove x
  saveAs (ETLatex x) = saveAs x
  useCurrentStyle (ETLatex x) = useCurrentStyle x
  write (ETLatex x) = write x
instance IDeletable (Exist TLatex) where
  delete (ETLatex x) = delete x


newTLatex :: Double -> Double -> String -> IO TLatex
newTLatex = xform2 c_tlatex_newtlatex

tLatexDrawLatex :: TLatex -> Double -> Double -> String -> IO TLatex
tLatexDrawLatex = xform3 c_tlatex_tlatexdrawlatex

instance FPtr (Exist TLatex) where
  type Raw (Exist TLatex) = RawTLatex
  get_fptr (ETLatex obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETLatex (cast_fptr_to_obj (fptr :: ForeignPtr RawTLatex) :: TLatex)
