{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TLegendEntry.Implementation where


import HROOT.TypeCast

import HROOT.Class.TLegendEntry.RawType
import HROOT.Class.TLegendEntry.FFI
import HROOT.Class.TLegendEntry.Interface
import HROOT.Class.TLegendEntry.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttText.RawType
import HROOT.Class.TAttText.Cast
import HROOT.Class.TAttText.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttMarker.RawType
import HROOT.Class.TAttMarker.Cast
import HROOT.Class.TAttMarker.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITLegendEntry TLegendEntry where
instance ITObject TLegendEntry where
  draw = xform1 c_tlegendentry_draw
  findObject = xform1 c_tlegendentry_findobject
  getName = xform0 c_tlegendentry_getname
  isA = xform0 c_tlegendentry_isa
  isFolder = xform0 c_tlegendentry_isfolder
  isEqual = xform1 c_tlegendentry_isequal
  isSortable = xform0 c_tlegendentry_issortable
  paint = xform1 c_tlegendentry_paint
  printObj = xform1 c_tlegendentry_printobj
  recursiveRemove = xform1 c_tlegendentry_recursiveremove
  saveAs = xform2 c_tlegendentry_saveas
  useCurrentStyle = xform0 c_tlegendentry_usecurrentstyle
  write = xform3 c_tlegendentry_write
instance ITAttText TLegendEntry where
  getTextAlign = xform0 c_tlegendentry_gettextalign
  getTextAngle = xform0 c_tlegendentry_gettextangle
  getTextColor = xform0 c_tlegendentry_gettextcolor
  getTextFont = xform0 c_tlegendentry_gettextfont
  getTextSize = xform0 c_tlegendentry_gettextsize
  resetAttText = xform1 c_tlegendentry_resetatttext
  setTextAttributes = xform0 c_tlegendentry_settextattributes
  setTextAlign = xform1 c_tlegendentry_settextalign
  setTextAngle = xform1 c_tlegendentry_settextangle
  setTextColor = xform1 c_tlegendentry_settextcolor
  setTextFont = xform1 c_tlegendentry_settextfont
  setTextSize = xform1 c_tlegendentry_settextsize
  setTextSizePixels = xform1 c_tlegendentry_settextsizepixels
instance ITAttLine TLegendEntry where
  getLineColor = xform0 c_tlegendentry_getlinecolor
  getLineStyle = xform0 c_tlegendentry_getlinestyle
  getLineWidth = xform0 c_tlegendentry_getlinewidth
  resetAttLine = xform1 c_tlegendentry_resetattline
  setLineAttributes = xform0 c_tlegendentry_setlineattributes
  setLineColor = xform1 c_tlegendentry_setlinecolor
  setLineStyle = xform1 c_tlegendentry_setlinestyle
  setLineWidth = xform1 c_tlegendentry_setlinewidth
instance ITAttFill TLegendEntry where
  setFillColor = xform1 c_tlegendentry_setfillcolor
  setFillStyle = xform1 c_tlegendentry_setfillstyle
instance ITAttMarker TLegendEntry where
  getMarkerColor = xform0 c_tlegendentry_getmarkercolor
  getMarkerStyle = xform0 c_tlegendentry_getmarkerstyle
  getMarkerSize = xform0 c_tlegendentry_getmarkersize
  resetAttMarker = xform1 c_tlegendentry_resetattmarker
  setMarkerAttributes = xform0 c_tlegendentry_setmarkerattributes
  setMarkerColor = xform1 c_tlegendentry_setmarkercolor
  setMarkerStyle = xform1 c_tlegendentry_setmarkerstyle
  setMarkerSize = xform1 c_tlegendentry_setmarkersize
instance IDeletable TLegendEntry where
  delete = xform0 c_tlegendentry_delete

instance ITLegendEntry (Exist TLegendEntry) where

instance ITObject (Exist TLegendEntry) where
  draw (ETLegendEntry x) = draw x
  findObject (ETLegendEntry x) = findObject x
  getName (ETLegendEntry x) = getName x
  isA (ETLegendEntry x) = isA x
  isFolder (ETLegendEntry x) = isFolder x
  isEqual (ETLegendEntry x) = isEqual x
  isSortable (ETLegendEntry x) = isSortable x
  paint (ETLegendEntry x) = paint x
  printObj (ETLegendEntry x) = printObj x
  recursiveRemove (ETLegendEntry x) = recursiveRemove x
  saveAs (ETLegendEntry x) = saveAs x
  useCurrentStyle (ETLegendEntry x) = useCurrentStyle x
  write (ETLegendEntry x) = write x
instance ITAttText (Exist TLegendEntry) where
  getTextAlign (ETLegendEntry x) = getTextAlign x
  getTextAngle (ETLegendEntry x) = getTextAngle x
  getTextColor (ETLegendEntry x) = getTextColor x
  getTextFont (ETLegendEntry x) = getTextFont x
  getTextSize (ETLegendEntry x) = getTextSize x
  resetAttText (ETLegendEntry x) = resetAttText x
  setTextAttributes (ETLegendEntry x) = setTextAttributes x
  setTextAlign (ETLegendEntry x) = setTextAlign x
  setTextAngle (ETLegendEntry x) = setTextAngle x
  setTextColor (ETLegendEntry x) = setTextColor x
  setTextFont (ETLegendEntry x) = setTextFont x
  setTextSize (ETLegendEntry x) = setTextSize x
  setTextSizePixels (ETLegendEntry x) = setTextSizePixels x
instance ITAttLine (Exist TLegendEntry) where
  getLineColor (ETLegendEntry x) = getLineColor x
  getLineStyle (ETLegendEntry x) = getLineStyle x
  getLineWidth (ETLegendEntry x) = getLineWidth x
  resetAttLine (ETLegendEntry x) = resetAttLine x
  setLineAttributes (ETLegendEntry x) = setLineAttributes x
  setLineColor (ETLegendEntry x) = setLineColor x
  setLineStyle (ETLegendEntry x) = setLineStyle x
  setLineWidth (ETLegendEntry x) = setLineWidth x
instance ITAttFill (Exist TLegendEntry) where
  setFillColor (ETLegendEntry x) = setFillColor x
  setFillStyle (ETLegendEntry x) = setFillStyle x
instance ITAttMarker (Exist TLegendEntry) where
  getMarkerColor (ETLegendEntry x) = getMarkerColor x
  getMarkerStyle (ETLegendEntry x) = getMarkerStyle x
  getMarkerSize (ETLegendEntry x) = getMarkerSize x
  resetAttMarker (ETLegendEntry x) = resetAttMarker x
  setMarkerAttributes (ETLegendEntry x) = setMarkerAttributes x
  setMarkerColor (ETLegendEntry x) = setMarkerColor x
  setMarkerStyle (ETLegendEntry x) = setMarkerStyle x
  setMarkerSize (ETLegendEntry x) = setMarkerSize x
instance IDeletable (Exist TLegendEntry) where
  delete (ETLegendEntry x) = delete x





instance FPtr (Exist TLegendEntry) where
  type Raw (Exist TLegendEntry) = RawTLegendEntry
  get_fptr (ETLegendEntry obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETLegendEntry (cast_fptr_to_obj (fptr :: ForeignPtr RawTLegendEntry) :: TLegendEntry)
