{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TLine.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TLine.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTLine.h"

foreign import ccall "HROOTTLine.h TLine_Draw" c_tline_draw 
  :: (Ptr RawTLine) -> CString -> IO ()
foreign import ccall "HROOTTLine.h TLine_FindObject" c_tline_findobject 
  :: (Ptr RawTLine) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTLine.h TLine_GetName" c_tline_getname 
  :: (Ptr RawTLine) -> IO CString
foreign import ccall "HROOTTLine.h TLine_IsA" c_tline_isa 
  :: (Ptr RawTLine) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTLine.h TLine_IsFolder" c_tline_isfolder 
  :: (Ptr RawTLine) -> IO CInt
foreign import ccall "HROOTTLine.h TLine_IsEqual" c_tline_isequal 
  :: (Ptr RawTLine) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTLine.h TLine_IsSortable" c_tline_issortable 
  :: (Ptr RawTLine) -> IO CInt
foreign import ccall "HROOTTLine.h TLine_Paint" c_tline_paint 
  :: (Ptr RawTLine) -> CString -> IO ()
foreign import ccall "HROOTTLine.h TLine_printObj" c_tline_printobj 
  :: (Ptr RawTLine) -> CString -> IO ()
foreign import ccall "HROOTTLine.h TLine_RecursiveRemove" c_tline_recursiveremove 
  :: (Ptr RawTLine) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTLine.h TLine_SaveAs" c_tline_saveas 
  :: (Ptr RawTLine) -> CString -> CString -> IO ()
foreign import ccall "HROOTTLine.h TLine_UseCurrentStyle" c_tline_usecurrentstyle 
  :: (Ptr RawTLine) -> IO ()
foreign import ccall "HROOTTLine.h TLine_Write" c_tline_write 
  :: (Ptr RawTLine) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTLine.h TLine_GetLineColor" c_tline_getlinecolor 
  :: (Ptr RawTLine) -> IO CInt
foreign import ccall "HROOTTLine.h TLine_GetLineStyle" c_tline_getlinestyle 
  :: (Ptr RawTLine) -> IO CInt
foreign import ccall "HROOTTLine.h TLine_GetLineWidth" c_tline_getlinewidth 
  :: (Ptr RawTLine) -> IO CInt
foreign import ccall "HROOTTLine.h TLine_ResetAttLine" c_tline_resetattline 
  :: (Ptr RawTLine) -> CString -> IO ()
foreign import ccall "HROOTTLine.h TLine_SetLineAttributes" c_tline_setlineattributes 
  :: (Ptr RawTLine) -> IO ()
foreign import ccall "HROOTTLine.h TLine_SetLineColor" c_tline_setlinecolor 
  :: (Ptr RawTLine) -> CInt -> IO ()
foreign import ccall "HROOTTLine.h TLine_SetLineStyle" c_tline_setlinestyle 
  :: (Ptr RawTLine) -> CInt -> IO ()
foreign import ccall "HROOTTLine.h TLine_SetLineWidth" c_tline_setlinewidth 
  :: (Ptr RawTLine) -> CInt -> IO ()
foreign import ccall "HROOTTLine.h TLine_delete" c_tline_delete 
  :: (Ptr RawTLine) -> IO ()
foreign import ccall "HROOTTLine.h TLine_newTLine" c_tline_newtline 
  :: CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTLine)
foreign import ccall "HROOTTLine.h TLine_DrawLine" c_tline_drawline 
  :: (Ptr RawTLine) -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTLine)
foreign import ccall "HROOTTLine.h TLine_DrawLineNDC" c_tline_drawlinendc 
  :: (Ptr RawTLine) -> CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTLine)
foreign import ccall "HROOTTLine.h TLine_tLineGetX1" c_tline_tlinegetx1 
  :: (Ptr RawTLine) -> IO CDouble
foreign import ccall "HROOTTLine.h TLine_tLineGetX2" c_tline_tlinegetx2 
  :: (Ptr RawTLine) -> IO CDouble
foreign import ccall "HROOTTLine.h TLine_tLineGetY1" c_tline_tlinegety1 
  :: (Ptr RawTLine) -> IO CDouble
foreign import ccall "HROOTTLine.h TLine_tLineGetY2" c_tline_tlinegety2 
  :: (Ptr RawTLine) -> IO CDouble
foreign import ccall "HROOTTLine.h TLine_tLineIsHorizontal" c_tline_tlineishorizontal 
  :: (Ptr RawTLine) -> IO CInt
foreign import ccall "HROOTTLine.h TLine_tLineIsVertical" c_tline_tlineisvertical 
  :: (Ptr RawTLine) -> IO CInt
foreign import ccall "HROOTTLine.h TLine_PaintLine" c_tline_paintline 
  :: (Ptr RawTLine) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTLine.h TLine_PaintLineNDC" c_tline_paintlinendc 
  :: (Ptr RawTLine) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTLine.h TLine_tLineSetHorizontal" c_tline_tlinesethorizontal 
  :: (Ptr RawTLine) -> CInt -> IO ()
foreign import ccall "HROOTTLine.h TLine_tLineSetVertical" c_tline_tlinesetvertical 
  :: (Ptr RawTLine) -> CInt -> IO ()
foreign import ccall "HROOTTLine.h TLine_SetX1" c_tline_setx1 
  :: (Ptr RawTLine) -> CDouble -> IO ()
foreign import ccall "HROOTTLine.h TLine_SetX2" c_tline_setx2 
  :: (Ptr RawTLine) -> CDouble -> IO ()
foreign import ccall "HROOTTLine.h TLine_SetY1" c_tline_sety1 
  :: (Ptr RawTLine) -> CDouble -> IO ()
foreign import ccall "HROOTTLine.h TLine_SetY2" c_tline_sety2 
  :: (Ptr RawTLine) -> CDouble -> IO ()

