{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TLine.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TLine.RawType

import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.Interface


class (ITObject a,ITAttLine a) => ITLine a where

    drawLine :: a -> Double -> Double -> Double -> Double -> IO TLine 

    drawLineNDC :: a -> Double -> Double -> Double -> Double -> IO TLine 

    paintLine :: a -> Double -> Double -> Double -> Double -> IO () 

    paintLineNDC :: a -> Double -> Double -> Double -> Double -> IO () 

    setX1 :: a -> Double -> IO () 

    setX2 :: a -> Double -> IO () 

    setY1 :: a -> Double -> IO () 

    setY2 :: a -> Double -> IO () 

instance Existable TLine where
  data Exist TLine = forall a. (FPtr a, ITLine a) => ETLine a

upcastTLine :: (FPtr a, ITLine a) => a -> TLine
upcastTLine h = let fh = get_fptr h
                    fh2 :: ForeignPtr RawTLine = castForeignPtr fh
                in cast_fptr_to_obj fh2
