{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TObjArray.Implementation where


import HROOT.TypeCast

import HROOT.Class.TObjArray.RawType
import HROOT.Class.TObjArray.FFI
import HROOT.Class.TObjArray.Interface
import HROOT.Class.TObjArray.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TSeqCollection.RawType
import HROOT.Class.TSeqCollection.Cast
import HROOT.Class.TSeqCollection.Interface
import HROOT.Class.TCollection.RawType
import HROOT.Class.TCollection.Cast
import HROOT.Class.TCollection.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITObjArray TObjArray where
instance ITSeqCollection TObjArray where
instance ITCollection TObjArray where
instance ITObject TObjArray where
  draw = xform1 c_tobjarray_draw
  findObject = xform1 c_tobjarray_findobject
  getName = xform0 c_tobjarray_getname
  isA = xform0 c_tobjarray_isa
  isFolder = xform0 c_tobjarray_isfolder
  isEqual = xform1 c_tobjarray_isequal
  isSortable = xform0 c_tobjarray_issortable
  paint = xform1 c_tobjarray_paint
  printObj = xform1 c_tobjarray_printobj
  recursiveRemove = xform1 c_tobjarray_recursiveremove
  saveAs = xform2 c_tobjarray_saveas
  useCurrentStyle = xform0 c_tobjarray_usecurrentstyle
  write = xform3 c_tobjarray_write
instance IDeletable TObjArray where
  delete = xform0 c_tobjarray_delete

instance ITObjArray (Exist TObjArray) where

instance ITSeqCollection (Exist TObjArray) where

instance ITCollection (Exist TObjArray) where

instance ITObject (Exist TObjArray) where
  draw (ETObjArray x) = draw x
  findObject (ETObjArray x) = findObject x
  getName (ETObjArray x) = getName x
  isA (ETObjArray x) = isA x
  isFolder (ETObjArray x) = isFolder x
  isEqual (ETObjArray x) = isEqual x
  isSortable (ETObjArray x) = isSortable x
  paint (ETObjArray x) = paint x
  printObj (ETObjArray x) = printObj x
  recursiveRemove (ETObjArray x) = recursiveRemove x
  saveAs (ETObjArray x) = saveAs x
  useCurrentStyle (ETObjArray x) = useCurrentStyle x
  write (ETObjArray x) = write x
instance IDeletable (Exist TObjArray) where
  delete (ETObjArray x) = delete x





instance FPtr (Exist TObjArray) where
  type Raw (Exist TObjArray) = RawTObjArray
  get_fptr (ETObjArray obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETObjArray (cast_fptr_to_obj (fptr :: ForeignPtr RawTObjArray) :: TObjArray)
