{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TPad.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TPad.RawType
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTPad.h"

foreign import ccall "HROOTTPad.h TPad_cd" c_tpad_cd 
  :: (Ptr RawTPad) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTPad.h TPad_GetFrame" c_tpad_getframe 
  :: (Ptr RawTPad) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTPad.h TPad_Modified" c_tpad_modified 
  :: (Ptr RawTPad) -> CInt -> IO ()
foreign import ccall "HROOTTPad.h TPad_Range" c_tpad_range 
  :: (Ptr RawTPad) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_Draw" c_tpad_draw 
  :: (Ptr RawTPad) -> CString -> IO ()
foreign import ccall "HROOTTPad.h TPad_FindObject" c_tpad_findobject 
  :: (Ptr RawTPad) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTPad.h TPad_GetName" c_tpad_getname 
  :: (Ptr RawTPad) -> IO CString
foreign import ccall "HROOTTPad.h TPad_IsA" c_tpad_isa 
  :: (Ptr RawTPad) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTPad.h TPad_IsFolder" c_tpad_isfolder 
  :: (Ptr RawTPad) -> IO CInt
foreign import ccall "HROOTTPad.h TPad_IsEqual" c_tpad_isequal 
  :: (Ptr RawTPad) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTPad.h TPad_IsSortable" c_tpad_issortable 
  :: (Ptr RawTPad) -> IO CInt
foreign import ccall "HROOTTPad.h TPad_Paint" c_tpad_paint 
  :: (Ptr RawTPad) -> CString -> IO ()
foreign import ccall "HROOTTPad.h TPad_printObj" c_tpad_printobj 
  :: (Ptr RawTPad) -> CString -> IO ()
foreign import ccall "HROOTTPad.h TPad_RecursiveRemove" c_tpad_recursiveremove 
  :: (Ptr RawTPad) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTPad.h TPad_SaveAs" c_tpad_saveas 
  :: (Ptr RawTPad) -> CString -> CString -> IO ()
foreign import ccall "HROOTTPad.h TPad_UseCurrentStyle" c_tpad_usecurrentstyle 
  :: (Ptr RawTPad) -> IO ()
foreign import ccall "HROOTTPad.h TPad_Write" c_tpad_write 
  :: (Ptr RawTPad) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTPad.h TPad_GetLineColor" c_tpad_getlinecolor 
  :: (Ptr RawTPad) -> IO CInt
foreign import ccall "HROOTTPad.h TPad_GetLineStyle" c_tpad_getlinestyle 
  :: (Ptr RawTPad) -> IO CInt
foreign import ccall "HROOTTPad.h TPad_GetLineWidth" c_tpad_getlinewidth 
  :: (Ptr RawTPad) -> IO CInt
foreign import ccall "HROOTTPad.h TPad_ResetAttLine" c_tpad_resetattline 
  :: (Ptr RawTPad) -> CString -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetLineAttributes" c_tpad_setlineattributes 
  :: (Ptr RawTPad) -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetLineColor" c_tpad_setlinecolor 
  :: (Ptr RawTPad) -> CInt -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetLineStyle" c_tpad_setlinestyle 
  :: (Ptr RawTPad) -> CInt -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetLineWidth" c_tpad_setlinewidth 
  :: (Ptr RawTPad) -> CInt -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetFillColor" c_tpad_setfillcolor 
  :: (Ptr RawTPad) -> CInt -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetFillStyle" c_tpad_setfillstyle 
  :: (Ptr RawTPad) -> CInt -> IO ()
foreign import ccall "HROOTTPad.h TPad_ResetAttPad" c_tpad_resetattpad 
  :: (Ptr RawTPad) -> CString -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetBottomMargin" c_tpad_setbottommargin 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetLeftMargin" c_tpad_setleftmargin 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetRightMargin" c_tpad_setrightmargin 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetTopMargin" c_tpad_settopmargin 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetMargin" c_tpad_setmargin 
  :: (Ptr RawTPad) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetAfile" c_tpad_setafile 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetXfile" c_tpad_setxfile 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetYfile" c_tpad_setyfile 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetAstat" c_tpad_setastat 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetXstat" c_tpad_setxstat 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_SetYstat" c_tpad_setystat 
  :: (Ptr RawTPad) -> CDouble -> IO ()
foreign import ccall "HROOTTPad.h TPad_delete" c_tpad_delete 
  :: (Ptr RawTPad) -> IO ()

