{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TPad.Implementation where


import HROOT.TypeCast

import HROOT.Class.TPad.RawType
import HROOT.Class.TPad.FFI
import HROOT.Class.TPad.Interface
import HROOT.Class.TPad.Cast
import HROOT.Class.TFrame.RawType
import HROOT.Class.TFrame.Cast
import HROOT.Class.TFrame.Interface
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TVirtualPad.Cast
import HROOT.Class.TVirtualPad.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttPad.RawType
import HROOT.Class.TAttPad.Cast
import HROOT.Class.TAttPad.Interface
import HROOT.Class.TQObject.RawType
import HROOT.Class.TQObject.Cast
import HROOT.Class.TQObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITPad TPad where
instance ITVirtualPad TPad where
  cd = xform1 c_tpad_cd
  getFrame = xform0 c_tpad_getframe
  modified = xform1 c_tpad_modified
  range = xform4 c_tpad_range
instance ITObject TPad where
  draw = xform1 c_tpad_draw
  findObject = xform1 c_tpad_findobject
  getName = xform0 c_tpad_getname
  isA = xform0 c_tpad_isa
  isFolder = xform0 c_tpad_isfolder
  isEqual = xform1 c_tpad_isequal
  isSortable = xform0 c_tpad_issortable
  paint = xform1 c_tpad_paint
  printObj = xform1 c_tpad_printobj
  recursiveRemove = xform1 c_tpad_recursiveremove
  saveAs = xform2 c_tpad_saveas
  useCurrentStyle = xform0 c_tpad_usecurrentstyle
  write = xform3 c_tpad_write
instance ITAttLine TPad where
  getLineColor = xform0 c_tpad_getlinecolor
  getLineStyle = xform0 c_tpad_getlinestyle
  getLineWidth = xform0 c_tpad_getlinewidth
  resetAttLine = xform1 c_tpad_resetattline
  setLineAttributes = xform0 c_tpad_setlineattributes
  setLineColor = xform1 c_tpad_setlinecolor
  setLineStyle = xform1 c_tpad_setlinestyle
  setLineWidth = xform1 c_tpad_setlinewidth
instance ITAttFill TPad where
  setFillColor = xform1 c_tpad_setfillcolor
  setFillStyle = xform1 c_tpad_setfillstyle
instance ITAttPad TPad where
  resetAttPad = xform1 c_tpad_resetattpad
  setBottomMargin = xform1 c_tpad_setbottommargin
  setLeftMargin = xform1 c_tpad_setleftmargin
  setRightMargin = xform1 c_tpad_setrightmargin
  setTopMargin = xform1 c_tpad_settopmargin
  setMargin = xform4 c_tpad_setmargin
  setAfile = xform1 c_tpad_setafile
  setXfile = xform1 c_tpad_setxfile
  setYfile = xform1 c_tpad_setyfile
  setAstat = xform1 c_tpad_setastat
  setXstat = xform1 c_tpad_setxstat
  setYstat = xform1 c_tpad_setystat
instance ITQObject TPad where
instance IDeletable TPad where
  delete = xform0 c_tpad_delete

instance ITPad (Exist TPad) where

instance ITVirtualPad (Exist TPad) where
  cd (ETPad x) = cd x
  getFrame (ETPad x) = getFrame x
  modified (ETPad x) = modified x
  range (ETPad x) = range x
instance ITObject (Exist TPad) where
  draw (ETPad x) = draw x
  findObject (ETPad x) = findObject x
  getName (ETPad x) = getName x
  isA (ETPad x) = isA x
  isFolder (ETPad x) = isFolder x
  isEqual (ETPad x) = isEqual x
  isSortable (ETPad x) = isSortable x
  paint (ETPad x) = paint x
  printObj (ETPad x) = printObj x
  recursiveRemove (ETPad x) = recursiveRemove x
  saveAs (ETPad x) = saveAs x
  useCurrentStyle (ETPad x) = useCurrentStyle x
  write (ETPad x) = write x
instance ITAttLine (Exist TPad) where
  getLineColor (ETPad x) = getLineColor x
  getLineStyle (ETPad x) = getLineStyle x
  getLineWidth (ETPad x) = getLineWidth x
  resetAttLine (ETPad x) = resetAttLine x
  setLineAttributes (ETPad x) = setLineAttributes x
  setLineColor (ETPad x) = setLineColor x
  setLineStyle (ETPad x) = setLineStyle x
  setLineWidth (ETPad x) = setLineWidth x
instance ITAttFill (Exist TPad) where
  setFillColor (ETPad x) = setFillColor x
  setFillStyle (ETPad x) = setFillStyle x
instance ITAttPad (Exist TPad) where
  resetAttPad (ETPad x) = resetAttPad x
  setBottomMargin (ETPad x) = setBottomMargin x
  setLeftMargin (ETPad x) = setLeftMargin x
  setRightMargin (ETPad x) = setRightMargin x
  setTopMargin (ETPad x) = setTopMargin x
  setMargin (ETPad x) = setMargin x
  setAfile (ETPad x) = setAfile x
  setXfile (ETPad x) = setXfile x
  setYfile (ETPad x) = setYfile x
  setAstat (ETPad x) = setAstat x
  setXstat (ETPad x) = setXstat x
  setYstat (ETPad x) = setYstat x
instance ITQObject (Exist TPad) where

instance IDeletable (Exist TPad) where
  delete (ETPad x) = delete x





instance FPtr (Exist TPad) where
  type Raw (Exist TPad) = RawTPad
  get_fptr (ETPad obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPad (cast_fptr_to_obj (fptr :: ForeignPtr RawTPad) :: TPad)
