{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TPave.Implementation where


import HROOT.TypeCast

import HROOT.Class.TPave.RawType
import HROOT.Class.TPave.FFI
import HROOT.Class.TPave.Interface
import HROOT.Class.TPave.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TBox.RawType
import HROOT.Class.TBox.Cast
import HROOT.Class.TBox.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITPave TPave where
instance ITBox TPave where
instance ITObject TPave where
  draw = xform1 c_tpave_draw
  findObject = xform1 c_tpave_findobject
  getName = xform0 c_tpave_getname
  isA = xform0 c_tpave_isa
  isFolder = xform0 c_tpave_isfolder
  isEqual = xform1 c_tpave_isequal
  isSortable = xform0 c_tpave_issortable
  paint = xform1 c_tpave_paint
  printObj = xform1 c_tpave_printobj
  recursiveRemove = xform1 c_tpave_recursiveremove
  saveAs = xform2 c_tpave_saveas
  useCurrentStyle = xform0 c_tpave_usecurrentstyle
  write = xform3 c_tpave_write
instance ITAttLine TPave where
  getLineColor = xform0 c_tpave_getlinecolor
  getLineStyle = xform0 c_tpave_getlinestyle
  getLineWidth = xform0 c_tpave_getlinewidth
  resetAttLine = xform1 c_tpave_resetattline
  setLineAttributes = xform0 c_tpave_setlineattributes
  setLineColor = xform1 c_tpave_setlinecolor
  setLineStyle = xform1 c_tpave_setlinestyle
  setLineWidth = xform1 c_tpave_setlinewidth
instance ITAttFill TPave where
  setFillColor = xform1 c_tpave_setfillcolor
  setFillStyle = xform1 c_tpave_setfillstyle
instance IDeletable TPave where
  delete = xform0 c_tpave_delete

instance ITPave (Exist TPave) where

instance ITBox (Exist TPave) where

instance ITObject (Exist TPave) where
  draw (ETPave x) = draw x
  findObject (ETPave x) = findObject x
  getName (ETPave x) = getName x
  isA (ETPave x) = isA x
  isFolder (ETPave x) = isFolder x
  isEqual (ETPave x) = isEqual x
  isSortable (ETPave x) = isSortable x
  paint (ETPave x) = paint x
  printObj (ETPave x) = printObj x
  recursiveRemove (ETPave x) = recursiveRemove x
  saveAs (ETPave x) = saveAs x
  useCurrentStyle (ETPave x) = useCurrentStyle x
  write (ETPave x) = write x
instance ITAttLine (Exist TPave) where
  getLineColor (ETPave x) = getLineColor x
  getLineStyle (ETPave x) = getLineStyle x
  getLineWidth (ETPave x) = getLineWidth x
  resetAttLine (ETPave x) = resetAttLine x
  setLineAttributes (ETPave x) = setLineAttributes x
  setLineColor (ETPave x) = setLineColor x
  setLineStyle (ETPave x) = setLineStyle x
  setLineWidth (ETPave x) = setLineWidth x
instance ITAttFill (Exist TPave) where
  setFillColor (ETPave x) = setFillColor x
  setFillStyle (ETPave x) = setFillStyle x
instance IDeletable (Exist TPave) where
  delete (ETPave x) = delete x


newTPave :: Double -> Double -> Double -> Double -> Int -> String -> IO TPave
newTPave = xform5 c_tpave_newtpave



instance FPtr (Exist TPave) where
  type Raw (Exist TPave) = RawTPave
  get_fptr (ETPave obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPave (cast_fptr_to_obj (fptr :: ForeignPtr RawTPave) :: TPave)
