{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TPaveLabel.Implementation where


import HROOT.TypeCast

import HROOT.Class.TPaveLabel.RawType
import HROOT.Class.TPaveLabel.FFI
import HROOT.Class.TPaveLabel.Interface
import HROOT.Class.TPaveLabel.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TPave.RawType
import HROOT.Class.TPave.Cast
import HROOT.Class.TPave.Interface
import HROOT.Class.TAttText.RawType
import HROOT.Class.TAttText.Cast
import HROOT.Class.TAttText.Interface
import HROOT.Class.TBox.RawType
import HROOT.Class.TBox.Cast
import HROOT.Class.TBox.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITPaveLabel TPaveLabel where
instance ITPave TPaveLabel where
instance ITAttText TPaveLabel where
  getTextAlign = xform0 c_tpavelabel_gettextalign
  getTextAngle = xform0 c_tpavelabel_gettextangle
  getTextColor = xform0 c_tpavelabel_gettextcolor
  getTextFont = xform0 c_tpavelabel_gettextfont
  getTextSize = xform0 c_tpavelabel_gettextsize
  resetAttText = xform1 c_tpavelabel_resetatttext
  setTextAttributes = xform0 c_tpavelabel_settextattributes
  setTextAlign = xform1 c_tpavelabel_settextalign
  setTextAngle = xform1 c_tpavelabel_settextangle
  setTextColor = xform1 c_tpavelabel_settextcolor
  setTextFont = xform1 c_tpavelabel_settextfont
  setTextSize = xform1 c_tpavelabel_settextsize
  setTextSizePixels = xform1 c_tpavelabel_settextsizepixels
instance ITBox TPaveLabel where
instance ITObject TPaveLabel where
  draw = xform1 c_tpavelabel_draw
  findObject = xform1 c_tpavelabel_findobject
  getName = xform0 c_tpavelabel_getname
  isA = xform0 c_tpavelabel_isa
  isFolder = xform0 c_tpavelabel_isfolder
  isEqual = xform1 c_tpavelabel_isequal
  isSortable = xform0 c_tpavelabel_issortable
  paint = xform1 c_tpavelabel_paint
  printObj = xform1 c_tpavelabel_printobj
  recursiveRemove = xform1 c_tpavelabel_recursiveremove
  saveAs = xform2 c_tpavelabel_saveas
  useCurrentStyle = xform0 c_tpavelabel_usecurrentstyle
  write = xform3 c_tpavelabel_write
instance ITAttLine TPaveLabel where
  getLineColor = xform0 c_tpavelabel_getlinecolor
  getLineStyle = xform0 c_tpavelabel_getlinestyle
  getLineWidth = xform0 c_tpavelabel_getlinewidth
  resetAttLine = xform1 c_tpavelabel_resetattline
  setLineAttributes = xform0 c_tpavelabel_setlineattributes
  setLineColor = xform1 c_tpavelabel_setlinecolor
  setLineStyle = xform1 c_tpavelabel_setlinestyle
  setLineWidth = xform1 c_tpavelabel_setlinewidth
instance ITAttFill TPaveLabel where
  setFillColor = xform1 c_tpavelabel_setfillcolor
  setFillStyle = xform1 c_tpavelabel_setfillstyle
instance IDeletable TPaveLabel where
  delete = xform0 c_tpavelabel_delete

instance ITPaveLabel (Exist TPaveLabel) where

instance ITPave (Exist TPaveLabel) where

instance ITAttText (Exist TPaveLabel) where
  getTextAlign (ETPaveLabel x) = getTextAlign x
  getTextAngle (ETPaveLabel x) = getTextAngle x
  getTextColor (ETPaveLabel x) = getTextColor x
  getTextFont (ETPaveLabel x) = getTextFont x
  getTextSize (ETPaveLabel x) = getTextSize x
  resetAttText (ETPaveLabel x) = resetAttText x
  setTextAttributes (ETPaveLabel x) = setTextAttributes x
  setTextAlign (ETPaveLabel x) = setTextAlign x
  setTextAngle (ETPaveLabel x) = setTextAngle x
  setTextColor (ETPaveLabel x) = setTextColor x
  setTextFont (ETPaveLabel x) = setTextFont x
  setTextSize (ETPaveLabel x) = setTextSize x
  setTextSizePixels (ETPaveLabel x) = setTextSizePixels x
instance ITBox (Exist TPaveLabel) where

instance ITObject (Exist TPaveLabel) where
  draw (ETPaveLabel x) = draw x
  findObject (ETPaveLabel x) = findObject x
  getName (ETPaveLabel x) = getName x
  isA (ETPaveLabel x) = isA x
  isFolder (ETPaveLabel x) = isFolder x
  isEqual (ETPaveLabel x) = isEqual x
  isSortable (ETPaveLabel x) = isSortable x
  paint (ETPaveLabel x) = paint x
  printObj (ETPaveLabel x) = printObj x
  recursiveRemove (ETPaveLabel x) = recursiveRemove x
  saveAs (ETPaveLabel x) = saveAs x
  useCurrentStyle (ETPaveLabel x) = useCurrentStyle x
  write (ETPaveLabel x) = write x
instance ITAttLine (Exist TPaveLabel) where
  getLineColor (ETPaveLabel x) = getLineColor x
  getLineStyle (ETPaveLabel x) = getLineStyle x
  getLineWidth (ETPaveLabel x) = getLineWidth x
  resetAttLine (ETPaveLabel x) = resetAttLine x
  setLineAttributes (ETPaveLabel x) = setLineAttributes x
  setLineColor (ETPaveLabel x) = setLineColor x
  setLineStyle (ETPaveLabel x) = setLineStyle x
  setLineWidth (ETPaveLabel x) = setLineWidth x
instance ITAttFill (Exist TPaveLabel) where
  setFillColor (ETPaveLabel x) = setFillColor x
  setFillStyle (ETPaveLabel x) = setFillStyle x
instance IDeletable (Exist TPaveLabel) where
  delete (ETPaveLabel x) = delete x


newTPaveLabel :: Double -> Double -> Double -> Double -> String -> String -> IO TPaveLabel
newTPaveLabel = xform5 c_tpavelabel_newtpavelabel



instance FPtr (Exist TPaveLabel) where
  type Raw (Exist TPaveLabel) = RawTPaveLabel
  get_fptr (ETPaveLabel obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPaveLabel (cast_fptr_to_obj (fptr :: ForeignPtr RawTPaveLabel) :: TPaveLabel)
