{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TRandom.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TRandom.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTRandom.h"

foreign import ccall "HROOTTRandom.h TRandom_SetName" c_trandom_setname 
  :: (Ptr RawTRandom) -> CString -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_SetNameTitle" c_trandom_setnametitle 
  :: (Ptr RawTRandom) -> CString -> CString -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_SetTitle" c_trandom_settitle 
  :: (Ptr RawTRandom) -> CString -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_Draw" c_trandom_draw 
  :: (Ptr RawTRandom) -> CString -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_FindObject" c_trandom_findobject 
  :: (Ptr RawTRandom) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTRandom.h TRandom_GetName" c_trandom_getname 
  :: (Ptr RawTRandom) -> IO CString
foreign import ccall "HROOTTRandom.h TRandom_IsA" c_trandom_isa 
  :: (Ptr RawTRandom) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTRandom.h TRandom_IsFolder" c_trandom_isfolder 
  :: (Ptr RawTRandom) -> IO CInt
foreign import ccall "HROOTTRandom.h TRandom_IsEqual" c_trandom_isequal 
  :: (Ptr RawTRandom) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTRandom.h TRandom_IsSortable" c_trandom_issortable 
  :: (Ptr RawTRandom) -> IO CInt
foreign import ccall "HROOTTRandom.h TRandom_Paint" c_trandom_paint 
  :: (Ptr RawTRandom) -> CString -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_printObj" c_trandom_printobj 
  :: (Ptr RawTRandom) -> CString -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_RecursiveRemove" c_trandom_recursiveremove 
  :: (Ptr RawTRandom) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_SaveAs" c_trandom_saveas 
  :: (Ptr RawTRandom) -> CString -> CString -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_UseCurrentStyle" c_trandom_usecurrentstyle 
  :: (Ptr RawTRandom) -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_Write" c_trandom_write 
  :: (Ptr RawTRandom) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTRandom.h TRandom_delete" c_trandom_delete 
  :: (Ptr RawTRandom) -> IO ()
foreign import ccall "HROOTTRandom.h TRandom_newTRandom" c_trandom_newtrandom 
  :: CInt -> IO (Ptr RawTRandom)
foreign import ccall "HROOTTRandom.h TRandom_Gaus" c_trandom_gaus 
  :: (Ptr RawTRandom) -> CDouble -> CDouble -> IO CDouble
foreign import ccall "HROOTTRandom.h TRandom_Uniform" c_trandom_uniform 
  :: (Ptr RawTRandom) -> CDouble -> CDouble -> IO CDouble

