{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TShape.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TShape.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTShape.h"

foreign import ccall "HROOTTShape.h TShape_SetName" c_tshape_setname 
  :: (Ptr RawTShape) -> CString -> IO ()
foreign import ccall "HROOTTShape.h TShape_SetNameTitle" c_tshape_setnametitle 
  :: (Ptr RawTShape) -> CString -> CString -> IO ()
foreign import ccall "HROOTTShape.h TShape_SetTitle" c_tshape_settitle 
  :: (Ptr RawTShape) -> CString -> IO ()
foreign import ccall "HROOTTShape.h TShape_GetLineColor" c_tshape_getlinecolor 
  :: (Ptr RawTShape) -> IO CInt
foreign import ccall "HROOTTShape.h TShape_GetLineStyle" c_tshape_getlinestyle 
  :: (Ptr RawTShape) -> IO CInt
foreign import ccall "HROOTTShape.h TShape_GetLineWidth" c_tshape_getlinewidth 
  :: (Ptr RawTShape) -> IO CInt
foreign import ccall "HROOTTShape.h TShape_ResetAttLine" c_tshape_resetattline 
  :: (Ptr RawTShape) -> CString -> IO ()
foreign import ccall "HROOTTShape.h TShape_SetLineAttributes" c_tshape_setlineattributes 
  :: (Ptr RawTShape) -> IO ()
foreign import ccall "HROOTTShape.h TShape_SetLineColor" c_tshape_setlinecolor 
  :: (Ptr RawTShape) -> CInt -> IO ()
foreign import ccall "HROOTTShape.h TShape_SetLineStyle" c_tshape_setlinestyle 
  :: (Ptr RawTShape) -> CInt -> IO ()
foreign import ccall "HROOTTShape.h TShape_SetLineWidth" c_tshape_setlinewidth 
  :: (Ptr RawTShape) -> CInt -> IO ()
foreign import ccall "HROOTTShape.h TShape_SetFillColor" c_tshape_setfillcolor 
  :: (Ptr RawTShape) -> CInt -> IO ()
foreign import ccall "HROOTTShape.h TShape_SetFillStyle" c_tshape_setfillstyle 
  :: (Ptr RawTShape) -> CInt -> IO ()
foreign import ccall "HROOTTShape.h TShape_Draw" c_tshape_draw 
  :: (Ptr RawTShape) -> CString -> IO ()
foreign import ccall "HROOTTShape.h TShape_FindObject" c_tshape_findobject 
  :: (Ptr RawTShape) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTShape.h TShape_GetName" c_tshape_getname 
  :: (Ptr RawTShape) -> IO CString
foreign import ccall "HROOTTShape.h TShape_IsA" c_tshape_isa 
  :: (Ptr RawTShape) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTShape.h TShape_IsFolder" c_tshape_isfolder 
  :: (Ptr RawTShape) -> IO CInt
foreign import ccall "HROOTTShape.h TShape_IsEqual" c_tshape_isequal 
  :: (Ptr RawTShape) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTShape.h TShape_IsSortable" c_tshape_issortable 
  :: (Ptr RawTShape) -> IO CInt
foreign import ccall "HROOTTShape.h TShape_Paint" c_tshape_paint 
  :: (Ptr RawTShape) -> CString -> IO ()
foreign import ccall "HROOTTShape.h TShape_printObj" c_tshape_printobj 
  :: (Ptr RawTShape) -> CString -> IO ()
foreign import ccall "HROOTTShape.h TShape_RecursiveRemove" c_tshape_recursiveremove 
  :: (Ptr RawTShape) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTShape.h TShape_SaveAs" c_tshape_saveas 
  :: (Ptr RawTShape) -> CString -> CString -> IO ()
foreign import ccall "HROOTTShape.h TShape_UseCurrentStyle" c_tshape_usecurrentstyle 
  :: (Ptr RawTShape) -> IO ()
foreign import ccall "HROOTTShape.h TShape_Write" c_tshape_write 
  :: (Ptr RawTShape) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTShape.h TShape_delete" c_tshape_delete 
  :: (Ptr RawTShape) -> IO ()
foreign import ccall "HROOTTShape.h TShape_newTShape" c_tshape_newtshape 
  :: CString -> CString -> CString -> IO (Ptr RawTShape)

