{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TSlider.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TSlider.RawType
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TFrame.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTSlider.h"

foreign import ccall "HROOTTSlider.h TSlider_cd" c_tslider_cd 
  :: (Ptr RawTSlider) -> CInt -> IO (Ptr RawTVirtualPad)
foreign import ccall "HROOTTSlider.h TSlider_GetFrame" c_tslider_getframe 
  :: (Ptr RawTSlider) -> IO (Ptr RawTFrame)
foreign import ccall "HROOTTSlider.h TSlider_Modified" c_tslider_modified 
  :: (Ptr RawTSlider) -> CInt -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_Range" c_tslider_range 
  :: (Ptr RawTSlider) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_Draw" c_tslider_draw 
  :: (Ptr RawTSlider) -> CString -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_FindObject" c_tslider_findobject 
  :: (Ptr RawTSlider) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTSlider.h TSlider_GetName" c_tslider_getname 
  :: (Ptr RawTSlider) -> IO CString
foreign import ccall "HROOTTSlider.h TSlider_IsA" c_tslider_isa 
  :: (Ptr RawTSlider) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTSlider.h TSlider_IsFolder" c_tslider_isfolder 
  :: (Ptr RawTSlider) -> IO CInt
foreign import ccall "HROOTTSlider.h TSlider_IsEqual" c_tslider_isequal 
  :: (Ptr RawTSlider) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTSlider.h TSlider_IsSortable" c_tslider_issortable 
  :: (Ptr RawTSlider) -> IO CInt
foreign import ccall "HROOTTSlider.h TSlider_Paint" c_tslider_paint 
  :: (Ptr RawTSlider) -> CString -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_printObj" c_tslider_printobj 
  :: (Ptr RawTSlider) -> CString -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_RecursiveRemove" c_tslider_recursiveremove 
  :: (Ptr RawTSlider) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SaveAs" c_tslider_saveas 
  :: (Ptr RawTSlider) -> CString -> CString -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_UseCurrentStyle" c_tslider_usecurrentstyle 
  :: (Ptr RawTSlider) -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_Write" c_tslider_write 
  :: (Ptr RawTSlider) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTSlider.h TSlider_GetLineColor" c_tslider_getlinecolor 
  :: (Ptr RawTSlider) -> IO CInt
foreign import ccall "HROOTTSlider.h TSlider_GetLineStyle" c_tslider_getlinestyle 
  :: (Ptr RawTSlider) -> IO CInt
foreign import ccall "HROOTTSlider.h TSlider_GetLineWidth" c_tslider_getlinewidth 
  :: (Ptr RawTSlider) -> IO CInt
foreign import ccall "HROOTTSlider.h TSlider_ResetAttLine" c_tslider_resetattline 
  :: (Ptr RawTSlider) -> CString -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetLineAttributes" c_tslider_setlineattributes 
  :: (Ptr RawTSlider) -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetLineColor" c_tslider_setlinecolor 
  :: (Ptr RawTSlider) -> CInt -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetLineStyle" c_tslider_setlinestyle 
  :: (Ptr RawTSlider) -> CInt -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetLineWidth" c_tslider_setlinewidth 
  :: (Ptr RawTSlider) -> CInt -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetFillColor" c_tslider_setfillcolor 
  :: (Ptr RawTSlider) -> CInt -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetFillStyle" c_tslider_setfillstyle 
  :: (Ptr RawTSlider) -> CInt -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_ResetAttPad" c_tslider_resetattpad 
  :: (Ptr RawTSlider) -> CString -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetBottomMargin" c_tslider_setbottommargin 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetLeftMargin" c_tslider_setleftmargin 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetRightMargin" c_tslider_setrightmargin 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetTopMargin" c_tslider_settopmargin 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetMargin" c_tslider_setmargin 
  :: (Ptr RawTSlider) -> CDouble -> CDouble -> CDouble -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetAfile" c_tslider_setafile 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetXfile" c_tslider_setxfile 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetYfile" c_tslider_setyfile 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetAstat" c_tslider_setastat 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetXstat" c_tslider_setxstat 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_SetYstat" c_tslider_setystat 
  :: (Ptr RawTSlider) -> CDouble -> IO ()
foreign import ccall "HROOTTSlider.h TSlider_delete" c_tslider_delete 
  :: (Ptr RawTSlider) -> IO ()

