{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TSlider.Implementation where


import HROOT.TypeCast

import HROOT.Class.TSlider.RawType
import HROOT.Class.TSlider.FFI
import HROOT.Class.TSlider.Interface
import HROOT.Class.TSlider.Cast
import HROOT.Class.TFrame.RawType
import HROOT.Class.TFrame.Cast
import HROOT.Class.TFrame.Interface
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TPad.RawType
import HROOT.Class.TPad.Cast
import HROOT.Class.TPad.Interface
import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TVirtualPad.Cast
import HROOT.Class.TVirtualPad.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttPad.RawType
import HROOT.Class.TAttPad.Cast
import HROOT.Class.TAttPad.Interface
import HROOT.Class.TQObject.RawType
import HROOT.Class.TQObject.Cast
import HROOT.Class.TQObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITSlider TSlider where
instance ITPad TSlider where
instance ITVirtualPad TSlider where
  cd = xform1 c_tslider_cd
  getFrame = xform0 c_tslider_getframe
  modified = xform1 c_tslider_modified
  range = xform4 c_tslider_range
instance ITObject TSlider where
  draw = xform1 c_tslider_draw
  findObject = xform1 c_tslider_findobject
  getName = xform0 c_tslider_getname
  isA = xform0 c_tslider_isa
  isFolder = xform0 c_tslider_isfolder
  isEqual = xform1 c_tslider_isequal
  isSortable = xform0 c_tslider_issortable
  paint = xform1 c_tslider_paint
  printObj = xform1 c_tslider_printobj
  recursiveRemove = xform1 c_tslider_recursiveremove
  saveAs = xform2 c_tslider_saveas
  useCurrentStyle = xform0 c_tslider_usecurrentstyle
  write = xform3 c_tslider_write
instance ITAttLine TSlider where
  getLineColor = xform0 c_tslider_getlinecolor
  getLineStyle = xform0 c_tslider_getlinestyle
  getLineWidth = xform0 c_tslider_getlinewidth
  resetAttLine = xform1 c_tslider_resetattline
  setLineAttributes = xform0 c_tslider_setlineattributes
  setLineColor = xform1 c_tslider_setlinecolor
  setLineStyle = xform1 c_tslider_setlinestyle
  setLineWidth = xform1 c_tslider_setlinewidth
instance ITAttFill TSlider where
  setFillColor = xform1 c_tslider_setfillcolor
  setFillStyle = xform1 c_tslider_setfillstyle
instance ITAttPad TSlider where
  resetAttPad = xform1 c_tslider_resetattpad
  setBottomMargin = xform1 c_tslider_setbottommargin
  setLeftMargin = xform1 c_tslider_setleftmargin
  setRightMargin = xform1 c_tslider_setrightmargin
  setTopMargin = xform1 c_tslider_settopmargin
  setMargin = xform4 c_tslider_setmargin
  setAfile = xform1 c_tslider_setafile
  setXfile = xform1 c_tslider_setxfile
  setYfile = xform1 c_tslider_setyfile
  setAstat = xform1 c_tslider_setastat
  setXstat = xform1 c_tslider_setxstat
  setYstat = xform1 c_tslider_setystat
instance ITQObject TSlider where
instance IDeletable TSlider where
  delete = xform0 c_tslider_delete

instance ITSlider (Exist TSlider) where

instance ITPad (Exist TSlider) where

instance ITVirtualPad (Exist TSlider) where
  cd (ETSlider x) = cd x
  getFrame (ETSlider x) = getFrame x
  modified (ETSlider x) = modified x
  range (ETSlider x) = range x
instance ITObject (Exist TSlider) where
  draw (ETSlider x) = draw x
  findObject (ETSlider x) = findObject x
  getName (ETSlider x) = getName x
  isA (ETSlider x) = isA x
  isFolder (ETSlider x) = isFolder x
  isEqual (ETSlider x) = isEqual x
  isSortable (ETSlider x) = isSortable x
  paint (ETSlider x) = paint x
  printObj (ETSlider x) = printObj x
  recursiveRemove (ETSlider x) = recursiveRemove x
  saveAs (ETSlider x) = saveAs x
  useCurrentStyle (ETSlider x) = useCurrentStyle x
  write (ETSlider x) = write x
instance ITAttLine (Exist TSlider) where
  getLineColor (ETSlider x) = getLineColor x
  getLineStyle (ETSlider x) = getLineStyle x
  getLineWidth (ETSlider x) = getLineWidth x
  resetAttLine (ETSlider x) = resetAttLine x
  setLineAttributes (ETSlider x) = setLineAttributes x
  setLineColor (ETSlider x) = setLineColor x
  setLineStyle (ETSlider x) = setLineStyle x
  setLineWidth (ETSlider x) = setLineWidth x
instance ITAttFill (Exist TSlider) where
  setFillColor (ETSlider x) = setFillColor x
  setFillStyle (ETSlider x) = setFillStyle x
instance ITAttPad (Exist TSlider) where
  resetAttPad (ETSlider x) = resetAttPad x
  setBottomMargin (ETSlider x) = setBottomMargin x
  setLeftMargin (ETSlider x) = setLeftMargin x
  setRightMargin (ETSlider x) = setRightMargin x
  setTopMargin (ETSlider x) = setTopMargin x
  setMargin (ETSlider x) = setMargin x
  setAfile (ETSlider x) = setAfile x
  setXfile (ETSlider x) = setXfile x
  setYfile (ETSlider x) = setYfile x
  setAstat (ETSlider x) = setAstat x
  setXstat (ETSlider x) = setXstat x
  setYstat (ETSlider x) = setYstat x
instance ITQObject (Exist TSlider) where

instance IDeletable (Exist TSlider) where
  delete (ETSlider x) = delete x





instance FPtr (Exist TSlider) where
  type Raw (Exist TSlider) = RawTSlider
  get_fptr (ETSlider obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETSlider (cast_fptr_to_obj (fptr :: ForeignPtr RawTSlider) :: TSlider)
