{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TTree.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TTree.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TClass.RawType

#include "HROOTTTree.h"

foreign import ccall "HROOTTTree.h TTree_SetName" c_ttree_setname 
  :: (Ptr RawTTree) -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetNameTitle" c_ttree_setnametitle 
  :: (Ptr RawTTree) -> CString -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetTitle" c_ttree_settitle 
  :: (Ptr RawTTree) -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_GetLineColor" c_ttree_getlinecolor 
  :: (Ptr RawTTree) -> IO CInt
foreign import ccall "HROOTTTree.h TTree_GetLineStyle" c_ttree_getlinestyle 
  :: (Ptr RawTTree) -> IO CInt
foreign import ccall "HROOTTTree.h TTree_GetLineWidth" c_ttree_getlinewidth 
  :: (Ptr RawTTree) -> IO CInt
foreign import ccall "HROOTTTree.h TTree_ResetAttLine" c_ttree_resetattline 
  :: (Ptr RawTTree) -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetLineAttributes" c_ttree_setlineattributes 
  :: (Ptr RawTTree) -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetLineColor" c_ttree_setlinecolor 
  :: (Ptr RawTTree) -> CInt -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetLineStyle" c_ttree_setlinestyle 
  :: (Ptr RawTTree) -> CInt -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetLineWidth" c_ttree_setlinewidth 
  :: (Ptr RawTTree) -> CInt -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetFillColor" c_ttree_setfillcolor 
  :: (Ptr RawTTree) -> CInt -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetFillStyle" c_ttree_setfillstyle 
  :: (Ptr RawTTree) -> CInt -> IO ()
foreign import ccall "HROOTTTree.h TTree_GetMarkerColor" c_ttree_getmarkercolor 
  :: (Ptr RawTTree) -> IO CInt
foreign import ccall "HROOTTTree.h TTree_GetMarkerStyle" c_ttree_getmarkerstyle 
  :: (Ptr RawTTree) -> IO CInt
foreign import ccall "HROOTTTree.h TTree_GetMarkerSize" c_ttree_getmarkersize 
  :: (Ptr RawTTree) -> IO CDouble
foreign import ccall "HROOTTTree.h TTree_ResetAttMarker" c_ttree_resetattmarker 
  :: (Ptr RawTTree) -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetMarkerAttributes" c_ttree_setmarkerattributes 
  :: (Ptr RawTTree) -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetMarkerColor" c_ttree_setmarkercolor 
  :: (Ptr RawTTree) -> CInt -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetMarkerStyle" c_ttree_setmarkerstyle 
  :: (Ptr RawTTree) -> CInt -> IO ()
foreign import ccall "HROOTTTree.h TTree_SetMarkerSize" c_ttree_setmarkersize 
  :: (Ptr RawTTree) -> CInt -> IO ()
foreign import ccall "HROOTTTree.h TTree_Draw" c_ttree_draw 
  :: (Ptr RawTTree) -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_FindObject" c_ttree_findobject 
  :: (Ptr RawTTree) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTTree.h TTree_GetName" c_ttree_getname 
  :: (Ptr RawTTree) -> IO CString
foreign import ccall "HROOTTTree.h TTree_IsA" c_ttree_isa 
  :: (Ptr RawTTree) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTTree.h TTree_IsFolder" c_ttree_isfolder 
  :: (Ptr RawTTree) -> IO CInt
foreign import ccall "HROOTTTree.h TTree_IsEqual" c_ttree_isequal 
  :: (Ptr RawTTree) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTTree.h TTree_IsSortable" c_ttree_issortable 
  :: (Ptr RawTTree) -> IO CInt
foreign import ccall "HROOTTTree.h TTree_Paint" c_ttree_paint 
  :: (Ptr RawTTree) -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_printObj" c_ttree_printobj 
  :: (Ptr RawTTree) -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_RecursiveRemove" c_ttree_recursiveremove 
  :: (Ptr RawTTree) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTTree.h TTree_SaveAs" c_ttree_saveas 
  :: (Ptr RawTTree) -> CString -> CString -> IO ()
foreign import ccall "HROOTTTree.h TTree_UseCurrentStyle" c_ttree_usecurrentstyle 
  :: (Ptr RawTTree) -> IO ()
foreign import ccall "HROOTTTree.h TTree_Write" c_ttree_write 
  :: (Ptr RawTTree) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTTree.h TTree_delete" c_ttree_delete 
  :: (Ptr RawTTree) -> IO ()
foreign import ccall "HROOTTTree.h TTree_newTTree" c_ttree_newttree 
  :: CString -> CString -> CInt -> IO (Ptr RawTTree)

