{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TTreeSQL.Implementation where


import HROOT.TypeCast

import HROOT.Class.TTreeSQL.RawType
import HROOT.Class.TTreeSQL.FFI
import HROOT.Class.TTreeSQL.Interface
import HROOT.Class.TTreeSQL.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TTree.RawType
import HROOT.Class.TTree.Cast
import HROOT.Class.TTree.Interface
import HROOT.Class.TNamed.RawType
import HROOT.Class.TNamed.Cast
import HROOT.Class.TNamed.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttMarker.RawType
import HROOT.Class.TAttMarker.Cast
import HROOT.Class.TAttMarker.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITTreeSQL TTreeSQL where
instance ITTree TTreeSQL where
instance ITNamed TTreeSQL where
  setName = xform1 c_ttreesql_setname
  setNameTitle = xform2 c_ttreesql_setnametitle
  setTitle = xform1 c_ttreesql_settitle
instance ITAttLine TTreeSQL where
  getLineColor = xform0 c_ttreesql_getlinecolor
  getLineStyle = xform0 c_ttreesql_getlinestyle
  getLineWidth = xform0 c_ttreesql_getlinewidth
  resetAttLine = xform1 c_ttreesql_resetattline
  setLineAttributes = xform0 c_ttreesql_setlineattributes
  setLineColor = xform1 c_ttreesql_setlinecolor
  setLineStyle = xform1 c_ttreesql_setlinestyle
  setLineWidth = xform1 c_ttreesql_setlinewidth
instance ITAttFill TTreeSQL where
  setFillColor = xform1 c_ttreesql_setfillcolor
  setFillStyle = xform1 c_ttreesql_setfillstyle
instance ITAttMarker TTreeSQL where
  getMarkerColor = xform0 c_ttreesql_getmarkercolor
  getMarkerStyle = xform0 c_ttreesql_getmarkerstyle
  getMarkerSize = xform0 c_ttreesql_getmarkersize
  resetAttMarker = xform1 c_ttreesql_resetattmarker
  setMarkerAttributes = xform0 c_ttreesql_setmarkerattributes
  setMarkerColor = xform1 c_ttreesql_setmarkercolor
  setMarkerStyle = xform1 c_ttreesql_setmarkerstyle
  setMarkerSize = xform1 c_ttreesql_setmarkersize
instance ITObject TTreeSQL where
  draw = xform1 c_ttreesql_draw
  findObject = xform1 c_ttreesql_findobject
  getName = xform0 c_ttreesql_getname
  isA = xform0 c_ttreesql_isa
  isFolder = xform0 c_ttreesql_isfolder
  isEqual = xform1 c_ttreesql_isequal
  isSortable = xform0 c_ttreesql_issortable
  paint = xform1 c_ttreesql_paint
  printObj = xform1 c_ttreesql_printobj
  recursiveRemove = xform1 c_ttreesql_recursiveremove
  saveAs = xform2 c_ttreesql_saveas
  useCurrentStyle = xform0 c_ttreesql_usecurrentstyle
  write = xform3 c_ttreesql_write
instance IDeletable TTreeSQL where
  delete = xform0 c_ttreesql_delete

instance ITTreeSQL (Exist TTreeSQL) where

instance ITTree (Exist TTreeSQL) where

instance ITNamed (Exist TTreeSQL) where
  setName (ETTreeSQL x) = setName x
  setNameTitle (ETTreeSQL x) = setNameTitle x
  setTitle (ETTreeSQL x) = setTitle x
instance ITAttLine (Exist TTreeSQL) where
  getLineColor (ETTreeSQL x) = getLineColor x
  getLineStyle (ETTreeSQL x) = getLineStyle x
  getLineWidth (ETTreeSQL x) = getLineWidth x
  resetAttLine (ETTreeSQL x) = resetAttLine x
  setLineAttributes (ETTreeSQL x) = setLineAttributes x
  setLineColor (ETTreeSQL x) = setLineColor x
  setLineStyle (ETTreeSQL x) = setLineStyle x
  setLineWidth (ETTreeSQL x) = setLineWidth x
instance ITAttFill (Exist TTreeSQL) where
  setFillColor (ETTreeSQL x) = setFillColor x
  setFillStyle (ETTreeSQL x) = setFillStyle x
instance ITAttMarker (Exist TTreeSQL) where
  getMarkerColor (ETTreeSQL x) = getMarkerColor x
  getMarkerStyle (ETTreeSQL x) = getMarkerStyle x
  getMarkerSize (ETTreeSQL x) = getMarkerSize x
  resetAttMarker (ETTreeSQL x) = resetAttMarker x
  setMarkerAttributes (ETTreeSQL x) = setMarkerAttributes x
  setMarkerColor (ETTreeSQL x) = setMarkerColor x
  setMarkerStyle (ETTreeSQL x) = setMarkerStyle x
  setMarkerSize (ETTreeSQL x) = setMarkerSize x
instance ITObject (Exist TTreeSQL) where
  draw (ETTreeSQL x) = draw x
  findObject (ETTreeSQL x) = findObject x
  getName (ETTreeSQL x) = getName x
  isA (ETTreeSQL x) = isA x
  isFolder (ETTreeSQL x) = isFolder x
  isEqual (ETTreeSQL x) = isEqual x
  isSortable (ETTreeSQL x) = isSortable x
  paint (ETTreeSQL x) = paint x
  printObj (ETTreeSQL x) = printObj x
  recursiveRemove (ETTreeSQL x) = recursiveRemove x
  saveAs (ETTreeSQL x) = saveAs x
  useCurrentStyle (ETTreeSQL x) = useCurrentStyle x
  write (ETTreeSQL x) = write x
instance IDeletable (Exist TTreeSQL) where
  delete (ETTreeSQL x) = delete x





instance FPtr (Exist TTreeSQL) where
  type Raw (Exist TTreeSQL) = RawTTreeSQL
  get_fptr (ETTreeSQL obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETTreeSQL (cast_fptr_to_obj (fptr :: ForeignPtr RawTTreeSQL) :: TTreeSQL)
