{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TVirtualPad.Implementation where


import HROOT.TypeCast

import HROOT.Class.TVirtualPad.RawType
import HROOT.Class.TVirtualPad.FFI
import HROOT.Class.TVirtualPad.Interface
import HROOT.Class.TVirtualPad.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TFrame.RawType
import HROOT.Class.TFrame.Cast
import HROOT.Class.TFrame.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.TAttPad.RawType
import HROOT.Class.TAttPad.Cast
import HROOT.Class.TAttPad.Interface
import HROOT.Class.TQObject.RawType
import HROOT.Class.TQObject.Cast
import HROOT.Class.TQObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITVirtualPad TVirtualPad where
  cd = xform1 c_tvirtualpad_cd
  getFrame = xform0 c_tvirtualpad_getframe
  modified = xform1 c_tvirtualpad_modified
  range = xform4 c_tvirtualpad_range
instance ITObject TVirtualPad where
  draw = xform1 c_tvirtualpad_draw
  findObject = xform1 c_tvirtualpad_findobject
  getName = xform0 c_tvirtualpad_getname
  isA = xform0 c_tvirtualpad_isa
  isFolder = xform0 c_tvirtualpad_isfolder
  isEqual = xform1 c_tvirtualpad_isequal
  isSortable = xform0 c_tvirtualpad_issortable
  paint = xform1 c_tvirtualpad_paint
  printObj = xform1 c_tvirtualpad_printobj
  recursiveRemove = xform1 c_tvirtualpad_recursiveremove
  saveAs = xform2 c_tvirtualpad_saveas
  useCurrentStyle = xform0 c_tvirtualpad_usecurrentstyle
  write = xform3 c_tvirtualpad_write
instance ITAttLine TVirtualPad where
  getLineColor = xform0 c_tvirtualpad_getlinecolor
  getLineStyle = xform0 c_tvirtualpad_getlinestyle
  getLineWidth = xform0 c_tvirtualpad_getlinewidth
  resetAttLine = xform1 c_tvirtualpad_resetattline
  setLineAttributes = xform0 c_tvirtualpad_setlineattributes
  setLineColor = xform1 c_tvirtualpad_setlinecolor
  setLineStyle = xform1 c_tvirtualpad_setlinestyle
  setLineWidth = xform1 c_tvirtualpad_setlinewidth
instance ITAttFill TVirtualPad where
  setFillColor = xform1 c_tvirtualpad_setfillcolor
  setFillStyle = xform1 c_tvirtualpad_setfillstyle
instance ITAttPad TVirtualPad where
  resetAttPad = xform1 c_tvirtualpad_resetattpad
  setBottomMargin = xform1 c_tvirtualpad_setbottommargin
  setLeftMargin = xform1 c_tvirtualpad_setleftmargin
  setRightMargin = xform1 c_tvirtualpad_setrightmargin
  setTopMargin = xform1 c_tvirtualpad_settopmargin
  setMargin = xform4 c_tvirtualpad_setmargin
  setAfile = xform1 c_tvirtualpad_setafile
  setXfile = xform1 c_tvirtualpad_setxfile
  setYfile = xform1 c_tvirtualpad_setyfile
  setAstat = xform1 c_tvirtualpad_setastat
  setXstat = xform1 c_tvirtualpad_setxstat
  setYstat = xform1 c_tvirtualpad_setystat
instance ITQObject TVirtualPad where
instance IDeletable TVirtualPad where
  delete = xform0 c_tvirtualpad_delete

instance ITVirtualPad (Exist TVirtualPad) where
  cd (ETVirtualPad x) = cd x
  getFrame (ETVirtualPad x) = getFrame x
  modified (ETVirtualPad x) = modified x
  range (ETVirtualPad x) = range x
instance ITObject (Exist TVirtualPad) where
  draw (ETVirtualPad x) = draw x
  findObject (ETVirtualPad x) = findObject x
  getName (ETVirtualPad x) = getName x
  isA (ETVirtualPad x) = isA x
  isFolder (ETVirtualPad x) = isFolder x
  isEqual (ETVirtualPad x) = isEqual x
  isSortable (ETVirtualPad x) = isSortable x
  paint (ETVirtualPad x) = paint x
  printObj (ETVirtualPad x) = printObj x
  recursiveRemove (ETVirtualPad x) = recursiveRemove x
  saveAs (ETVirtualPad x) = saveAs x
  useCurrentStyle (ETVirtualPad x) = useCurrentStyle x
  write (ETVirtualPad x) = write x
instance ITAttLine (Exist TVirtualPad) where
  getLineColor (ETVirtualPad x) = getLineColor x
  getLineStyle (ETVirtualPad x) = getLineStyle x
  getLineWidth (ETVirtualPad x) = getLineWidth x
  resetAttLine (ETVirtualPad x) = resetAttLine x
  setLineAttributes (ETVirtualPad x) = setLineAttributes x
  setLineColor (ETVirtualPad x) = setLineColor x
  setLineStyle (ETVirtualPad x) = setLineStyle x
  setLineWidth (ETVirtualPad x) = setLineWidth x
instance ITAttFill (Exist TVirtualPad) where
  setFillColor (ETVirtualPad x) = setFillColor x
  setFillStyle (ETVirtualPad x) = setFillStyle x
instance ITAttPad (Exist TVirtualPad) where
  resetAttPad (ETVirtualPad x) = resetAttPad x
  setBottomMargin (ETVirtualPad x) = setBottomMargin x
  setLeftMargin (ETVirtualPad x) = setLeftMargin x
  setRightMargin (ETVirtualPad x) = setRightMargin x
  setTopMargin (ETVirtualPad x) = setTopMargin x
  setMargin (ETVirtualPad x) = setMargin x
  setAfile (ETVirtualPad x) = setAfile x
  setXfile (ETVirtualPad x) = setXfile x
  setYfile (ETVirtualPad x) = setYfile x
  setAstat (ETVirtualPad x) = setAstat x
  setXstat (ETVirtualPad x) = setXstat x
  setYstat (ETVirtualPad x) = setYstat x
instance ITQObject (Exist TVirtualPad) where

instance IDeletable (Exist TVirtualPad) where
  delete (ETVirtualPad x) = delete x





instance FPtr (Exist TVirtualPad) where
  type Raw (Exist TVirtualPad) = RawTVirtualPad
  get_fptr (ETVirtualPad obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETVirtualPad (cast_fptr_to_obj (fptr :: ForeignPtr RawTVirtualPad) :: TVirtualPad)
