{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TVirtualTreePlayer.Implementation where


import HROOT.TypeCast

import HROOT.Class.TVirtualTreePlayer.RawType
import HROOT.Class.TVirtualTreePlayer.FFI
import HROOT.Class.TVirtualTreePlayer.Interface
import HROOT.Class.TVirtualTreePlayer.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITVirtualTreePlayer TVirtualTreePlayer where
instance ITObject TVirtualTreePlayer where
  draw = xform1 c_tvirtualtreeplayer_draw
  findObject = xform1 c_tvirtualtreeplayer_findobject
  getName = xform0 c_tvirtualtreeplayer_getname
  isA = xform0 c_tvirtualtreeplayer_isa
  isFolder = xform0 c_tvirtualtreeplayer_isfolder
  isEqual = xform1 c_tvirtualtreeplayer_isequal
  isSortable = xform0 c_tvirtualtreeplayer_issortable
  paint = xform1 c_tvirtualtreeplayer_paint
  printObj = xform1 c_tvirtualtreeplayer_printobj
  recursiveRemove = xform1 c_tvirtualtreeplayer_recursiveremove
  saveAs = xform2 c_tvirtualtreeplayer_saveas
  useCurrentStyle = xform0 c_tvirtualtreeplayer_usecurrentstyle
  write = xform3 c_tvirtualtreeplayer_write
instance IDeletable TVirtualTreePlayer where
  delete = xform0 c_tvirtualtreeplayer_delete

instance ITVirtualTreePlayer (Exist TVirtualTreePlayer) where

instance ITObject (Exist TVirtualTreePlayer) where
  draw (ETVirtualTreePlayer x) = draw x
  findObject (ETVirtualTreePlayer x) = findObject x
  getName (ETVirtualTreePlayer x) = getName x
  isA (ETVirtualTreePlayer x) = isA x
  isFolder (ETVirtualTreePlayer x) = isFolder x
  isEqual (ETVirtualTreePlayer x) = isEqual x
  isSortable (ETVirtualTreePlayer x) = isSortable x
  paint (ETVirtualTreePlayer x) = paint x
  printObj (ETVirtualTreePlayer x) = printObj x
  recursiveRemove (ETVirtualTreePlayer x) = recursiveRemove x
  saveAs (ETVirtualTreePlayer x) = saveAs x
  useCurrentStyle (ETVirtualTreePlayer x) = useCurrentStyle x
  write (ETVirtualTreePlayer x) = write x
instance IDeletable (Exist TVirtualTreePlayer) where
  delete (ETVirtualTreePlayer x) = delete x





instance FPtr (Exist TVirtualTreePlayer) where
  type Raw (Exist TVirtualTreePlayer) = RawTVirtualTreePlayer
  get_fptr (ETVirtualTreePlayer obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETVirtualTreePlayer (cast_fptr_to_obj (fptr :: ForeignPtr RawTVirtualTreePlayer) :: TVirtualTreePlayer)
