{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Class.TWbox.Implementation where


import HROOT.TypeCast

import HROOT.Class.TWbox.RawType
import HROOT.Class.TWbox.FFI
import HROOT.Class.TWbox.Interface
import HROOT.Class.TWbox.Cast
import HROOT.Class.TClass.RawType
import HROOT.Class.TClass.Cast
import HROOT.Class.TClass.Interface
import HROOT.Class.TBox.RawType
import HROOT.Class.TBox.Cast
import HROOT.Class.TBox.Interface
import HROOT.Class.TObject.RawType
import HROOT.Class.TObject.Cast
import HROOT.Class.TObject.Interface
import HROOT.Class.TAttLine.RawType
import HROOT.Class.TAttLine.Cast
import HROOT.Class.TAttLine.Interface
import HROOT.Class.TAttFill.RawType
import HROOT.Class.TAttFill.Cast
import HROOT.Class.TAttFill.Interface
import HROOT.Class.Deletable.RawType
import HROOT.Class.Deletable.Cast
import HROOT.Class.Deletable.Interface

import Data.Word
-- import Foreign.C            
-- import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITWbox TWbox where
  setBorderMode = xform1 c_twbox_setbordermode
instance ITBox TWbox where
instance ITObject TWbox where
  draw = xform1 c_twbox_draw
  findObject = xform1 c_twbox_findobject
  getName = xform0 c_twbox_getname
  isA = xform0 c_twbox_isa
  isFolder = xform0 c_twbox_isfolder
  isEqual = xform1 c_twbox_isequal
  isSortable = xform0 c_twbox_issortable
  paint = xform1 c_twbox_paint
  printObj = xform1 c_twbox_printobj
  recursiveRemove = xform1 c_twbox_recursiveremove
  saveAs = xform2 c_twbox_saveas
  useCurrentStyle = xform0 c_twbox_usecurrentstyle
  write = xform3 c_twbox_write
instance ITAttLine TWbox where
  getLineColor = xform0 c_twbox_getlinecolor
  getLineStyle = xform0 c_twbox_getlinestyle
  getLineWidth = xform0 c_twbox_getlinewidth
  resetAttLine = xform1 c_twbox_resetattline
  setLineAttributes = xform0 c_twbox_setlineattributes
  setLineColor = xform1 c_twbox_setlinecolor
  setLineStyle = xform1 c_twbox_setlinestyle
  setLineWidth = xform1 c_twbox_setlinewidth
instance ITAttFill TWbox where
  setFillColor = xform1 c_twbox_setfillcolor
  setFillStyle = xform1 c_twbox_setfillstyle
instance IDeletable TWbox where
  delete = xform0 c_twbox_delete

instance ITWbox (Exist TWbox) where
  setBorderMode (ETWbox x) = setBorderMode x
instance ITBox (Exist TWbox) where

instance ITObject (Exist TWbox) where
  draw (ETWbox x) = draw x
  findObject (ETWbox x) = findObject x
  getName (ETWbox x) = getName x
  isA (ETWbox x) = isA x
  isFolder (ETWbox x) = isFolder x
  isEqual (ETWbox x) = isEqual x
  isSortable (ETWbox x) = isSortable x
  paint (ETWbox x) = paint x
  printObj (ETWbox x) = printObj x
  recursiveRemove (ETWbox x) = recursiveRemove x
  saveAs (ETWbox x) = saveAs x
  useCurrentStyle (ETWbox x) = useCurrentStyle x
  write (ETWbox x) = write x
instance ITAttLine (Exist TWbox) where
  getLineColor (ETWbox x) = getLineColor x
  getLineStyle (ETWbox x) = getLineStyle x
  getLineWidth (ETWbox x) = getLineWidth x
  resetAttLine (ETWbox x) = resetAttLine x
  setLineAttributes (ETWbox x) = setLineAttributes x
  setLineColor (ETWbox x) = setLineColor x
  setLineStyle (ETWbox x) = setLineStyle x
  setLineWidth (ETWbox x) = setLineWidth x
instance ITAttFill (Exist TWbox) where
  setFillColor (ETWbox x) = setFillColor x
  setFillStyle (ETWbox x) = setFillStyle x
instance IDeletable (Exist TWbox) where
  delete (ETWbox x) = delete x


newTWbox :: Double -> Double -> Double -> Double -> Int -> Int -> Int -> IO TWbox
newTWbox = xform6 c_twbox_newtwbox



instance FPtr (Exist TWbox) where
  type Raw (Exist TWbox) = RawTWbox
  get_fptr (ETWbox obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETWbox (cast_fptr_to_obj (fptr :: ForeignPtr RawTWbox) :: TWbox)
